var app = angular.module( 'uiApp', [
		'ngRoute',
		'ngCookies',
        'ngIdle',
        'ngSpectrum',
		'login',
		'ChartAngular',
		'configure', 'configAppliances', 'configAssets', 'configCopiedAssets',
		'jobs',
		'reports',
		'constants',
        'help',
	    'options',
		'protect',
		'recover',
		'quickStartWizard',
		'mgo-angular-wizard',
		'recover',
        'dynamicdashboardapp',
		'archiveSummaryWidgetModule',
		'backupSummaryWidgetModule',
		'activeJobWidgetModule',
		'topForumPostsWidgetModule',
        "storageWidgetModule",
		"alertWidgetModule",
		'dailyFeedWidgetModule',
		'ngSanitize',
        'nsPopover',
        'angulartics',
        'angulartics.google.analytics',
        'tour-module',
		'retention',
        'replicationThrottleScheduleModule',
        'backupCopyOptionDialogModule',
        'cifsStorage',
        'nfsStorage',
        'iscsiStorage',
        'fcStorage',
        'credentials',
        'asset_service',
        'cisco_ucs_service',
        'add_server',
        'add_cisco_ucs',
        'edit_server',
		'backupPhysicalModule',
 		'ngJsTree',
 	    'fileBrowserDialogApp',
        'manage-appliance',
        'treeGrid',
		'backupCopyWidgetWidgetModule',
        'RecoverTileModule',
        'windowRecoveryModule',
        'editNonManagedResourceApplianceModule',
        'backupCopyStorageWidgetModule',
	    'recoveryModule',
        'fileLevelRecoveryModule',
        'backupJobModule',
        'inventory',
        'searchFLRModule',
        'backupCopyTargetModule',
        'multipleErrorsController',
        'backupCopyMedia',
        'updates',
        'hypervisor_ctrl',
		'addEditNasModule',
        'advanced-toolbox',
        'active-directory-module',
        'os-password-module',
        'iscsi-chap-module',
        'advanced-settings-module',
        'advanced-hosts-module',
        'advanced-ports-module',
        'network-module',
        'advanced-snmp-module',
        'groups-module'
]);

app.factory('Page', ['$cookieStore','$rootScope', function($cookieStore,$rootScope){
    var title = 'Unitrends UI';
    return {
        title: function() {
           if($rootScope.user.eulaWizardFlag){
                return "Unitrends End User License Agreement";
            }else if($rootScope.user.showSetupWizFlag){
                return "Unitrends QuickSetup Wizard";
            }else{
                return location.host + ' - ' + title;
            }
        },
        setTitle: function(newTitle, update_cookies) {
            if (update_cookies === undefined || update_cookies === true) {
                $cookieStore.put('Page', newTitle);
            }
            title = newTitle;
        }
    };
}]);

/*
modal dialog for alert
*/
app.directive('alertDialog', function () {
    return {
        restrict: 'E',
        scope: {
            show: '='
        },
        replace: true, // Replace with the template below
        transclude: true, // we want to insert custom content inside the directive
        link: function (scope, element, attrs) {
            scope.dialogStyle = {};
            if (attrs.width)
                scope.dialogStyle.width = attrs.width;
            if (attrs.height)
                scope.dialogStyle.height = attrs.height;
            scope.hideModal = function () {
                scope.show = false;
            };
        },
        template: "<div class='ng-modal' ng-show='show'><div class='ng-alertmodeldialog-dialog' ng-style='dialogStyle'><div class='ng-alertmodeldialog-dialog-content' ng-transclude></div></div></div>"
    };
});
app.factory('dataToBeShared', function(){
    return { objectList:undefined };
});


/*
 * Items controlled at the global level.
 */
app.controller('GlobalCtrl', ['$scope', '$rootScope', '$window', '$location', '$cookieStore', '$http', 'Page', 'Idle', 'ngDialog', 'Title', '$timeout',
		function($scope, $rootScope, $window, $location, $cookieStore, $http, Page, Idle, ngDialog, Title, $timeout) {
	
	$scope.Page = Page;
	
	/*open and close dailog*/
	$scope.modalShown = false;

    $scope.toggleModal = function() {
        if($scope.modalShown == true)
        {
            $('.ng-alertmodeldialog-dialog').css("display","none");
            $scope.modalShown = !$scope.modalShown;
            $timeout(function() {
                $scope.$apply(function() {
                    $("#id-alerts-menu").removeClass("open");
                    $("#id-alerts-menu").blur();
                });
            }, 0);
        }
        else
        { $('.ng-alertmodeldialog-dialog').css("display","block");
            $scope.modalShown = !$scope.modalShown;
        }
    };

	// user name should be passed from login
	$rootScope.backupTimer=10000;
    $rootScope.maintenance_mode = false;
    $rootScope.saveTimers = [];
    $rootScope.saveJobTimer = 0;
    $rootScope.saveJobTimer = 0;

    $rootScope.local = {};
    $rootScope.local.id = localID;
    $rootScope.local.name = localName;

    // Default job history to max of 250 records
    // This could be persisted if desired, but the concern is that the more jobs the more chance to overload the DataTable.
    $rootScope.jobHistoryLimit = 250;
    $rootScope.jobHistoryLimitHit = "";

    // Default audit history to max of 250 records
    $rootScope.systemJobHistoryLimit = 250;
    $rootScope.systemJobHistoryLimitHit = "";

    // See if the user is logged in.
    var $cookie = {};
    $cookie.username = $cookieStore.get("username");
    $cookie.uid = $cookieStore.get("uid");
    $cookie.password = $cookieStore.get("password");
    $cookie.token = $cookieStore.get("token");
    $cookie.superuser = $cookieStore.get("superuser");
    $cookie.administrator = $cookieStore.get("administrator");

    if ($cookie.token !== undefined && $cookie.username !== undefined) {
        $scope.user = {};
        $scope.user.loggedIn = true;
        $scope.user.name = $cookie.username;
        $scope.user.id = $cookie.uid;
        $scope.user.token = $cookie.token;
        $scope.user.superuser = $cookie.superuser;
        $scope.user.administrator = $cookie.administrator;
        $http.defaults.headers.common['AuthToken'] = $scope.user.token;
    } else {
        $scope.user = {};
        $scope.user.name = '';
        $scope.user.id = '';
        $scope.user.loggedIn = false;
        $scope.user.token = '';
        $scope.user.superuser = false;
        $scope.user.administrator = false;
    }

	// set preferences for user, refresh rates, get user id.
	// track whether or not they have seen the tour (tour_activated)
	// track whether or not the eula is accepted (sula_accepted)
	// track the timezone: (timezone = 'US/Eastern')
	// track username, first and last name, email, active_user
	// is_superuser, is_staff?
	// date_user_created
	// tz string for timezone (tz='-0400')
	
	$rootScope.user = $scope.user;
    global_user = $rootScope.user;

    // Platform-specifics
    $rootScope.isCE = isCE == 1;                // Unitrends Free
    $rootScope.isGoogle = isGoogle == 1;        // Unitrends Free Google Edition
    $rootScope.isVirtual = isVirtual == 1;      // A virtual appliance (UEB, Unitrends Free, Unitrends Free Google Edition)
    $rootScope.isTarget = isTarget == 1;        // Is this appliance a target?
    $rootScope.isUEB = $rootScope.isVirtual && !$rootScope.isCE && !$rootScope.isGoogle;    // UEB
    $rootScope.isXenUEB = isXenUEB == 1;        // XenUEB?
    $rootScope.isRecoverySeries = !$rootScope.isVirtual;    // Recovery Series Hardware Appliance
    $rootScope.assetTag = assetTag;                 // appliance Asset Tag
    $rootScope.identity = identity;                 //Identity of appliance
    $rootScope.featureString = featureString;       //featurestring of appliance

    // Some preferences are global.
    $rootScope.globalPreference = {};
    $rootScope.globalPreference.showSetupWizard = showWizard;
    $rootScope.globalPreference.showEULA = showEULA;
    $rootScope.globalPreference.showTour = showTour;


    /*
     * Set rootScope variable to track view of backup catalog filter (defaults to "show").
     */
    $rootScope.showCatalogFilter = true;

	$scope.user.logout = function() {

        var userout = {};
        userout.cookie = $scope.user.token;
        /*
         * Turn off the idle timer, if set
         */
        Idle.unwatch();

        $http.post('/api/logout', userout)
            .success(function(data, status, headers) {
                $scope.logoutUser();
            })
            .error(function(data, status, headers) {
                // Tap into PHD.throwError function here.
                // No need to display this.  There is nothing a user can do.  Log to the console and if logins fail, the user will see the errors.
                //window.PHD.throwError(data);
                if (data != undefined && data.result != undefined && data.result[0] != undefined && data.result[0].message != undefined) {
                    console.log("user.logout: error, message = " + data.result[0].message);
                }
                $scope.logoutUser();
            })
	};

    $(document).on("session-expired", function(event) {
        $scope.user.logout();
    });

    $scope.logoutUser = function() {
        // Send an event on logout.
        var e = $.Event('logout');
        $(document).trigger(e);

        // remove cookies if present.
        $cookieStore.remove('username');
        $cookieStore.remove('password');
        $cookieStore.remove('uid');
        $cookieStore.remove('superuser');
        $cookieStore.remove('administrator');
        $cookieStore.remove('remember_me');
        $cookieStore.put('autologin', false);

        $scope.user.loggedIn = false;
        $rootScope.user.loggedIn = false;
        $rootScope.user.token = '';
        $cookieStore.remove('token');

        // force reload on logout to clean up Timers.
        $window.location.href = "#";
        $window.location.reload();
    };
	
	$scope.credentials = {
		username: '',
		password: ''
	};

	$rootScope.setIfDefined = function(obj, widget, variable, value) {
		if (typeof value !== 'undefined') {
            rate = value * 1000;
			obj[variable] = rate;
            $(document).trigger("userpreferencesave." + widget, [variable, rate]);
		}
	};
	
	$scope.bodyIsReady = function() {
		// Send an event to the jQuery listeners on login.
		console.log('body is ready');
	};

    /*
     * Idle timeout handling.  Set the timer on login, based on CMC Timeout value.  Turn on the timer with "watch()".
     * On logout, turn off the timer with "unwatch()".
     *  When Idle Start is reached, issue a warning.
     *  When Idle timeout is reached, log out
     *  If the user clicks or moves the mouse in the app (IdleEnd), remove the warning dialog.
     */
    $scope.$on('IdleStart', function() {
        console.log("Idle Start, show Warning");
        ngDialog.open({
            dialogType:'warning',
            dialogMessage: "This session will soon timeout due to inactivity unless you click 'OK' or move your mouse in this window.",
            modelDialogId: 'idle-timeout-dialog',
            scope: $scope,
            onConfirmOkButtonClick:'onConfirmIdle()'
        });
    });

    $scope.onConfirmIdle = function() {
        $timeout(function() {
            Title.value(Page.title());
        }, 0);
        ngDialog.close('idle-timeout-dialog');
    };

    $scope.$on('IdleEnd', function() {
        $scope.onConfirmIdle();
    });

    $scope.$on('IdleTimeout', function() {
        console.log("Idle Timeout, logout");
        $scope.onConfirmIdle();
        $scope.user.logout();
    });

    //
    // Provides a common validation function for nested dialogs.  The caller must provide the below <div> in the $form
    //
    //  <div id="nested-dialog-errors"><p class="summary error"></p><ul id="nested-dialog-error-list" class="errorlist"></ul></div>
    //
    $rootScope.validateNestedDialog = function($form, options) {
        var wrapper = "#nested-dialog-error-list";
        var errors = "#nested-dialog-errors";
        var dialogDefaults = {
            errorLabelContainer: wrapper,
            errorContainer: errors,
            showErrors: function (errorMap, errorList) {
                $(errors).find(".summary")
                    .html(gettext("Correct the following errors:"));
                this.defaultShowErrors();
            }
        };
        options = jQuery.extend(options, dialogDefaults);
        return $form.validate(options);
    };
}]);

/*
 * Items controlled at the global level.
 */
app.controller('AppCtrl', ['getPreferencesFactory', 'getClientFactory', 'getStorageFactory', '$scope', '$rootScope', '$location', '$cookieStore', '$route', '$http', '$timeout', 'Page', 'ngDialog', 'Idle',
	function(getPreferencesFactory, getClientFactory, getStorageFactory, $scope, $rootScope, $location, $cookieStore, $route, $http, $timeout, Page, ngDialog, Idle) {

	 /*Event to handle preferences*/
	   $scope.$on("update-userPrefrence", function(event, widgetName,refreshKey) {
	 			var dataObj ={};
				var url = '/api/preferences/' + $rootScope.user.name + '/';
				var dropdownKey="#id_"+widgetName.toLowerCase()+"Refresh";
                var my_dropid= "id_"+widgetName.toLowerCase()+'Refresh';
                var dropdown_id= "[id='"+my_dropid+"']";
				dataObj[refreshKey]=$(dropdown_id).val();
		 		$http({
					   url: url, 
					   data: JSON.stringify(dataObj),
					   method: 'PUT'
					}).success(function(data, status, headers){
						console.log("success");
						console.log(data);
					}).error(function(response){
						console.log(response);
					}); 
	});
	
	/*
	Initializing the variable at rootScopeLevel to implement Timer and save userPreference for refresh rate
    * 1) Stores function need to be called to refresh data.
	* 2) Stores time period after refresh function need to be called
	* 3) Stores ID return by setInterval function
	* 4) Stores ID of refresh Icon
	* 5) Stores controller of Widgets
	* 6) Stores widget specific refreshKey for saving userPreference
	*/
	$rootScope.listOfFunction=["$rootScope.getBackupRefereshData","$rootScope.getActiveJobData",
                               "$rootScope.getStorageData","$rootScope.getAlertsRefereshData",
                               "$rootScope.getTopForumPosts","$rootScope.getDailyFeed",
                    "$rootScope.getBackupCopyRefereshData","$rootScope.getRecoverRefereshData","$rootScope.getBackupCopyStorageRefereshData","$rootScope.getBackupCopyTargetRefereshData"];
	$rootScope.listOfTimer=[0,0,0,0,0,0,0,0,0,0];
	$rootScope.listOfWidgetName=["Backup","Active Job","Storage","Alerts","Post","Daily Feed","Backup Copy","Recover Summary","Backup Copy Storage","Backup Copy Target"];
	$rootScope.listOfTimerFunction=["Backup","Active Job","Storage","Alerts","Post","Daily Feed","Backup Copy","Recover Summary","Backup Copy Storage","Backup Copy Target"];
	$rootScope.listOfID=["[id='IDBACKUP SUMMARY']","[id='IDACTIVE JOBS']","[id='IDSTORAGE']",
                         "[id='IDAlerts']","[id='IDCOMMUNITY']","[id='IDDAILY FEED']","[id='IDBACKUP COPY SUMMARY - UNITRENDS']","[id='IDRECOVER SUMMARY']","[id='IDBACKUP COPY SUMMARY-COLD STORAGE']","[id='IDBACKUP COPY - TARGET']"];
	$rootScope.listOfController=["[ng-controller=BackupWidgetContorller]","[ng-controller=ActiveJobsDashCtrl]",
                                 "[ng-controller=storageWidgetCtrl]","[ng-controller=AlertWidgetContorller]",
                                 "[ng-controller=TopForumPostsWidgetCtrl]","[ng-controller=DailyFeedWidgetController]",
                                "[ng-controller=backupCopyWidgetContorller]","[ng-controller=RecoverTileContorller]","[ng-controller=backupCopyWidgetStorageContorller]","[ng-controller=backupCopyTargetWidgetContorller]"];
	$rootScope.listOfRefreshKey=["dash_backup_refresh","dash_active_job_refresh","dash_storage_refresh",
                                 "dash_alert_refresh","dash_forum_posts_refresh","dash_daily_feed_refresh","dash_replication_refresh","dash_restore_refresh","dash_replication_refresh","dash_replication_refresh"];
    /* Timer for refresh of Jobs Page */
    $rootScope.JobsTimer = PHD.Timer({
        namespace: "jobspage",
        interval: 0,
        refreshControl: null
    });

    /* Timer for refresh of Protect Page */
    $rootScope.ProtectTimer = PHD.Timer({
        namespace: "protectpage",
        interval: 0,
        refreshControl: null
    });

    /* Timer for refresh of Protect Page */
    $rootScope.RecoverTimer = PHD.Timer({
        namespace: "recoverpage",
        interval: 0,
        refreshControl: null
    });

    $rootScope.disableTimers = function() {
        if (!$rootScope.maintenance_mode) {
            var nTimers = $rootScope.listOfTimer.length;
            $rootScope.saveTimers = $rootScope.listOfTimer;
            for (var i = 0; i < nTimers; i++) {
                $rootScope.listOfTimer[i] = 0;
                clearInterval($rootScope.listOfTimerFunction[i]);
            }
            $rootScope.saveJobTimer = $rootScope.JobsTimer.getInterval();
            $rootScope.saveProtectTimer = $rootScope.ProtectTimer.getInterval();
            $rootScope.saveRecoverTimer = $rootScope.RecoverTimer.getInterval();
            $rootScope.JobsTimer.setInterval(0);
            $rootScope.ProtectTimer.setInterval(0);
            $rootScope.RecoverTimer.setInterval(0);
            $rootScope.maintenance_mode = true;
        }
    };

    $rootScope.enableTimers = function() {
        var nSavedTimers = $rootScope.saveTimers.length;
        var nTimers = $rootScope.listOfTimer.length;
        $rootScope.listOfTimer = $rootScope.saveTimers;
        for (var i = 0; i < nTimers && i < nSavedTimers; i++) {
            $rootScope.listOfTimer[i] = 300 * 1000;
            $rootScope.listOfTimerFunction[i] = setInterval(eval($rootScope.listOfFunction[i]), $rootScope.listOfTimer[i]);
        }
        $rootScope.JobsTimer.setInterval($rootScope.saveJobTimer);
        $rootScope.ProtectTimer.setInterval($rootScope.saveProtectTimer);
        $rootScope.RecoverTimer.setInterval($rootScope.saveRecoverTimer);
        $rootScope.maintenance_mode = false;
    };
	
	/* function to hide/show manual refresh control for widget 
	 * and also refresh widget based on time selected by user
	 * Parameters : refresh_rate and Widget Name
    */
        $rootScope.manualRefreshControl  = function(refresh_rate,widgetName){
            var index = $rootScope.listOfWidgetName.indexOf(widgetName);
            var my_id =$rootScope.listOfID[index];
            var dropDownID='#id_' +widgetName.toLowerCase() +'Refresh';
            var my_dropid= "id_"+widgetName.toLowerCase()+'Refresh';
            var dropdown_id= "[id='"+my_dropid+"']";
           
            /*check for refresh rate , if it is zero we need to show manual refresh icon
             else we need to call function for updating Widget data using setInterval method,
             whereas on change of user Preference we need to clear previous timer Function
             */
            $(dropdown_id).val(refresh_rate); // set the value of dropDown with selected value
            if (refresh_rate == 0){
                $rootScope.listOfTimer[index]=refresh_rate;
                clearInterval($rootScope.listOfTimerFunction[index]);
                if(my_id === "[id='IDCOMMUNITY']" ||
                    my_id === "[id='IDDAILY FEED']" || 
                    my_id === "[id='IDACTIVE JOBS']" || 
                    my_id === "[id='IDSTORAGE']"){
                    $(my_id).css("display","inline-block");
                }
            } else {
                $(my_id).css("display","none");
                clearInterval($rootScope.listOfTimerFunction[index]);
                refresh_rate = refresh_rate * 1000;
                $rootScope.listOfTimer[index]=refresh_rate;
                $rootScope.listOfTimerFunction[index] = setInterval(eval($rootScope.listOfFunction[index]), $rootScope.listOfTimer[index]);
            }
        };
	
	/*save User Preference*/
	$rootScope.userPreferenceParentSave = function (widgetName) {
        var index = $rootScope.listOfWidgetName.indexOf(widgetName);
        var dropDownID='#id_' +widgetName.toLowerCase() +'Refresh';
        var my_dropid= "id_"+widgetName.toLowerCase()+'Refresh';
        var dropdown_id= "[id='"+my_dropid+"']";
        var refresh_rate= parseInt($(dropdown_id).val());
        var scope = $($rootScope.listOfController[index]).scope();
        scope.toggleModal();
        $rootScope.manualRefreshControl(refresh_rate,widgetName);
        $scope.$broadcast("update-userPrefrence", widgetName,$rootScope.listOfRefreshKey[index]);
	};

	// available languages
	$scope.languages = [
		{ code: 'en', language: 'English' },
		{ code: 'de', language: 'German' },
		{ code: 'ja', language: 'Japanese' }
	];
	// set default language, overriden by user preference.
	$scope.language = $scope.languages[0];
	// update the language on request, must use async in case a digest is in progress.
	$scope.$on("update-language", function(event, code) {
		for (var i = 0; i < $scope.languages.length; i++) {
			var lang = $scope.languages[i];
			if (lang.code === code) {
				$scope.$evalAsync(function() {
					$scope.language = lang;
				});
				break;
			}
		}
	});

	$scope.Page = Page;

        if(mktString !== ""){
            $scope.licenseType = mktString;
        }
        else{
            if(licenseClass === "PHY"){
                var line = licenseType;
                var Appliance,lineArray;
                if (strstr(line, "Unitrends DPU") && !( strstr(line, "VM-Hyper-V") ) && !( strstr(line, "VM-VMware") )) {
                    lineArray = split(" ", $line);
                    Appliance = lineArray[2];
                } else if (strstr(line, "Unitrends Recovery")) {
                    lineArray = split(" ", $line);
                    Appliance = lineArray[1];
                } else if (strstr(line, "Unitrends Small Form Factor")) {
                    lineArray = split(" ", $line);
                    Appliance = "SFF";
                } else if (strstr(line, "VM-Hyper-V")) {
                    Appliance = "Unitrends Enterprise Backup (Hyper-V)";
                } else if (strstr(line, "VM-VMware")) {
                    Appliance = "Unitrends Enterprise Backup (VMware)";
                }
                else{
                    Appliance = licenseType;
                }
                $scope.licenseType = Appliance;
            }
            else{
                var description = "";
                switch (licenseClass) {
                    case "UNREG":
                        description = "Unregistered";
                        break;
                    case "FREE":
                    case "CE":
                        description = "Free Edition";
                        break;
                    case "NFR":
                        description = "Not For Resale";
                        break;
                    case "TRIAL":
                        description = "Trial Edition";
                        break;
                    case "ENTRB":
                        //$description = "Enterprise Edition (per TB)";
                        description = "Enterprise Edition";
                        break;
                    case "ENTRR":
                        //$description = "Enterprise Edition (per Resource)";
                        description = "Enterprise Edition";
                        break;
                    case "PHY":
                        description = "Enterprise Edition with Physical Unit";
                        break;
                    default:
                        description = "No Description";
                        break;
                }
                $scope.licenseType = description;
            }
        }

        function strstr(input, string, bool) {  //Equivalent to strstr function in PHP
            var pos = 0;
            input += '';
            pos = input.indexOf(string);       //Index of "string" where it is found in "input"
            if (pos == -1) {
                return false;
            } else {
                if (bool) {
                    return input.substr(0, pos);    //if bool = true send substring from start of "input" to first occurrence of "string".
                } else {
                    return input.slice(pos);    //If bool = false return substring from "pos" to the end of "input"
                }
            }
        }

    // lmc - TODO - commenting out until timers cleaned up, as this causes multiple instances.
	//$route.reload();
	
	// Initialize navigation to expanded.
	// lmc - TODO load from user preferences.
	$cookieStore.put('nav', 'nav-expanded');
	var navExpanded = {
			cookieNav: 'nav-expanded',
			arrowNav: 'icon-arrowleft',
			navTitle: 'Collapse Left Navigation'
	};
	var navCollapsed = {
			cookieNav: 'nav-collapsed',
			arrowNav: 'icon-arrowright',
			navTitle: 'Expand Left Navigation'
	};

	// set default view, overridden by user preference.
	$scope.navbar = navExpanded;

	$scope.showSelected = function(selectedItem) {
	    var currentLocation = $location.path().substring(1) || 'dynamic-dashboard';
	    return (currentLocation.indexOf(selectedItem) !== -1) ? 'selected' : '';
	};
	
	/*
	 * Send an event to the rest of the system when a subsystem is selected.
	  */
	$scope.selectNav = function(selectedItem) {
		var e = $.Event('uinav.' + selectedItem);
		$(document).trigger(e);
	};
	
	/*
	 * Collapse or exapand the menu/navigation on the left-hand-side.
	  */
	$scope.toggleNav = function() {
		if ($scope.navbar.cookieNav == 'nav-expanded') {
			$scope.navbar = navCollapsed;
		} else if ($scope.cookieNav = 'nav-collapsed') {
			$scope.navbar = navExpanded;
		}
		$cookieStore.put('nav', $scope.navbar.cookieNav);
	};


    // Login the user, passing in credentials, autologin, or from the cookie store (if remember_me).
    $rootScope.loginUser = function(username, password, auto, remember) {
        var redirectToDash = false;
        var autologin = auto || false;
        var remember_me = remember || false;

        if (username === undefined || password === undefined) {
            if (remember_me) {
                $scope.credentials.username = $cookieStore.get("username");
                $scope.credentials.password = $cookieStore.get("password");
            } else {
                return;
            }
        }  else {
            $scope.credentials.username = username;
            $scope.credentials.password = password;
        }

        var load;
        if (!autologin) {
            $loginButton = $("#login-button");
            load = window.PHD.showLoadingIndicator($loginButton, false);
        }

        $http.post('/api/login', $scope.credentials)
            .success(function(data, status, headers) {

                $rootScope.user.name = $scope.credentials.username;
                $rootScope.user.id = data.id;
                $rootScope.user.superuser = data.superuser;
                $rootScope.user.administrator = data.administrator;
                $cookieStore.put('uid', data.id);
                $cookieStore.put('superuser', data.superuser);
                $cookieStore.put('administrator', data.administrator);
                $cookieStore.put('username', $scope.credentials.username);
                //$rootScope.user.loggedIn = true;  // set loggin flag

                // See if we should remember or clear the credentials.
                if (remember_me) {
                    $cookieStore.put('password', $scope.credentials.password);
                    $cookieStore.put('remember_me', true);
                } else {
                    $cookieStore.remove('password');
                    $cookieStore.remove('remember_me');
                }

                // set the default headers for the $http service.
                $http.defaults.headers.common['AuthToken'] = data.auth_token;
                $cookieStore.put('token', data.auth_token);

                // get this user's preferences
                getPreferencesFactory.async($scope,$rootScope).then(function(result) {
                    var data = result.data.data[0];

                    //For QuickStartWizard Flag
                    $rootScope.user.loggedIn = true;  // set loggin flag
                    // clear the logged in status on the login page
                    if (!autologin) {
                        window.PHD.hideLoadingIndicator(load);
                    }

                    $rootScope.passwd = $scope.credentials.password; // setting current password to root variable for quick start wizard.

                    $scope.setPreferences(result, false);
                });

                // get tour settings on login.
                getClientFactory.async($scope,$rootScope).then(function(result) {
                    $scope.tourClients = result.data.data.length;
                    // There must be assets to create a job.
                    $rootScope.tourBackupDisabled = !($scope.tourClients >=1);
                });

                getStorageFactory.async($scope, $rootScope).then(function(result){
                    var storage = result.data.storage;
                    // Stateless storage must be configured before adding assets.
                    $rootScope.tourHostDisabled = (storage.usage == "stateless" && storage.stateless_type === null);
                });

                // Send an event to the jQuery listeners on login.
                var e = $.Event('login');
                e.name = $scope.user.name;
                e.token = data.auth_token;
                e.version = '9.0';
                // Not great practice, but this is timing between Angular and Ajax calls.
                // We must set rootScope first so that global_user will be set in PHD ajax calls.
                $rootScope.user.token = e.token;
                $(document).trigger(e);

                // On login, check screen resolution vs the supported minimum and display message if low.

                var MIN_SUPPORTED_WIDTH = 1280;
                var MIN_SUPPORTED_HEIGHT = 1024;
                var height = screen.height;
                var width = screen.width;
                if (width !== undefined && height !== undefined && (width < MIN_SUPPORTED_WIDTH || height < MIN_SUPPORTED_HEIGHT)) {
                    var message = "This interface is designed to work optimally at a resolution of 1280x1024. " +
                        "Your current resolution (" + width + "x" + height + ") does not meet this minimum requirement " +
                        "and as a result you may encounter some display issues. <br/><br/>" +
                        "If you encounter any issues you should switch to another display with higher resolution or adjust your browser's display size/zoom controls.";
                    ngDialog.open({
                        dialogType:'Warning',
                        dialogMessage: message,
                        ngDialogStyle:'width:600px; height:200px;'
                    });
                }
            })
            .error(function(data, status, headers) {
                if (!autologin) {
                    // Remove the loading indicator and tap into PHD.throwError function here.
                    window.PHD.hideLoadingIndicator(load);
                    window.PHD.throwError(data);
                }
            })
    };

    $scope.setPreferences = function(result, isRefresh) {
        var data = result.data.data[0];
        var isRefresh = isRefresh || false;

        // For the setup wizard, check the user preference, and override with the global flag if set.
        var flag = data.show_setup_wizard;
        if (flag === "false" || $rootScope.globalPreference.showSetupWizard === false){
            $rootScope.user.showSetupWizFlag = false;
            $rootScope.globalPreference.showSetupWizard = false;
            if (!isRefresh) {
                // if a refresh, don't need the extra reload.
                var apppage = angular.element(document.getElementById("app"));
                var injector = apppage.injector();
                var route = injector.get('$route');
                route.reload();
            }
        }else{
            $rootScope.user.showSetupWizFlag = true;
        }
        // For the EULA, check the user preference, and override with the global flag if set.
        var eulaFlag = data.show_eula;
        $rootScope.eulaFlag = eulaFlag;
        if (eulaFlag === "false" || $rootScope.globalPreference.showEULA === false){
            $rootScope.user.eulaWizardFlag = false;
        }else{
            $rootScope.user.eulaWizardFlag = true;
        }

        // For Tour Flag
        var tourFlag = data.show_help_overlay;
        if (tourFlag === "false" || $rootScope.globalPreference.showTour === false) {
            $rootScope.user.showTour = false;
        } else {
            $rootScope.user.showTour = true;
        }
        //Set current tour step
        $rootScope.user.tourStep = 1;

        if($rootScope.user.showSetupWizFlag){
            $rootScope.loadDateTimeWizardData();
        }

        // update the language to be used based on user preference.
        var language = data.language;
        if (language !== undefined) {
            $scope.$broadcast("update-language", language);
        }

        $rootScope.setIfDefined($scope.Preferences, "backupwidget", "dash_backup_refresh", data.dash_backup_refresh);
        $rootScope.setIfDefined($scope.Preferences, "alertswidget", "dash_alert_refresh", data.dash_alert_refresh);
        $rootScope.setIfDefined($scope.Preferences, "replicationwidget", "dash_replication_refresh", data.dash_replication_refresh);
        $rootScope.setIfDefined($scope.Preferences, "recoverwidget", "dash_restore_refresh", data.dash_restore_refresh);
        $rootScope.setIfDefined($scope.Preferences, "activejobswidget", "dash_active_job_refresh", data.dash_active_job_refresh);
        $rootScope.setIfDefined($scope.Preferences, "storagewidget", "dash_storage_refresh", data.dash_storage_refresh);
        $rootScope.setIfDefined($scope.Preferences, "jobspage", "page_jobs_refresh", data.page_jobs_refresh);

        var FIVE_MINUTES = 5 * 60 * 1000;

        refreshRates.dash_backup_refresh = $scope.Preferences.dash_backup_refresh;
        refreshRates.dash_replication_refresh = $scope.Preferences.dash_replication_refresh;
        refreshRates.dash_restore_refresh = $scope.Preferences.dash_restore_refresh;
        refreshRates.dash_active_job_refresh = $scope.Preferences.dash_active_job_refresh;
        refreshRates.dash_alert_refresh = $scope.Preferences.dash_alert_refresh;
        refreshRates.dash_storage_refresh = $scope.Preferences.dash_storage_refresh;
        refreshRates.page_jobs_refresh = $scope.Preferences.page_jobs_refresh;
        $rootScope.listOfTimer[0] = data.dash_backup_refresh !== undefined ? data.dash_backup_refresh * 1000 : refreshRates.dash_backup_refresh;
        $rootScope.listOfTimer[1] = data.dash_active_job_refresh !== undefined ? data.dash_active_job_refresh * 1000 : refreshRates.dash_active_job_refresh;
        $rootScope.listOfTimer[2] = data.dash_storage_refresh !== undefined ? data.dash_storage_refresh * 1000 : refreshRates.dash_storage_refresh;
        $rootScope.listOfTimer[3] = data.dash_alert_refresh !== undefined ? data.dash_alert_refresh * 1000 : refreshRates.dash_alert_refresh;
        $rootScope.listOfTimer[4] = data.dash_forum_posts_refresh !== undefined ? data.dash_forum_posts_refresh * 1000 : FIVE_MINUTES;
        $rootScope.listOfTimer[5] = data.dash_daily_feed_refresh !== undefined ? data.dash_daily_feed_refresh * 1000 : FIVE_MINUTES;
        $rootScope.listOfTimer[6] = data.dash_replication_refresh !== undefined ? data.dash_replication_refresh * 1000 : refreshRates.dash_replication_refresh;
        $rootScope.listOfTimer[7] = data.dash_restore_refresh !== undefined ? data.dash_restore_refresh * 1000 : refreshRates.dash_restore_refresh;
        $rootScope.listOfTimer[8] = data.dash_replication_refresh !== undefined ? data.dash_replication_refresh * 1000 : refreshRates.dash_replication_refresh;
        $rootScope.listOfTimer[9] = data.dash_replication_refresh !== undefined ? data.dash_replication_refresh * 1000 : refreshRates.dash_replication_refresh;
        if (isRefresh) {
            for (var i = 0; i <= 8; i++) {
                var widgetName = $rootScope.listOfWidgetName[i];
                $rootScope.manualRefreshControl($rootScope.listOfTimer[i]/1000,widgetName);
            }
        }
        var jobsRefresh = data.page_jobs_refresh !== undefined ? data.page_jobs_refresh : refreshRates.page_jobs_refresh;
        $rootScope.JobsTimer.setInterval(jobsRefresh * 1000);
        var protectRefresh = data.page_protect_refresh !== undefined ? data.page_protect_refresh : refreshRates.page_jobs_refresh;
        $rootScope.ProtectTimer.setInterval(protectRefresh * 1000);
        var restoreRefresh = data.page_restore_refresh !== undefined ? data.page_restore_refresh : refreshRates.page_restore_refresh;
        $rootScope.RecoverTimer.setInterval(restoreRefresh * 1000);

        if($rootScope.user.showSetupWizFlag == false) {
            // remember subsystem the user was in last.
            if ($cookieStore.get('Page') !== undefined) {
                var Page = $cookieStore.get('Page');
                var lower_Page = Page.toLowerCase();
                if (lower_Page != "dashboard") {
                    location.href = "#/" + lower_Page;
                }
            }
        } else {
            $scope.disableTimers();
        }

        /*
         * If the idle timer is set in master.ini, use it.  Otherwise, turn off the timer.
         */
        var logoutTimer = data.timeout;
        if (($rootScope.user.showSetupWizFlag == false) && logoutTimer !== undefined && parseInt(logoutTimer) > 0) {
            Idle.setIdle(parseInt(logoutTimer) * 60);
            Idle.setTimeout(30);    // An additional 30 seconds once the warning is displayed 'til logout.
            Idle.watch();
        } else {
            Idle.unwatch();
        }

        $rootScope.showNavGroups = data['ShowGroups'] == "true";

        /* Triggering Event once user has logged-in
         * $rootScope.$broadcast is used as there is no parent-child relation
         * between login and alert module
         */
        $timeout(function() {
            $rootScope.$broadcast("logged-in");
        }, 1000);
    };

    angular.element(document).ready(function() {
        if ($rootScope.user.loggedIn) {
            console.log("************app ready,user logged in********");
            // get this user's preferences
            var getPreferences = function() {
                getPreferencesFactory.async($scope,$rootScope).then(function(result) {
                    $scope.setPreferences(result, true)
                });
            };
            getPreferences();

            // get tour settings on refresh.
            getClientFactory.async($scope,$rootScope).then(function(result) {
                $scope.tourClients = result.data.data.length;
                // There must be assets to create a job.
                $rootScope.tourBackupDisabled = !($scope.tourClients >=1);
            });

            getStorageFactory.async($scope, $rootScope).then(function(result){
                var storage = result.data.storage;
                // Stateless storage must be configured before adding assets.
                $rootScope.tourHostDisabled = (storage.usage == "stateless" && storage.stateless_type === null);
            });
        } else {
            var autologin = $cookieStore.get('autologin');
            if (autologin == undefined) {
                $http.get("app/login/autologin.json").success(function (data) {
                    autologin = data.autologin;
                    $cookieStore.put('autologin', autologin);
                    if (autologin) {
                        console.log("************app ready, auto login user********");
                        $rootScope.loginUser('root', 'unitrends1', true, false);
                    }
                });
            } else if (autologin) {
                console.log("************app ready, auto login user********");
                $rootScope.loginUser('root', 'unitrends1', true, false);
            } else {
                var remember_me = $cookieStore.get('remember_me');
                if (remember_me) {
                    console.log("************app ready, remember_me login user********");
                    $rootScope.loginUser(undefined, undefined, false, true);
                }
            }
        }
    });

}]);

app.config(function($routeProvider, $analyticsProvider) {
	$routeProvider.when('/', {
        templateUrl: "app/dynamic-dashboard/dynamicDashboard.html",
        controller: 'DynamicDashboardController'
	})
	.when('/protect', {
		templateUrl: "app/protect/protect.html",
		controller: 'ProtectCtrl'
	})
	.when('/recover', {
		templateUrl: "app/recover/recover.html",
		controller: 'RecoverCtrl'
	})
	.when('/jobs', {
		templateUrl: "app/jobs/jobs.html",
		controller: 'JobsCtrl'
	})
	.when('/reports', {
		templateUrl: "app/reports/reports.html",
		controller: 'ReportsCtrl'
	})
	.when('/configure', {
		templateUrl: "app/configure/configure.html",
		controller: 'ConfigCtrl'
	})
	.when('/reports/:id/:days/:sid', {
		templateUrl: "app/reports/reports.html",
		controller: 'ReportsCtrl'
	})
	.otherwise({ redirectTo: '/' });
});

app.factory('getPreferencesFactory', function($http) {
    return {
        async: function($scope, $rootScope) {
            var DEFAULT_REFRESH = 5000;
            $scope.Preferences = {};
            pref = $scope.Preferences;
            pref.dash_backup_refresh = DEFAULT_REFRESH;
            pref.dash_replication_refresh = DEFAULT_REFRESH;
            pref.dash_restore_refresh = DEFAULT_REFRESH;
            pref.dash_active_job_refresh = DEFAULT_REFRESH;
            pref.dash_alert_refresh = DEFAULT_REFRESH;
            pref.dash_storage_refresh = DEFAULT_REFRESH;
            pref.page_protect_refresh = DEFAULT_REFRESH;
            pref.page_restore_refresh = DEFAULT_REFRESH;
            pref.page_jobs_refresh = DEFAULT_REFRESH;

            $url = '/api/preferences/' + $scope.user.name + '/';
            console.log("*************************"+$scope.user.name+"***************"+$url);
            var promise = $http({
                method: 'GET',
                url: $url
            }).success(function(data, status, headers) {
                // per the JSON returned, get the first array element.

            }).error(function(data, status, headers) {

            });
            return promise;
        }
    };
});

app.factory('getClientFactory', function($http) {
    return {
        async: function($scope, $rootScope) {
            $scope.tourClients = 0;
            $url = '/api/clients/';
            console.log("*****" + $url + "*****");
            var promise = $http({
                method: 'GET',
                url: $url
            }).success(function (data, status, headers) {

            }).error(function (data, status, headers) {

            });
            return promise;
        }
    };
});

app.factory('getStorageFactory', function($http) {
    return {
        async: function($scope, $rootScope) {
            $url = '/api/storage/1/?sid=1';
            console.log("*****" + $url + "*****");
            var promise = $http({
                method: 'GET',
                url: $url
            }).success(function (data, status, headers) {

            }).error(function (data, status, headers) {

            });
            return promise;
        }
    };
});

app.directive('ngElementReady', [function() {
	return {
		priority: -1000,
		restrict: "A",
		link: function(scope, element, attributes) {
			scope.$eval(attributes.ngElementReady);
		}
	}
}]);
