
 // Validations for all wizard steps.
 function checkWizardValidation(wizardTitle){



 // regular expression to match required time format 
   	if(wizardTitle === DATE_TIME_WIZARD){
    	timeZoneValidator();
		$("#dateTimeWizForm").validate({
            rules: {  
                date: {
                    required: true
                },
                time: {
                    required: true,
					isTimeZoneMatch:true
                },
                timeZone: {
                    required: true
                },
                ntpServerText: {
                    required: true
                }
            },
            messages: {
                        date: "Date is required.",
                        time:{ required: "Time is required."},
                        timeZone: "Time zone is required.",
                        ntpServerText: "NTP server address is required."

            }
        });
        if((!$('#dateTimeWizForm').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
     }
	else if(wizardTitle === HOSTNAME_PASSWORD_WIZARD){
         domainNameValidator();
         $("#form_host").validate({
            rules: {  
                host_name: {
                    required: true,
                    maxlength: 63
                },
                host_domain_name: {
                    required: false,
                    isDomainNameValid: true // Domain name not mandatory hence required false here.
                },
                host_root_password: {
                    required: true
                },
                host_confirm_password: {
                    required: true,
                    equalTo: "#host_root_password"
                }
            },
             messages: {
                 host_name:{
                     required: "Host name is required.",
                     maxlength: "Host name is too long.  The maximum allowed is 63 characters."
                 },
                 host_root_password: {
                     required: "Root password is required."
                 },
                 host_confirm_password:{
                     required: "Confirm password is required.",
                     equalTo: "Confirm password and password do not match."
                 }
             }
        });
        if((!$('#form_host').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
     }else if(wizardTitle === EMAIL_WIZARD){
        
         $("#emailQSForm").validate({
            rules: {  
                smtp_server: {
                    required: true
                },
                email_user_name: {
                    required: true
                },
                email_password:{
                    required:true
                },
                email_confirm_pwd:{
                    required:true,
                    equalTo: "#email_password"
                }
            },
             messages: {
                 smtp_server: "Smtp server is required.",
                 email_user_name: "Username is required.",
                 email_password: "Password is required.",
                 email_confirm_pwd:{
                     required:"Confirm password is required.",
                     equalTo: "Confirm password and password do not match."
                 }
             }
            });
        if((!$('#emailQSForm').valid())) {
                return false;
        }else{
            return true;
        }
     
         
     }else if(wizardTitle === BACKUP_STORAGE_WIZARD){
        isValidationDone = true;
        return true;
		//backupStoreNameValidator(totalStorageDiskSize);
		//diskSizeValidator(totalStorageDiskSize);
         /*$("#backupStorageWizForm").validate({
            rules: {  
                backup: {
                    required: true,
					isbackupStoreNameMatch:true,
					isDiskSizeMatch:true// ,
					//checkException:true
                }
            },
            messages: {backup: { required:"Backup data store name is required."}}
        });
        if((!$('#backupStorageWizForm').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
        */
	 }else if(wizardTitle === FORUM_ACCOUNT_WIZARD){
		$("#form_forum_account").validate({
            rules: {  
                forum_acccount_email: {
                    required: true
                },
                forum_account_password:{
                    required: true
                }
            },
            messages: {
                forum_acccount_email:"Unitrends forum account is required.",
                forum_account_password:"Password is required."
            }
        });
        if((!$('#form_forum_account').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
	 }
    return true; // If All steps are valid then it will return true.
}// checkWizardValidation() >> End

function backupStoreNameValidator(totalStorageDiskSize){
    var backupVal = document.getElementById("backup").value;
	$.validator.addMethod("isbackupStoreNameMatch", function(value, element){ 
	          if(backupVal !== 'Internal' && backupVal !== 'internal')
					return true;
				else
					return false;

	}, "Invalid backup store name");
	
	$.validator.addMethod("isDiskSizeMatch", function(value, element){ 
			 if(totalStorageDiskSize >= 140){
					return true;
				}else{
				   return false;
				}
	}, "Total disk selection should be a minimum size of 140GB");
	
	$.validator.addMethod("checkException", function(value, element){ 
			 if(checkStorageExceptionFlags){
					return true;
				}else{
				   return false;
				}
	}, "Total disk selection should be a minimum size of 140GB");
}
 
 function timeZoneValidator(){
     re = /^\d{1,2}:\d{1,2}:\d{1,2}([ap]m)?$/;
     $.validator.addMethod("isTimeZoneMatch", function(value, element) {
         return value.match(re);

     }, "Invalid time format");
 }

 function domainNameValidator(){
     re = /^[a-z0-9-_]+(\.[a-z0-9-_]+)*\.([a-z]{2,4})$/;

     $.validator.addMethod("isDomainNameValid", function(value, element) {
         if(value== undefined || value== null || value== ""){
             return true;
         }
         if(value.length >63){
             return false;
         }
         return value.match(re);

     }, "Invalid domain name");
 }


/************************************* Validation for WIR ********************************************/
function validateWIR(){
    checkIPFormate();
    checkNetMaskFormate();
    checkGatewayFormate();
    $("#wir-location-form").validate({
            errorLabelContainer: ".datetime-dialog-error-list",
            errorContainer: ".datetime-dialog-errors",
            showErrors: function(errorMap, errorList) {
                $(".datetime-dialog-errors").find(".summary")
                    .html(gettext("Correct the following errors:"));
                this.defaultShowErrors();
            },
            rules: {  
                locationType: {
                    required: true
                },
                location: {
                    required:true
                },
                wirDatastore: {
                    required:true
                },
                wirLocationNetwork:{
                    required:true
                },
                ipAddress:{
                    required:true,
                    IPFormateChecked:true
                },
                netmask:{
                    required:true,
                    netmaskFormateChecked:true
                },
                gateway:{
                    required:true,
                    gatwayFormateChecked:true
                }
            },
            messages: {
                locationType:"Type is required",
                location:"Location is required",
                wirDatastore:"Datastore is required",
                wirLocationNetwork:"Network is required",
                ipAddress: "Invalid IP Address",
                netmask:"Invalid Netmask",
                gateway:"Invalid Gateway"
            }
        });
        if((!$('#wir-location-form').valid())) {
                return false;
        }else{
            return true;
        }
	 }
    function checkIPFormate(){
        
        var ipformate = $("#wir-location-ip").val();
            
         $.validator.addMethod("IPFormateChecked", function(ipformate) { 
                
              var ip = /^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/;
             if(ipformate.match(ip)==null ){
                 return false;
             }else if(ipformate.match(ip) !=null){
                return true; //ipformate.match(ip);   
             }
        }, "Invalid IP Format.");
    }
    function checkNetMaskFormate(){
        
        var ipformate = $("#wir-location-mask").val();
            
         $.validator.addMethod("netmaskFormateChecked", function(ipformate) { 
                
              var ip = /^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/;
             if(ipformate.match(ip)==null ){
                 return false;
             }else if(ipformate.match(ip) !=null){
                return true; //ipformate.match(ip);   
             }
        }, "Invalid Netmask format.");
    }
    function checkGatewayFormate(){
        
        var ipformate = $("#wir-location-gateway").val();
            
         $.validator.addMethod("gatwayFormateChecked", function(ipformate) { 
                
              var ip = /^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/;
             if(ipformate.match(ip)==null ){
                 return false;
             }else if(ipformate.match(ip) !=null){
                return true; //ipformate.match(ip);   
             }
        }, "Invalid Gateway format.");
    }

function checkedValidationVPCOption(isUnitrendAppliance,minProcessors,maxProcessors,minMemory,maxMemory,selectedAppType,memory_step){
	  checkProcessorValidation(minProcessors,maxProcessors);
	  checMemoryValidation(minMemory,maxMemory,selectedAppType,memory_step);
       $("#wir-vfc-form").validate({
            errorLabelContainer: ".datetime-dialog-error-list",
            errorContainer: ".datetime-dialog-errors",
            showErrors: function(errorMap, errorList) {
                $(".datetime-dialog-errors").find(".summary")
                    .html(gettext("Correct the following errors:"));
                this.defaultShowErrors();
            },
            rules: {  
                vfcName: {
                    required: !(isUnitrendAppliance)
                },
                processor:{
                    required: true,
					processorCheck:true
                },
                memory:{
                    required: true,
					memoryCheck:true,
					memoryStepCheck:true
                }
            },
            messages: {
                vfcName:"Name is required",
			    processor:{ required:"Processors is required"},
                memory:{ required:"Please enter Memory."}
                
            }
        });
        if((!$('#wir-vfc-form').valid())) {
                return false;
        }else{
            return true;
        }
}

function checkProcessorValidation(minProcessors,maxProcessors){
	 var processor = $("#wir-vfc-processors").val();
	 var memory = $("#wir-vfc-memory").val();
	
	  $.validator.addMethod("processorCheck", function(ipformate) { 
		      if(processor <= minProcessors && processor >= maxProcessors){
                 return false;
             }else if(processor >= minProcessors && processor <= maxProcessors){
                return true; 
             }
        },  "Processor value should be in between "+minProcessors+" & "+maxProcessors);
	
}

function checMemoryValidation(minMemory,maxMemory,selectedAppType,memoryStep){
	 var processor = $("#wir-vfc-processors").val();
	 var memory = $("#wir-vfc-memory").val();
	 $.validator.addMethod("memoryCheck", function(ipformate) {
    	      if(memory <= minMemory && memory >= maxMemory){
                 return false;
             }else if(memory >= minMemory && memory <= maxMemory){
                return true; 
             }
        }, "Memory value should be in between "+minMemory+" & "+maxMemory);
	
	   $.validator.addMethod("memoryStepCheck", function(ipformate) {
		  if(memory % memoryStep !== 0){
                 return false;
             }else if(memory % memoryStep === 0){
                return true; 
             }
        }, "Memory value should be multiple of "+memoryStep);
	
}
 /************************************* End of Validation for WIR ********************************************/


/*************************************** Validation for Recover Wizard******************************************/
function checkValidationForRecoverOptions(hostRequired,resourcePoolRequired,storageRequired,networkRequired,switchRequired){
	  $("#recovery-job-form").validate({
            errorLabelContainer: ".datetime-dialog-error-list",
            errorContainer: ".datetime-dialog-errors",
            showErrors: function(errorMap, errorList) {
                $(".datetime-dialog-errors").find(".summary")
                    .html(gettext("Correct the following errors:"));
                this.defaultShowErrors();
            },
            rules: {  
                    host: {
                        required: function(element) {
                            return hostRequired;
                        }
                    },
                    resource: {
                        required: function(element) {
                            return resourcePoolRequired;
                        }
                    },
                    storage: {
                        required: function(element) {
                            return storageRequired;
                        }
                    },
                    network: {
                        required: function(element) {
                            return networkRequired;
                        }
                    },
                    hypervisor_switch: {
                        required: function(element) {
                            return switchRequired;
                        }
                    }
            },
            messages: {
				   host: {
							required: gettext("Target location is required")
						},
						resource: {
							required: gettext("Target resource pool is required")
						},
						storage: {
							required: gettext("Target storage is required")
						},
						network: {
							required: gettext("Target appliance network is required")
						},
						hypervisor_switch: {
							required: gettext("Target network switch is required")
						}
            }
        });
        if((!$('#recovery-job-form').valid())) {
                return false;
        }else{
            return true;
        }
	
	
	
}

function checkValidationForExchangeRecoverOptions() {
    $("#exchange-recovery-job-form").validate({
        errorLabelContainer: ".datetime-dialog-error-list",
        errorContainer: ".datetime-dialog-errors",
        showErrors: function(errorMap, errorList) {
            $(".datetime-dialog-errors").find(".summary")
                .html(gettext("Correct the following errors:"));
            this.defaultShowErrors();
        },
        rules: {
            exchange_asset: {
                required: function(element) {
                    return $("#id_recovery_target_select").val() === "0";
                }
            },
            exchange_alt_asset: {
                required: function(element) {
                    return $("#id_recovery_target_select").val() === "1";
                }
            },
            recovery_area: {
                required: function(element) {
                    if($("#id_recovery_database").is(":checked")){
                        return ($("#id_recovery_target_select").val() === "0");
                    }
                    return false;
                }
            },
            original_location: {
                required: function(element) {
                    return !($("#id_recovery_database").is(":checked") || $("#id_original_location").is(":checked"));
                }
            },
            exchange_alt_directory: {
                required: function(element) {
                    return $("#id_recovery_target_select").val() === "1";
                }
            }
        },
        messages: {
            exchange_asset: {
                required: gettext("Asset is required")
            },
            exchange_alt_asset: {
                required: gettext("Asset is required")
            },
            recovery_area: {
                required: gettext("Recovery database is required")
            },
            original_location: {
                required: gettext("Original location should be accessible")
            },
            exchange_alt_directory: {
                required: gettext("Directory is required")
            }
        }
    });
    if((!$('#exchange-recovery-job-form').valid())) {
        return false;
    } else {
        return true;
    }
}

 /*************************************** Validation for SQL Recover Wizard******************************************/
 function checkValidationForSqlRecoverOptions(SQLselectedaltlocationFlag) {
     $('#sql-recovery-job-form').validate({
         errorLabelContainer: ".datetime-dialog-error-list",
         errorContainer: ".datetime-dialog-errors",
         showErrors: function (errorMap, errorList) {
             $(".datetime-dialog-errors").find(".summary")
                 .html(gettext("Correct the following errors:"));
             this.defaultShowErrors();
         },
         rules: {
             target: {
                 required: true
             },
             instance: {
                 required: true
             },
             database: {
                 required: true
             },
             directory: {
                 required: SQLselectedaltlocationFlag
             }
         },
         messages: {
             target: {
                 required: gettext("Recovery target is required")
             },
             instance: {
                 required: gettext("Recovery instance is required")
             },
             database: {
                 required: gettext("Recovery database is required")
             },
             directory: {
                 required: gettext("The target path must be specified when restoring to another recovery target.")
             }
         }
     });
     if ((!$('#sql-recovery-job-form').valid())) {
         return false;
     } else {
         return true;
     }
 }


 /*************************************** Validation for NDMP Recover Wizard******************************************/
 function checkValidationForNdmpRecoverOptions() {
     $("#ndmp-recovery-job-form").validate({
         errorLabelContainer: ".datetime-dialog-error-list",
         errorContainer: ".datetime-dialog-errors",
         showErrors: function(errorMap, errorList) {
             $(".datetime-dialog-errors").find(".summary")
                 .html(gettext("Correct the following errors:"));
             this.defaultShowErrors();
         },
         rules: {
             host: {
                 required: true
             },
             volume: {
                 required: true
             },
             name_directory: {
                 required: false
             }
         },
         messages: {
             host: {
                 required: gettext("Asset is required")
             },
             volume: {
                 required: gettext("Volume is required")
             },
             name_directory: {
                 required: gettext("Directory is required")
             }
         }
     });
     if((!$('#ndmp-recovery-job-form').valid())) {
         return false;
     } else {
         return true;
     }
 }