angular.module('active-directory-module', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            trapFocus: true,
            preCloseCallback: function (value) {

            }
        });
    }])
    .controller('activeDirectoryCtrl', ['$scope', '$rootScope', '$http','ngDialog', '$window', '$timeout', function($scope, $rootScope, $http, ngDialog, $window, $timeout) {

        $scope.originalADSettings = $scope.activeDirectorySettings;
        $scope.adHelp = "Use an Active Directory server for user authentication.";

        $scope.showADTooltip = function(){
            var form = angular.element("#active-directory-advanced-form");
            form.find(".definition").popover({
                appendTo: form
            });
        };

        $scope.saveSettings = function(commandName) {
            var url = "/api/active-directory/?sid=" + selectedAppliance.id;
            var load = PHD.showLoadingIndicator("body", true); //, "Running command " + commandName + "....");
            var dimensions = 'width:650px; height:475px;';
            var payload = [];
            for (var prop in $scope.activeDirectorySettings) {
                var adValue = $scope.activeDirectorySettings[prop];
                if (typeof(adValue) === 'boolean') {
                    adValue = adValue ? "Yes" : "No";
                }
                var item = {"field": prop, "value": adValue};
                payload.push(item);
            }
            payload = JSON.stringify(payload);
            var resp = PHD.Ajax.put(url, payload, load, handleError);
            resp.done(function(data) {
                $(document).trigger("adUpdated");
                $scope.closeThisDialog();
            });
        };

        function handleError(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var message = data.result[0].message;
                    ngDialog.open({
                        dialogType: 'Error',
                        modelDialogId: 'ad-error-dialog',
                        scope: $scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick: 'onConfirmError()'
                    });
                }
            } else {
                PHD.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.onConfirmError = function () {
            ngDialog.close('ad-error-dialog');
        };

        $scope.closeThisDialog = function() {
            console.log('handleCancel');
            $scope.activeDirectorySettings = $scope.originalADSettings;
            $(document).trigger("adUpdated");
            $scope.PHD.currentMiniWizard.wizard("close");
            // Must clear currentMiniWizard for the next time the dialog is loaded.
            $scope.PHD.currentMiniWizard = null;
        };

        $scope.$on('$includeContentLoaded', function(event, obj) { $scope.processDialog(obj) });

        $scope.processDialog = function(obj) {
            $("#ad-template-specific-groups").removeClass("hidden");
           // $("#ad-template-ad_server").attr("autofocus", "autofocus");
            $scope.showADTooltip();
        }

    }]);