(function($, PHD, window, undefined) {
    var $form = $("#users-edit-form"),
        allUsers,
        UsersTable,
        $usersTable,
        UsersForm,
        $btnAddUser = $(".users-add"),
        $btnEditUser = $(".users-edit"),
        $btnDeleteUser = $(".users-delete"),
        $btnSaveUser = $(".users-save"),
        $btnCancel = $(".users-cancel"),
        roleSelect,
        $roleSelect = $("#role"),
        EditUser = false,
        UsersRowData,id,username,superuser,customers = {},locations = {},systems = {},
        multiple,common_privilege_level,
        activeDirectorySettings;


    function initForm() {

        $btnAddUser.on("click", function(event) {
            EditUser = false;
            $("#box_title").text("Add User");
            $("#passwordLabel1").text("Password");
            $("#confirm_password").show();
            $("#password1").show();
            $("#change_password").hide();
            $("#currentPassword").hide();
            $("#username").val("");
            $("#password1").val("");
            $("#password2").val("");
            handleAddUser();
        });
        $btnCancel.on("click", handleAddUser);
        $btnSaveUser.on("click", handleSaveUser);
        $btnEditUser.on("click", function(event) {
            EditUser = true;
            $("#box_title").text("Edit User");
            $("#confirm_password").hide();
            $("#password1").hide();
            $("#change_password").show();
            $("#username").val(username);
            if(typeof id !== "undefined"){
                if(superuser){
                    $roleSelect.val(4);
                    handleAddUser();
                }
                else if(multiple){
                    PHD.alert("Please use Legacy UI to update this user information.");
                }
                else{
                    $roleSelect.val(common_privilege_level);
                    handleAddUser();
                }
            }
            else{
                PHD.alert("You must select a user to edit.");
            }
            });
        $btnDeleteUser.on("click", handleDeleteUser);

        $("#change_password").on("click", function(){
            $("#confirm_password").show();
            $("#password1").show();
            $("#change_password").hide();
            $("#currentPassword").show();
            $("#passwordLabel1").text("New Password");
        });

        $usersTable = $form.find(".users-table");
        UsersTable = PHD.DataTable($usersTable, {});
        refreshUsersList();

        $.get("app/configure/active-directory/ad-template.html", function(filter_html) {
            filter_html = filter_html.replace(/ad-template-/g, "ad-edit-appliance-");
            filter_html = filter_html.replace(/\{\{adHelp\}\}/g, "Use an Active Directory server for user authentication.  Click the button below to update Active Directory Settings");
            $el = $form.find("#include_ad_template");
            $el.empty().append(filter_html);
            $el.find(".definition").popover({
                appendTo: $form
            });
            refreshADSettings();
        });

        $(document).on("adUpdated", function(event) {
            refreshADSettings();
        });

        $usersTable.on("rowselect", "tr", function (event, dbid, $el, DataTable, DataRow) {
            if(!$btnAddUser.is(':visible')){
                handleAddUser();
            }
            multiple = false;
            UsersRowData = DataRow.data;
            id = UsersRowData.id;
            username = UsersRowData.name;
            superuser = UsersRowData.superuser;
            customers = UsersRowData.customers;
            locations = UsersRowData.locations;
            systems = UsersRowData.systems;
            if(!superuser){
                if(customers.length > 0 && locations.length > 0 && systems.length > 0){
                    if((customers[0]['privilege_level'] == locations[0]['privilege_level']) && (locations[0]['privilege_level'] == systems[0]['privilege_level'])){
                        common_privilege_level = parseInt(customers[0]['privilege_level']);
                        console.log("Multiple: False",customers[0]['privilege_level'],locations[0]['privilege_level'],systems[0]['privilege_level']);
                    }
                    else{
                        multiple = true;
                        console.log("Multiple: True",customers[0]['privilege_level'],locations[0]['privilege_level'],systems[0]['privilege_level']);
                    }
                }
                else{
                    multiple = true;
                }
            }
        });

        roleSelect = $roleSelect[0];
        roleSelect.options[0] = new Option('Monitor', 1);
        roleSelect.options[1] = new Option('Manage', 2);
        roleSelect.options[2] = new Option('Administrator', 3);
        roleSelect.options[3] = new Option('Superuser', 4);

        $form.find(".definition").popover({
            appendTo: $form
        });

        UsersForm = PHD.FormController($form, {})

            .on("formcancel", function (event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function (event, data) {
                PHD.currentDialog.wizard("close");
            })
            .validate({
                errorLabelContainer: ".users-dialog-error-list",
                errorContainer: ".users-dialog-errors",
                showErrors: function(errorMap, errorList) {
                    $(".users-dialog-errors").find(".summary")
                        .html(gettext("Correct the following errors:"));
                    this.defaultShowErrors();
                },
                rules: {
                    username: {
                        required: true
                    },
                    password1: {
                        required: true
                    },
                    password2: {
                        required: true,
                        isPasswordMatch: true
                    }
                },
                messages: {
                    name: {
                        required: gettext("Username is required")
                    },
                    password1: {
                        required: gettext("Password is required")
                    },
                    password2: {
                        required: gettext("Confirm Password is required")
                    }
                }
            });
    }

    $('#edit-appliance').on("beforeactivationtab", function(event,ui) {
        if((ui.oldTab.text()) === " Users "){
            /* code to see if a confirmation is needed would go here */
            $(currentTarget).trigger('tabsactivateafterconfirm',ui);
        }
    });

    function refreshUsersList() {
        var users = PHD.Ajax.get('/api/users/?sid=' + PHD.appliance_sid);
        users.done(function(data) {
            allUsers = [];

            var usersList = data.data;
            usersList.forEach(function(item, index) {
                item.username = item.name;
                item.role = item.superuser;
                if(!item.vault_user){
                    if(item.superuser){
                        item.role = "Superuser";
                    }
                    else{
                        if( item.customers.length >0 &&  item.locations.length >0 && item.systems.length >0 ){
                            if(item.customers[0]['privilege_level'] == 0 && item.locations[0]['privilege_level'] == 0 && item.systems[0]['privilege_level'] == 0){
                                item.role = "None";
                            }
                            else if(item.customers[0]['privilege_level'] == 1 && item.locations[0]['privilege_level'] == 1 && item.systems[0]['privilege_level'] == 1){
                                item.role = "Monitor";
                            }
                            else if(item.customers[0]['privilege_level'] == 2 && item.locations[0]['privilege_level'] == 2 && item.systems[0]['privilege_level'] == 2){
                                item.role = "Manage";
                            }
                            else if(item.customers[0]['privilege_level'] == 3 && item.locations[0]['privilege_level'] == 3 && item.systems[0]['privilege_level'] == 3){
                                item.role = "Administrator";
                            }
                            else {
                                item.role = "Multiple";
                            }
                        }
                        else {
                            item.role = "Multiple";
                        }
                    }
                }
            });
            allUsers = $.merge(allUsers, usersList);
            UsersTable.load(allUsers);
        });
    }

    function refreshADSettings() {
        activeDirectorySettings = {};
        console.log("getting AD Settings");
        var resp = PHD.Ajax.get('/api/active-directory/?sid=' + PHD.appliance_sid);
        resp.done(function(data) {
            console.log("return from AD settings");
            console.log(data, data.data);
            if (data !== undefined && data.data !== undefined) {
                var settings = data.data;
                for (var i = 0; i < settings.length; i++) {
                    var setting = settings[i];
                    switch (setting.field) {
                        case "AD_AuthenticationEnabled":
                            activeDirectorySettings.AD_AuthenticationEnabled = setting.value == "Yes";
                            break;
                        case "AD_ServerName":
                            activeDirectorySettings.AD_ServerName = setting.value;
                            break;
                        case "AD_DomainName":
                            activeDirectorySettings.AD_DomainName = setting.value;
                            break;
                        case "AD_IP":
                            activeDirectorySettings.AD_IP = setting.value;
                            break;
                        case "AD_UseSSL":
                            activeDirectorySettings.AD_UseSSL = setting.value == "Yes";
                            break;
                        case "AD_Superuser":
                            activeDirectorySettings.AD_Superuser = setting.value;
                            break;
                        case "AD_Admin":
                            activeDirectorySettings.AD_Admin = setting.value;
                            break;
                        case "AD_Manage":
                            activeDirectorySettings.AD_Manage = setting.value;
                            break;
                        case "AD_Monitor":
                            activeDirectorySettings.AD_Monitor = setting.value;
                            break;
                    }
                }

                $("#ad-edit-appliance-ad_server").val(activeDirectorySettings.AD_ServerName);
                $("#ad-edit-appliance-ad_domain").val(activeDirectorySettings.AD_DomainName);
                $("#ad-edit-appliance-ad_enabled").prop('checked', activeDirectorySettings.AD_AuthenticationEnabled);
                $("#ad-edit-appliance-ad_ssl").prop('checked', activeDirectorySettings.AD_UseSSL);
                $("#ad-edit-appliance-ad_ip").val(activeDirectorySettings.AD_IP);
                $("#ad-edit-appliance-ad_server").attr('disabled', true);
                $("#ad-edit-appliance-ad_domain").attr('disabled', true);
                $("#ad-edit-appliance-ad_enabled").attr('disabled', true);
                $("#ad-edit-appliance-ad_ssl").attr('disabled', true);
            }
        });
    }

    function passwordValidator(){
        var passwd = $("#password1").val();
        var confimPasswd = $("#password2").val();

        $.validator.addMethod("isPasswordMatch", function(value, element) {
            if(passwd == confimPasswd)
                return true;
            else
                return false;

        }, "Confirm password and password, do not match.");
    }

    function handleAddUser() {
        if($btnAddUser.is(':visible')){
            $(".user_add_update_buttons").hide();
            $("#add_update_users").show();
            $("#active-directory-info").hide();
        }
        else{
            $(".user_add_update_buttons").show();
            $("#add_update_users").hide();
            $("#active-directory-info").show();
            $('#add_update_users').find('.error').removeClass("error");
            $("#users-edit-form #dialog-error-list").empty();
            $("#users-edit-form .users-dialog-errors").css('display','none');
        }
    }

    function handleDeleteUser() {
        var url = "/api/users/"+ id + "/";
        var sid = (PHD.appliance_sid == null) ? "" : "?sid=" + PHD.appliance_sid;
        url += sid;

        PHD.Ajax
            .delete(url)
            .done(function(data) {
                var result = data.result[0];
                if (result !== undefined) {
                    if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        console.log("SUCCESS");
                        refreshUsersList();
                    } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                        console.log("FAILURE");
                        PHD.throwError(data);
                    }
                }
            });
    }

    function handleSaveUser() {
        passwordValidator();
        if (!$form.valid()) {
            return false;
        }
        var selectedRoleID = $roleSelect.val();
        var obj = {};
        var url = "/api/users/";
        var self = this;
        var sid = (PHD.appliance_sid == null) ? "" : "?sid=" + PHD.appliance_sid;
        var customers = {},locations = {},systems = {}, customersArray = {}, locationsArray = {}, systemsArray = {};

        if(EditUser){
            if(!$("#change_password").is(':visible')){
                obj.password = $("#password1").val();
                obj.current_password = $("#currentPasswordInput").val();
            }
        }
        else{
            obj.password = $("#password1").val();
            obj.name = $("#username").val();
        }

        if(selectedRoleID == 4){
            obj.superuser = true;
        }
        else{
            obj.superuser = false;
            customers.id = PHD.appliance_sid;
            customers.privilege_level = parseInt(selectedRoleID);
            customersArray[0] = customers;
            obj.customers = customersArray;
            locations.id = PHD.appliance_sid;
            locations.privilege_level = parseInt(selectedRoleID);
            locationsArray[0] = locations;
            obj.locations = locationsArray;
            systems.id = PHD.appliance_sid;
            systems.privilege_level = parseInt(selectedRoleID);
            systemsArray[0] = systems;
            obj.systems = systemsArray;
        }

        obj = JSON.stringify(obj);
        var load = PHD.showLoadingIndicator($form);
        if(EditUser){
            url += id + "/" + sid;
            resp = PHD.Ajax.put(url, obj, load);
        }
        else{
            url += sid;
            resp = PHD.Ajax.post(url, obj, load);
        }

        resp.done(function(data) {
                // self.$form.trigger("formsubmit", [data, self.$form, self]);
                var result = data.result[0];
                if (result !== undefined) {
                    if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        console.log("SUCCESS");
                        refreshUsersList();
                        handleAddUser();
                        PHD.hideLoadingIndicator(load);
                    } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                        console.log("FAILURE");
                       PHD.throwError(data);
                    } else {
                        // adding user, get back id.
                        console.log("SUCCESS");
                        refreshUsersList();
                        handleAddUser();
                        PHD.hideLoadingIndicator(load);
                    }
                }
            });
    }


    // The advanced support toolbox is on the Encryption tab, which is the Advanced Tab.
    $("#btnADSettings").click(function (event) {
        event.stopPropagation();
        console.log(PHD.currentMiniWizard);
        /*
         * Workaround to handle the 2 event clicks that come from the 2 buttons that overlay each other.
         * Also, to use wizard within the wizard, the workaround is to use the miniWizard.
         * Save current Edit dialog, load the shutdown dialog, and set it to be the miniWizard one.
         * This can be simplified once Edit Appliance is AngularJS.
         */
        var saveDialog = PHD.currentDialog;
        if (PHD.currentMiniWizard === undefined || PHD.currentMiniWizard === null) {
            /*var scope = $("[ng-controller=AppliancesCtrl]").scope();
             var dimensions = 'width:825px; height:450px;';
             ngDialogService.open({
                 template: 'app/configure/active-directory/active-directory.html',
                 modelDialogId: 'active-directory-dialog-id',
                 name: 'active-directory-dialog',
                 scope: scope,
                 ngDialogStyle: dimensions,
                 data: activeDirectorySettings
             });
             */
            /*
             * Compile the additionl content so we can use AngularJS.
             */
            var ADDialog = PHD.wizard("app/configure/active-directory/active-directory.html", "active-directory",{
                title: "Active Directory Settings",
                helpArticle: PHD.App.getHelpLink("active-directory", true),
                width: 825,
                height: 450,
                open: function(event, ui) {
                    var adDialog = angular.element(document.getElementById("activeDirectoryDialog"));
                    var adScope = adDialog.scope();
                    angular.element(document).injector().invoke(function($compile){
                        $compile(adDialog.contents())(adScope);
                        adScope.$digest();
                        adScope.activeDirectorySettings = activeDirectorySettings;
                        adScope.PHD = PHD;
                    });
                }
            }, false, saveCurrentDialog);
            PHD.currentMiniWizard = ADDialog;
        }

        function saveCurrentDialog() {
            PHD.currentDialog = saveDialog;
        }
    });

    /* DOM Ready Function */
    $(function() {
        initForm();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
