angular.module('configure', ['angulartics', 'angulartics.google.analytics'])

	.controller('ConfigCtrl', ['$scope', '$http', 'Page', '$analytics', function($scope, $http, Page, $analytics) {
								
		Page.setTitle('Configure');

		$scope.tabs = [];
		$scope.currentTabIndex = 0;
		//$scope.slugs = ["appliances", "protected-assets", "copied-assets", "licensing"];
		// lmc - remove licensing as we have no concept of a global license at this time.
		$scope.slugs = ["appliances", "protected-assets", "copied-assets"];

		$scope.$on('$includeContentLoaded', function() {
			processConfigurePage(PHD, window, $analytics);
		});

		$scope.applianceLoaded = function() {
			$scope.tabs[0] = new PHD.ApplianceTab(0, $("#config-appliances")).init();
			if ($scope.currentTabIndex == 0) {
				$scope.tabs[0].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};

		$scope.assetsLoaded = function() {
			$scope.tabs[1] = new PHD.AssetsTab(1, $("#config-assets")).init();
			if ($scope.currentTabIndex == 1) {
				$scope.tabs[1].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};

		$scope.copiedAssetsLoaded = function() {
			$scope.tabs[2] = new PHD.CopiedAssetsTab(2, $("#config-copied-assets")).init();
			if ($scope.currentTabIndex == 2) {
				$scope.tabs[2].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};

		/*$scope.licenseLoaded = function() {
			$scope.tabs[3] = new PHD.LicenseTab(3, $("#config-licensing")).init();
			if ($scope.currentTabIndex == 3) {
				$scope.tabs[3].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};
		*/

		// wrap existing jQuery functionality.
		function processConfigurePage(PHD, window, $analytics) {
			var initialTab = $.cookie("initial_tab_config") || 0,
				$emailEditForm,
				$hvRemoveForm = $("#hypervisor-remove-form"),
				$applianceTable = $("#appliance-table"),
				hypervisorFormEdit = false,
				REFRESH_INTERVAL = 6000;

			function initTabs() {
				$scope.tabs[0] = {}; //new PHD.ApplianceTab(0, $(".ui-tabs-panel").eq(0)).init();
				$scope.tabs[1] = {}; // new PHD.ApplianceTab(1, $(".ui-tabs-panel").eq(1)).init();
				$scope.tabs[2] = {}; //new PHD.CopiedAssetsTab(2, $(".ui-tabs-panel").eq(2)).init();
				//tabs[3] = new PHD.LicenseTab(3, $(".ui-tabs-panel").eq(3)).init();

				//$scope.tabs[currentTabIndex].activate();
				//$(document).trigger("tabchange", "config" + slugs[currentTabIndex]);
			}

			function initForm() {
				/**
				 * Return true if the field value matches the given format RegExp
				 *
				 * @example jQuery.validator.methods.pattern("AR1004",element,/^AR\d{4}$/)
				 * @result true
				 *
				 * @example jQuery.validator.methods.pattern("BR1004",element,/^AR\d{4}$/)
				 * @result false
				 *
				 * @name jQuery.validator.methods.pattern
				 * @type Boolean
				 * @cat Plugins/Validate/Methods
				 */
				$.validator.addMethod("pattern", function (value, element, param) {
					if (this.optional(element)) {
						return true;
					}
					if (typeof param === 'string') {
						param = new RegExp('^(?:' + param + ')$');
					}
					return param.test(value);
				}, gettext("Invalid format."));
			}

			/*
			 *   DOM Ready Function
			 */
			$(function () {
				// Initialize form validation and event handlers
				initForm();

				// Quick and dirty way to change what tab opens by default via URL
				if (!isNaN(PHD.util.getHashInt())) {
					initialTab = PHD.util.getHashInt();
				}

				// Initialize the tabs
				$('#configure-page-tabs.tabs-wrapper').tabs({
					active: initialTab,
					create: function (event, ui) {
						$scope.currentTabIndex = ui.tab.index();
						initTabs();
					},
					activate: function (event, ui) {
						$(".loading").hide();
						$scope.currentTabIndex = ui.newTab.index();
						$.cookie("initial_tab_config", $scope.currentTabIndex, {expires: 365, path: '/'});
						$scope.tabs[ui.oldTab.index()].deactivate();
						$scope.tabs[$scope.currentTabIndex].activate();
						$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
					}
				});
			});

		}

	}]
);