angular.module('configCopiedAssets', ['ngDialog', 'angulartics', 'angulartics.google.analytics', 'treeGrid'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {
                
            }
        });
    }])
    
    .controller('CopiedAssetsCtrl', ['$scope', '$rootScope', '$http', '$timeout', 'ngDialog', '$analytics',
        function($scope, $rootScope, $http, $timeout, ngDialog, $analytics) {

        $scope.initCtrl = function () {
            $scope.Assets = {};
            processAssets(PHD, window);
        };

        $scope.listViewFlag =false;
        $scope.tableView = true;
        $scope.getView = function(tabular) {
            var view = tabular || $scope.tableView;
            return (view  ===true ? "Table" : "List");
        };
        
        $scope.toggleView = function() {
            $scope.tableView = !$scope.tableView;
            
            if(!$scope.tableView){
                $scope.selectProtectedAssetsFromList($scope.selectedID);
                $("#" + ($scope.selectedID)).css("background-color","#f5f5f5");
            }else{
                ($(".environment-assets").find(".assets-table")).load($scope.protectedAssetsDataArr);
                ($(".environment-assets").find(".assets-table")).resize();
            }
        };

        $scope.display = 'All';
        $scope.getDisplay = function(view) {
            var view = $scope.display;
            return view;
        };

        $scope.launchRetentionManager = function() {
            resp = PHD.Ajax.get("/api/retention/strategy/" + "?sid=" +  $rootScope.local.id);
            resp.done(function(data){
                var result = data.data;
                var strategy = result.strategy;
                if (strategy == 'MinMax') {
                    ngDialog.open({
                        template: 'app/configure/retention/min-max.html',
                        overlay: true,
                        name: 'MinMaxRetention',
                        ngDialogStyle:'width:700px; height:200px;',
                        closeByDocument: false,
                        closeByEscape: false
                    });
                } else {
                    ngDialog.open({
                        template: 'app/configure/retention/retentionpolicy.html',
                        scope: $scope,
                        overlay:true,
                        name: 'Retention-Policy',
                        ngDialogStyle:'width:300px; height:400px;',
                        // GFS TODO - enlarge dialog once we have weekly/monthly/yearly settings
                        //ngDialogStyle:'width:700px; height:400px;',
                        closeByDocument: false,
                        closeByEscape: false
                    });
                }
            });

        };

        $scope.tree_data = [];
        $scope.selectedArray = [];

        $scope.my_tree_handler = function (branch) {
            console.log('you clicked on', branch);
            //self.$selectedAppliance = $el;
            //$scope.el = $el;
            /*$scope.Assets.selectedID = branch.id;
            $scope.Assets.selectedObj = branch;
            $scope.selectedID = self.selectedID;
            $scope.selectedObj = branch;
            //self.selectedObj = _.find(self.assets, function(obj) { return obj.id == dbid });
            PHD.appliance_sid = ($scope.selectedObj != null) ? $scope.selectedObj.system_id : null;
            $scope.Assets.updateButtons(); */
            //self.refresh(this.updateAssets, true);
        };
        $scope.my_checkbox_handler = function(branch) {
            console.log("check ", branch);
            if (branch.checked) {
                console.log("IS checked");
                //if (_.findWhere($scope.selectedArray, {'id': branch.id}) == undefined) {
                    $scope.selectedArray.push(branch);
               // }
            } else {
                console.log("IS NOT checked");
                $scope.selectedArray = _.without($scope.selectedArray, branch);
            }
            if ($scope.selectedArray.length === 1) {
                $scope.selectedObj = $scope.selectedArray[0];
            } else {
                $scope.selectedObj = null;
            }
            PHD.appliance_sid = $rootScope.local.id;

            $scope.Assets.updateButtons();
        };
        $scope.my_tree = tree = {};
        $scope.expanding_property = {
            field: "name",
            displayName: "Name",
            sortable : true,
            filterable: true
        };
        $scope.col_defs = [
            {
                field: "description",
                displayName: "Description",
                sortable : true,
                sortingType : "string"
            },
            {
                field: "retention",
                displayName: "Retention",
                sortable : true,
                sortingType : "string"
            },
            {
                field: "system_name",
                displayName: "Source Appliance",
                sortable : true,
                sortingType : "string"
            }
        ];
        
        $scope.displayAll = function() {
            $scope.display = 'All';
            $scope.protectedAssetsDataArr = $scope.protectedAssetsAllDataArr;
            $timeout(function() {
                $scope.tree_data = $scope.protectedAssetsDataArr;
            });
        };

        $scope.displayVirtual = function() {
            $scope.display = 'Virtual';

            var virtualassets = ($scope.protectedAssetsAllDataArr).filter(function(obj){
                var isHyperV = false;
                if(obj.children) {
                    for (var i = 0; i < obj.children.length; i++) {
                        if (obj.children[i].type === "Hyper-V") {
                            isHyperV = true;
                            break;
                        }
                    }
                }
                return obj.asset_type && (obj.asset_type != ASSET_TYPE_PHYSICAL
                    || (obj.asset_type === ASSET_TYPE_PHYSICAL && (obj.is_hyperv_cluster || isHyperV) ));
            });

            $scope.protectedAssetsDataArr = virtualassets;
            $scope.tree_data = virtualassets;
        };

        $scope.displayPhysical = function() {
            $scope.display = ASSET_TYPE_PHYSICAL;
            var physicalassets = ($scope.protectedAssetsAllDataArr).filter(function(obj){
                return obj.asset_type && obj.asset_type === ASSET_TYPE_PHYSICAL;
            });

            $scope.protectedAssetsDataArr = physicalassets;
            $scope.tree_data = physicalassets;
        };

        $scope.launchAssetManager = function() {
            var assets = $scope.selectedArray;
            if (assets !== undefined) {
                if (assets.length > 1) {
                    console.log("selected > 1 asset");
                    ngDialog.open({
                        template: 'app/configure/environments/edit-multiple-assets.html',
                        scope: $scope,
                        overlay:true,
                        name: 'Edit-Assets',
                        data: assets,
                        ngDialogStyle:'width:600px;',
                        closeByDocument: false,
                        closeByEscape: true
                    });
                } else if (assets.length === 1) {
                    var asset = assets[0];
                    console.log("asset type:" + asset.asset_type);
                    var edit_url, title;
                    if(asset.name.endsWith(NAS_POSTFIX)) {
                        edit_url = "app/configure/environments/add-edit-nas.html";
                        title = "Edit NAS";
                        $analytics && $analytics.eventTrack(title, {  category: 'Configure', label: 'Protected Assets' });
                        PHD.wizard(edit_url, "manage-asset", {
                            title: gettext(title),
                            helpArticle: PHD.App.getHelpLink("editasset", true),
                            width: 570,
                            height: 555,
                            open: function (event, ui) {
                                $("#id_name").val(asset.name);
                                $("#id_ip").val(asset.nas_properties.hostname);
                                $("#edit_object_id").text(asset.nas_properties.nas_id);
                                $("#id_protocol").val(asset.nas_properties.protocol);
                                $("#id_port").val(asset.nas_properties.port);
                                $("#id_share").val(asset.nas_properties.share_name);
                                $("#id_credentials_username").val(asset.nas_properties.username);
                                associatedAppliance = asset.system_id;
                                serverEdit = true;
                                EditDisabled = true;
                            }
                        });
                    } else if(asset.asset_type == ASSET_TYPE_VMWARE_HOST){
                        edit_url = "app/configure/environments/" +  "add-edit-hypervisor.html" ;
                        title =  "Edit Virtual Host";
                        $analytics && $analytics.eventTrack(title, {  category: 'Configure', label: 'Configure' });
                        var height =  500 ;
                        PHD.wizard(edit_url, "manage-asset", {
                            title: gettext(title),
                            helpArticle: PHD.App.getHelpLink("editasset", true),
                            width: 575,
                            height: height,
                            open: function (event, ui) {
                                $("#id_server").val(asset.name);
                                $("#id_ip").val(asset.ip);
                                $("#edit_object_id").text(asset.id);
                                $("#id_enabled").prop('checked', asset.is_enabled);
                                $("#id_encrypted").prop('checked', asset.is_encrypted);
                                associatedAppliance = asset.system_id;
                                serverEdit = true;
                                selectedCredential = asset.credentials != undefined ? asset.credentials.credential_id : 0;
                                if(asset.description === "VMware Host"){
                                    EditDisabled = true;
                                }
                                else{
                                    EditDisabled = false;
                                }
                            }
                        });
                    } else if (asset.asset_type == ASSET_TYPE_PHYSICAL) {
                        ngDialog.open({
                            template: 'app/configure/environments/EditAsset.html',
                            scope: $scope,
                            overlay:true,
                            name: 'Edit-Server',
                            data: asset,
                            ngDialogStyle:'width:600px;height:520px',
                            closeByDocument: false,
                            closeByEscape: true
                        });
                    } else {
                        console.log("minimal asset dialog for apps");
                        ngDialog.open({
                            template: 'app/configure/environments/edit-multiple-assets.html',
                            scope: $scope,
                            overlay:true,
                            name: 'Edit-Assets',
                            data: assets,
                            ngDialogStyle:'width:600px;',
                            closeByDocument: false,
                            closeByEscape: true
                        });
                    }
                }
            }
            return true;
        };

        $scope.deleteAssetDialog = function() {
            if ($scope.selectedObj) {
                var asset_type = $scope.selectedObj.asset_type;
                if (asset_type == ASSET_TYPE_PHYSICAL || asset_type == ASSET_TYPE_VMWARE_HOST) {
                    var confirm = PHD.confirmDialog(
                        "<p>"+gettext("Are you sure you want to remove this copied asset?")+"</p>",
                        { title: gettext("Confirm Copied Asset Removal") }
                    );
                    confirm.done($.proxy($scope.Assets.kill, $scope.Assets));
                } else {
                    PHD.alert("Discovered assets (for example, a virtual machine or database) cannot be removed.");
                }
            } else {
                PHD.alert("You must select one and only one asset at a time for deletion.");
            }
        };

        function processAssets(PHD, window) {

            var Assets = function($el) {
                $scope.el = $el;
                this.$el = $el;
                this.dbid = this.$el.data("dbid");
                this.$header = $el.children(".environment-header");

                this.$buttons = $el.find(".button-bar a");
                $scope.buttons = this.$buttons;
                this.$options = this.$buttons.filter(".btn-environment-options");
                this.$el.find(".btn-group-display").flyout();
                this.$el.find(".btn-group-add-asset").flyout();

                this.appliancesInit = false;

                this.assets = [];
                this.$selectedAppliance = $();
                this.selectedID = null;
                $scope.selectedID = null;

                this.applianceProcess = null;
                this.detailProcess = null;

                this.timestamp = 0;
                this.refreshInterval = null;
                this.isActive = false;

                this.loadingIndicator = null;
            };

            Assets.prototype.init = function() {
                var self = this;

                this.initButtons();

                /*this.$applianceTable
                    .on("loadfinished updatefinished", function(event, newRows, DataTable) {
                        self.$applianceTable.scrollTable({"height": ".environment-assets"});
                        if(event.type === "loadfinished" && self.assets.length) {
                            //self.AssetsTable.selectByID(self.appliances[0].id);
                        }
                    }); */

                return this;
            };

            Assets.prototype.initButtons = function() {
                var self = this;
                return this;
            };

            Assets.prototype.updateButtons = function() {
                console.log("need to use scope to enable/disable buttons here.");
                /*this.$buttons.filter(".btn-edit-storage")
                    .toggleButton(this.selectedID && this.selectedStorageID && !this.$selectedStorage.is(".sync-status-pending"));
                this.$buttons.filter(".btn-remove-storage")
                    .toggleButton(this.selectedID && this.selectedStorageID && !this.$selectedStorage.is(".sync-status-pending"));
                this.$buttons.filter(".btn-edit-nic").toggleButton(this.selectedID && this.selectedNicID); */

                return this;
            };
            
            

            Assets.prototype.refresh = function(fn, updateDetails) {
                var self = this;
                if(this.isActive) {
                    fn = fn || this.updateAssets;
                    updateDetails = !(updateDetails === false);

                    this.applianceProcess = this.fetchAssets(fn);

                    $.when(this.applianceProcess).done(function() {
                        self.applianceProcess = null;
                        //if(!self.selectedID && self.appliances.length) self.AssetsTable.selectByID(self.appliances[0].state.id);
                        //if(!self.selectedID && self.assets.length) self.AssetsTable.selectByID(self.assets[0].id);
                        //self.setRefreshInterval();
                    });
                }
            };

            Assets.prototype.fetchAssets = function(fn) {
                if(!_.isFunction(fn)) {
                    fn = this.buildAssets;
                }

                this.loadingIndicator = PHD.showLoadingIndicator($("#config-copied-assets"), false);
                return PHD.Ajax
                    //lmc
                    .get("/api/assets/?grandclient=true", this.loadingIndicator)
                    .done($.proxy(fn, this));
            };

            $scope.protectedAssetsDataArr = [];
            $scope.protectedAssetsAllDataArr = [];
            $scope.selectedAssets = [];
            Assets.prototype.buildAssets = function(data) {
                if(data) {
                    this.assets = data.data;
                    this.assets.forEach(function(asset, index) {
                       asset.description = (asset.os_type != undefined) ? asset.os_type : asset.asset_type;
                    });
                    $scope.selectedArray = [];
                    $scope.protectedAssetsAllDataArr = this.assets;
                    if($scope.display == ASSET_TYPE_PHYSICAL){
                        $scope.displayPhysical();
                    } else if($scope.display == 'Virtual'){
                        $scope.displayVirtual();
                    } else {
                        $scope.displayAll();
                    }

                    $scope.selectedAssets = $scope.protectedAssetsDataArr[0];
                    if ($scope.selectedAssets !== undefined) {
                        $scope.selectedID = $scope.selectedAssets.id;
                    } else {
                        $scope.selectedID = null;
                    }
                    if ($scope.protectedAssetsDataArr[0] !== undefined && $scope.protectedAssetsDataArr[0].id !== undefined) {
                        $("#" + ($scope.protectedAssetsDataArr[0].id)).css("background-color","#f5f5f5");
                    }
                }
                if(this.applianceProcess) this.applianceProcess.resolve();
            };

            Assets.prototype.updateAssets = function(data) {
                if(data) {
                    this.assets = data.data;
                    this.assets.forEach(function(asset, index) {
                        asset.description = (asset.os_type != undefined) ? asset.os_type : asset.asset_type;
                    });
                    this.timestamp = data.timestamp;
                    $scope.selectedArray = [];
                    $scope.protectedAssetsAllDataArr = this.assets;
                    if($scope.display == ASSET_TYPE_PHYSICAL){
                        $scope.displayPhysical();
                    } else if($scope.display == 'Virtual'){
                        $scope.displayVirtual();
                    } else {
                        $scope.displayAll();
                    }
                }
                if(this.applianceProcess) this.applianceProcess.resolve();
            };

            Assets.prototype.isReady = function() {
                return this.isActive && (this.applianceProcess === null || this.applianceProcess.state() === 'resolved') &&
                    (this.detailProcess === null || this.detailProcess.state() === 'resolved');
            };

            Assets.prototype.setButtonLock = function(locked) {
                this.$buttons.each(function() {
                    $(this).toggleButton(!locked);
                });
            };

            Assets.prototype.initAssets = function() {
                this.refresh(this.buildAssets);
                this.appliancesInit = true;
                return this;
            };

            Assets.prototype.kill = function() {
                var self = this,
                    url = "/api/clients/" + $scope.selectedObj.id + "/?sid=" + $rootScope.local.id;
                //UNIBP-1708 added loding indicator while removing
                var deleteProtectedAsset = PHD.showLoadingIndicator("body", true, "Removing...");
                var resp = PHD.Ajax.delete(url, null, deleteProtectedAsset);
                resp.done(function(data) {
                    $analytics && $analytics.eventTrack('Delete Asset', {  category: 'Configure', label: 'Configure' });
                    self.selectedID = null;
                    PHD.hideLoadingIndicator(deleteProtectedAsset);
                    self.refresh(self.fetchAssets);
                });
            };

            Assets.prototype.activate = function() {
                this.isActive = true;
                if(!this.appliancesInit) {
                    this.initAssets();
                } else {
                    this.refresh(this.updateAssets);
                }
                return this;
            };

            Assets.prototype.deactivate = function() {
                this.isActive = false;
                clearInterval(this.refreshInterval);
                return this;
            };

            var AssetsTab = function(index, $panel) {
                this.index = index;
                this.$panel = $panel;
                this.$assetsArea = this.$panel.children("#copied-assets-list");
                this.$environments = null;
                this.environmentList = {};
                this.activeEnvironment = null;
                this.isActive = false;
                this.isBootstrapped = false;
            };

            AssetsTab.prototype.bootstrap = function(data) {
                this.$environments = this.$assetsArea.find(".environment");
                this.environmentList = new Assets(this.$environments).init();
                $scope.Assets = this.environmentList;
                this.activeEnvironment = this.environmentList; //this.environmentList.activate();
                this.isBootstrapped = true;
            };

            AssetsTab.prototype.init = function() {
                var self = this;
                $(document)
                    .on("assetChange", function(event, dbid) {
                        if ($scope.Assets !== undefined && $scope.Assets.appliancesInit !== undefined) {
                            if(!$scope.Assets.appliancesInit) {
                                $scope.Assets.initAssets();
                            } else {
                                $scope.Assets.refresh($scope.Assets.updateAssets);
                            }
                        }
                    });

                return this;
            };

            AssetsTab.prototype.activate = function() {
                this.isActive = true;
                if(!this.isBootstrapped) {
                    this.bootstrap();
                }
                if(this.activeEnvironment) {
                    this.activeEnvironment.activate();
                }
                return this;
            };

            AssetsTab.prototype.deactivate = function() {
                this.isActive = false;
                if(this.activeEnvironment) {
                    this.activeEnvironment.deactivate();
                }
                return this;
            };
            
            Assets.prototype.setSelectedAssets = function(selectedId){
                var self = this;
                
                $scope.listViewFlag = true;

                this.$selectedAppliance = $scope.el;
                this.selectedID = selectedId;

                /*var x = this.AssetsTable.$table[0].rows;
                for (var i = 1; i < x.length; i++) {
                    
                    var rowDetails = x[i];
                    
                    if((parseInt(x[i].dataset.dbid)) == selectedId){
                        if(!($(x[i]).hasClass("current-row"))){
                            $(x[i]).addClass("current-row");
                            $scope.selectedID = selectedId;
                            this.$selectedAppliance = $(x[i]);
                            this.selectedID = selectedId;
                        }
                        
                    }else{
                        if($(x[i]).hasClass("clickable current-row")){
                            $(x[i]).removeClass("current-row");
                        }
                    }
                }
                
                this.AssetsTable.$table[0].rows = x;*/
                self.updateButtons();
            };
            
            $scope.selectProtectedAssetsFromList = function(selectedId){
                var arrLength=($scope.protectedAssetsDataArr).length;

                for (var i=0; i < arrLength; i++){
                    if ($scope.protectedAssetsDataArr[i].id===selectedId){
                       $scope.selectedAssets = $scope.protectedAssetsDataArr[i];
                       $("#" + selectedId).css("background-color","#f5f5f5");
                       $scope.selectedID = selectedId;
                    }else{
                        $("#" + $scope.protectedAssetsDataArr[i].id).css("background-color","#fff");
                    }
                }
                
                Assets.prototype.setSelectedAssets(selectedId);
            };

            PHD.CopiedAssetsTab = AssetsTab;
        }

        // Initialize the controller.
        $scope.initCtrl();
    }]);