angular.module('configAssets', ['ngDialog', 'angulartics', 'angulartics.google.analytics', 'treeGrid'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {
                
            }
        });
    }])
    
    .controller('AssetsCtrl', ['$scope', '$rootScope', '$http', '$timeout', 'ngDialog', '$analytics',
        function($scope, $rootScope, $http, $timeout, ngDialog, $analytics) {

        $scope.initCtrl = function () {
            $scope.Assets = {};
            processAssets(PHD, window);
        };

        $scope.button_allowed = true;
        $scope.listViewFlag =false;
        $scope.tableView = true;
        $scope.updateAgentMessage='';
        $scope.getView = function(tabular) {
            var view = tabular || $scope.tableView;
            return (view  ===true ? "Table" : "List");
        };
        
        $scope.toggleView = function() {
            $scope.selectedObj = null;
            PHD.appliance_sid = 1;

            $scope.tableView = !$scope.tableView;
            
            if(!$scope.tableView){
                $scope.selectProtectedAssetsFromList($scope.selectedID);
                $("#" + ($scope.selectedID)).css("background-color","#f5f5f5");
            }else{
                ($(".environment-assets").find(".assets-table")).load($scope.protectedAssetsDataArr);
                ($(".environment-assets").find(".assets-table")).resize();
                if ($scope.selectedArray.length === 1) {
                    $scope.selectedObj = $scope.selectedArray[0];
                    PHD.appliance_sid = $scope.selectedObj.system_id;
                }
            }
        };

        $scope.display = 'All';
        $scope.getDisplay = function(view) {
            var view = $scope.display;
            return view;
        };

        $scope.launchRetentionManager = function() {
            resp = PHD.Ajax.get("/api/retention/strategy/" + "?sid=" +  PHD.appliance_sid);
            resp.done(function(data){
                var result = data.data;
                var strategy = result.strategy;
                if (strategy == 'MinMax') {
                    ngDialog.open({
                        template: 'app/configure/retention/min-max.html',
                        overlay: true,
                        name: 'MinMaxRetention',
                        ngDialogStyle:'width:700px;',
                        closeByDocument: false,
                        closeByEscape: false
                    });
                } else {
                    ngDialog.open({
                        template: 'app/configure/retention/retentionpolicy.html',
                        scope: $scope,
                        overlay:true,
                        name: 'Retention-Policy',
                        ngDialogStyle:'width:300px; height:400px;',
                        // GFS TODO - enlarge dialog once we have weekly/monthly/yearly settings
                        //ngDialogStyle:'width:700px; height:400px;',
                        closeByDocument: false,
                        closeByEscape: false
                    });
                }
            });

        };

        $scope.tree_data = [];
        $scope.selectedArray = [];

        $scope.my_tree_handler = function (branch) {
            console.log('you clicked on', branch);
            //self.$selectedAppliance = $el;
            //$scope.el = $el;
            /*$scope.Assets.selectedID = branch.id;
            $scope.Assets.selectedObj = branch;
            $scope.selectedID = self.selectedID;
            $scope.selectedObj = branch;
            //self.selectedObj = _.find(self.assets, function(obj) { return obj.id == dbid });
            PHD.appliance_sid = ($scope.selectedObj != null) ? $scope.selectedObj.system_id : null;
            $scope.Assets.updateButtons(); */
            //self.refresh(this.updateAssets, true);
        };
        $scope.my_checkbox_handler = function(branch) {
            console.log("check ", branch);
            if (branch.checked) {
                console.log("IS checked");
                //if (_.findWhere($scope.selectedArray, {'id': branch.id}) == undefined) {
                    $scope.selectedArray.push(branch);
               // }
            } else {
                console.log("IS NOT checked");
                $scope.selectedArray = _.without($scope.selectedArray, branch);
            }
            if ($scope.selectedArray.length === 1) {
                $scope.selectedObj = $scope.selectedArray[0];
                PHD.appliance_sid = $scope.selectedObj.system_id;
            } else {
                $scope.selectedObj = null;
                PHD.appliance_sid = 1;
            }

            $scope.Assets.updateButtons();
        };
        $scope.my_tree = tree = {};
        $scope.expanding_property = {
            field: "name",
            displayName: "Name",
            sortable : true,
            filterable: true
        };

        var credentialsTemplate = '<span tooltip="{{row.branch[col.field] == \'(Unnamed)\' ? \'Unnamed credentials are only for this asset and cannot be assigned to others.\' : row.branch[col.field]}}" tooltip-append-to-body="true" tooltip-trigger:"focus">{{row.branch[col.field]}}</span>';

        $scope.col_defs = [
            {
                field: "ip",
                displayName: "Address",
                sortable : true,
                sortingType : "string",
                filterable: true
            },
            {
                field: "description",
                displayName: "Description",
                sortable : true,
                sortingType : "string"
            },
            {
                field: "credential_display",
                displayName: "Credentials",
                sortable : true,
                sortingType : "string",
                cellTemplate: credentialsTemplate
            },
            {
                field: "retention",
                displayName: "Retention",
                sortable : true,
                sortingType : "string"
            },
            {
                field: "version",
                displayName: "Agent Version",
                sortable : true,
                sortingType : "number"/*,
                cellTemplate: '<div   style="padding-left:25px;padding-top:5px;" ng-click="cellTemplateScope.click(row.branch ,row.branch[col.field])"><span style="font-size:11px;padding-left:5px;padding-right: 5px;font-weight:normal">{{(row.branch[col.field])}}</span><i  tooltip="Agent update available" style="color:green" ng-class="(row.branch[col.field]).getType()!=\'object\' ? \'hide-icon\' : \'icon-upload\'"></i></div>',
                cellTemplateScope :{
                    click:function(rowdata , version) {    
                            // this works too: $scope.someMethod;
                             if(typeof(version) != 'undefined'){
                                console.log(rowdata);
                                console.log(version);
                                $scope.updateSelectedAgent(version);   
                             }
                             
                     }
                }*/
            },
            {
                field: "system_name",
                displayName: "Appliance",
                sortable : true,
                sortingType : "string"
            }
        ];
        $scope.displayAll = function() {
            $scope.display = 'All';
            $scope.protectedAssetsDataArr = $scope.protectedAssetsAllDataArr;
            $timeout(function() {
                $scope.tree_data = $scope.protectedAssetsDataArr;
            });
        };

        $scope.displayVirtual = function() {
            $scope.display = 'Virtual';

            var virtualassets = ($scope.protectedAssetsAllDataArr).filter(function(obj){
                var isHyperV = false;
                if(obj.children) {
                    for (var i = 0; i < obj.children.length; i++) {
                        if (obj.children[i].type === "Hyper-V") {
                            isHyperV = true;
                            break;
                        }
                    }
                }
                return obj.asset_type && (obj.asset_type != ASSET_TYPE_PHYSICAL
                    || (obj.asset_type === ASSET_TYPE_PHYSICAL && (obj.is_hyperv_cluster || isHyperV) ));
            });

            $scope.protectedAssetsDataArr = virtualassets;
            $scope.tree_data = virtualassets;
        };

        $scope.displayPhysical = function() {
            $scope.display = ASSET_TYPE_PHYSICAL;
            var physicalassets = ($scope.protectedAssetsAllDataArr).filter(function(obj){
                return obj.asset_type && obj.asset_type === ASSET_TYPE_PHYSICAL;
            });

            $scope.protectedAssetsDataArr = physicalassets;
            $scope.tree_data = physicalassets;
        };

        $scope.launchCredentialManager = function(followFunction) {
            ngDialog.open({
                template: 'app/configure/credentials/credentials.html',
                scope: $scope,
                overlay:true,
                name: 'Credential-Manager',
                ngDialogStyle:'width:700px; height:550px;',
                closeByDocument: false,
                closeByEscape: false,
                preCloseCallback: function (value) {
                    if ( followFunction != undefined ) {
                        followFunction();
                    }
                }
            });
        };

        $scope.launchAssetManager = function() {
            if(!$scope.button_allowed){                 //Set in updateButtons() function
                return false;
            }
            if($scope.tableView) {
                var assets = $scope.selectedArray;
            } else {
                var assets = [$scope.selectedAssets];
            }
            if (assets !== undefined) {
                if (assets.length > 1) {
                    console.log("selected > 1 asset");
                    ngDialog.open({
                        template: 'app/configure/environments/edit-multiple-assets.html',
                        scope: $scope,
                        overlay:true,
                        name: 'Edit-Assets',
                        data: assets,
                        ngDialogStyle:'width:600px;',
                        closeByDocument: false,
                        closeByEscape: true
                    });
                } else if (assets.length === 1) {
                    var asset = assets[0];
                    console.log("asset type:" + asset.asset_type);
                    var edit_url, title;
                    if(asset.name.endsWith(NAS_POSTFIX) || asset.os_type == ASSET_TYPE_NDMP) {
                        edit_url = "app/configure/environments/add-edit-nas.html";
                        title = "Edit NAS";
                        $scope.assetList=asset;
                        $analytics && $analytics.eventTrack(title, {  category: 'Configure', label: 'Protected Assets' });
                        ngDialog.open({
                            template: 'app/configure/environments/addEditNas.html',
                            scope: $scope,
                            overlay:true,
                            data:asset,
                            modelDialogId:'add-edit-nas-dailog',
                            ngDialogStyle:'width:600px;',
                            ngDialogPostionStyle:'top:40px;',
                            preCloseCallback: function (value) {}
                                
                        });
                        $scope.isEdit=true;
                        if(asset.os_type == ASSET_TYPE_NDMP) {
                            $scope.isNDMP= true;
                        } else {
                            $scope.isNDMP = false;
                        }
                        associatedAppliance = asset.system_id;
                        serverEdit = true;
                        EditDisabled = true;
                    } else if(asset.asset_type == ASSET_TYPE_VMWARE_HOST || asset.asset_type == ASSET_TYPE_XEN){
                        ngDialog.open({
                            template: 'app/configure/environments/add-edit-hypervisor.html',
                            scope: $scope,
                            overlay:true,
                            data: assets,
                            name: 'Edit-Hypervisor',
                            ngDialogStyle: 'width:600px;',
                            ngDialogPostionStyle:'top:40px;',
                            closeByDocument: false,
                            closeByEscape: true
                        });

                       /* edit_url = "app/configure/environments/" +  "add-edit-hypervisor.html" ;
                        title =  "Edit Virtual Host";
                        $analytics && $analytics.eventTrack(title, {  category: 'Configure', label: 'Configure' });
                        var height =  500 ;
                        PHD.wizard(edit_url, "manage-asset", {
                            title: gettext(title),
                            helpArticle: PHD.App.getHelpLink("editasset", true),
                            width: 635,
                            height: height,
                            open: function (event, ui) {
                                $("#id_server").val(asset.name);
                                $("#id_os_type").val(asset.asset_type);
                                $("#id_ip").val(asset.ip);
                                $("#edit_object_id").text(asset.id);
                                $("#id_enabled").prop('checked', asset.is_enabled);
                                $("#id_encrypted").prop('checked', asset.is_encrypted);
                                associatedAppliance = asset.system_id;
                                serverEdit = true;
                                selectedCredential = asset.credentials != undefined ? asset.credentials.credential_id : 0;
                                if(asset.description === "VMware Host"){
                                    EditDisabled = true;
                                }
                                else{
                                    EditDisabled = false;
                                }
                            }
                        });*/
                    } else if (asset.asset_type == ASSET_TYPE_PHYSICAL) {
                        ngDialog.open({
                            template: 'app/configure/environments/EditAsset.html',
                            scope: $scope,
                            overlay:true,
                            name: 'Edit-Server',
                            data: asset,
                            ngDialogStyle:'width:600px;top:-5em;',
                            closeByDocument: false,
                            closeByEscape: true
                        });
                    } else {
                        console.log("minimal asset dialog for apps");
                        ngDialog.open({
                            template: 'app/configure/environments/edit-multiple-assets.html',
                            scope: $scope,
                            overlay:true,
                            name: 'Edit-Assets',
                            data: assets,
                            ngDialogStyle:'width:600px;',
                            closeByDocument: false,
                            closeByEscape: true
                        });
                    }
                }
            }
            return true;
        };

        $scope.installAgent = function() {
            var selected = $scope.Assets.selectedArray;
            var confirm = PHD.confirmDialog(
                "<p>"+gettext("Are you sure you want to push an agent to the selected assets?")+"</p>",
                { title: gettext("Confirm Agent Push") }
            );

            confirm.done(function() {
                selected.forEach(function(asset, index) {
                    var url = "/api/clients/agent-push";
                    var data = [];
                    obj = {};
                    obj.id = asset.id;
                    obj.system_id = asset.system_id;
                    obj.address = asset.ip;
                    obj.credential_id = asset.credential_id;
                    data[0] = obj;
                    var clientArray = {};
                    clientArray.clients = data;
                    data = JSON.stringify(clientArray);
                    PHD.Ajax.put(url, data)
                        .done(function (data) {
                            ;
                        });
                });
            });

        };

        $scope.addServer = function(add, selectedID) {
            var edit = (add == 0);
            ngDialog.open({
                template: 'app/configure/environments/AddAsset.html',
                scope: $scope,
                overlay:true,
                name: 'Add-Server',
                id:'addAssetDialogID',
                ngDialogPostionStyle:'top:60px;',
                ngDialogStyle: 'width:600px;',
                closeByDocument: false,
                closeByEscape: true
            });
            return true;
        };

        $scope.updateSelectedAgent = function (selected){
            var agentSelection = "  Assets that support agent update must be selected at the top-most level, not their applications, databases, or virtual machines.";
            var noneSelectedMessage = "No agent-based assets were selected for update." + agentSelection;
            $scope.clientsList=[];
            var skipped = 0;
            if(selected == 0 ){
                if ($scope.selectedArray.length > 0){
                    $scope.updateAgentMessage="Agent software will be updated on the selected asset(s).";
                    for (var i =0 ;i <$scope.selectedArray.length;i++){
                        var asset = $scope.selectedArray[i];
                        if (asset.asset_type == "physical") {
                            var obj={};
                            obj.client_id =$scope.selectedArray[i].id;
                            obj.system_id =$scope.selectedArray[i].system_id;
                            if (typeof($scope.selectedArray[i].credentials) != 'undefined' && $scope.selectedArray[i].credentials !== null){
                                obj.credential_id =$scope.selectedArray[i].credentials.credential_id;
                            }
                            $scope.clientsList.push(obj);          
                        } else {
                            skipped++;
                        }
                    }
                    if ($scope.clientsList.length > 0) {
                        if (skipped) {
                            $scope.updateAgentMessage += "  One or more selections of non agent-based assets were skipped." + agentSelection;
                        }
                        $scope.openDialogForAgentUpdate();                      
                    } else {
                        ngDialog.open({
                            dialogType: 'ERROR',
                            dialogMessage: noneSelectedMessage,
                            overlay:true
                        });
                    }
                } else {
                    ngDialog.open({
                        dialogType: 'ERROR',
                        dialogMessage: noneSelectedMessage,
                        overlay:true
                    });
                }
                
            } else if (selected == 1){
                 $scope.updateAgentMessage="Agent software will be updated on all assets with an available agent update.";
                for (var i =0 ;i <$scope.protectedAssetsDataArr.length;i++){
                    asset = $scope.protectedAssetsDataArr[i];
                    if (asset.asset_type == "physical") {
                        var obj={};
                        obj.client_id =$scope.protectedAssetsDataArr[i].id;
                        obj.system_id =$scope.protectedAssetsDataArr[i].system_id;
                        if (typeof($scope.protectedAssetsDataArr[i].credentials) != 'undefined' && $scope.protectedAssetsDataArr[i].credentials !== null){
                            obj.credential_id =$scope.protectedAssetsDataArr[i].credentials.credential_id;
                        }
                        $scope.clientsList.push(obj);                      
                    }
                }
                if ($scope.clientsList.length > 0) {
                    $scope.openDialogForAgentUpdate();
                } else {
                    ngDialog.open({
                        dialogType: 'ERROR',
                        dialogMessage: noneSelectedMessage,
                        overlay:true
                    });
                }
            }else{
                $scope.updateAgentMessage="Agent software will be updated on the selected asset.";
              //  $scope.openDialogForAgentUpdate();
                 console.log(selected)
            }
        };
        $scope.openDialogForAgentUpdate = function(){
            ngDialog.open({
                template: 'app/configure/protected-assets/agent-update.html',
                scope: $scope,
                modelDialogId:'agent-update-dialog',
                id:'agent-update'
            });

        };
        $scope.updateAgents = function(){
            ngDialog.close('agent-update-dialog');
           
            var dataObject = {
                'clients':$scope.clientsList
            }
            var load = PHD.showLoadingIndicator('body', true, "Agent update in progress.");
            $http({
                       url: '/api/clients/agent-push', 
                       data: JSON.stringify(dataObject),
                       method: 'PUT'
                    }).success(function(data, status, headers){
                        $scope.errorListDisplay=[];
                        PHD.hideLoadingIndicator(load);
                        for (key in data){
                            if (typeof(data[key].message) !='undefined' && data[key].message != 'Latest available agent version is installed'){
                                var obj ={}
                                obj.client=data[key].client;
                                obj.message=data[key].message;
                                $scope.errorListDisplay.push(obj);
                            }

                        }
                        console.log($scope.errorListDisplay);
                        if($scope.errorListDisplay.length ==0){
                            var message = "Latest available agent version is installed";
                            ngDialog.open({
                                    dialogType: 'Success',
                                    dialogMessage: message
                            });

                        }else{
                            ngDialog.open({
                                template: 'app/configure/protected-assets/agent-update-messages.html',
                                scope: $scope,
                                modelDialogId:'agent-update-error-message',
                                id:'agent-update-error-message'
                            });    
                        }
                        
                       
                    }).error(function(response){
                        console.log(response);
                         PHD.hideLoadingIndicator(load);
                        ngDialog.open({
                            dialogType: 'ERROR',
                            dialogMessage: data,
                            overlay:true
                        });
                       
                    });
            
        }
		$scope.addHost = function(add, selectedID) {
            var edit = (add == 0);
            var dialogStyle = 'width:600px;height:' + ($rootScope.isCE ? '470px' : '645px');
            ngDialog.open({
                template: 'app/configure/environments/add-edit-hypervisor.html',
                scope: $scope,
                overlay:true,
                name: 'Add-Hypervisor',
                id:'addHostDialogID',
                ngDialogStyle: 'width:600px;',
                closeByDocument: false,
                closeByEscape: true
            });
            /*serverEdit = false;
            var id = selectedID || null;
            var resp = PHD.Ajax.get('/api/credentials/?sid=' + self.selectedID);
            resp.done(function(data){
                var credentialList = data.data;
                var title = gettext("Add Virtual Host");
                PHD.wizard("app/configure/environments/add-edit-hypervisor.html", "add-host", {
                    title: title,
                    helpArticle: PHD.App.getHelpLink("addasset", true),
                    width: 635,
                    height: 500,
                    beforeClose: function (event, ui) {
                        if(resetTour){
                            $analytics && $analytics.eventTrack(title, {  category: 'Configure', label: 'Product Tour' });
                            var $scope = $("[ng-controller=GlobalCtrl]").scope();
                            $scope.user.showTour = true;
                            refreshPage();
                            setTimeout(function(){
                                window.location.href = "#/dashboard/";
                                resetTour = false;
                            }, 1000);
                        } else {
                            $analytics && $analytics.eventTrack(title, {  category: 'Configure', label: 'Protected Assets' });
                        }
                    }
                });
            });*/
            return true;
        };

        $scope.addNAS = function(add, selectedID) {
            var edit = (add == 0);
            $scope.isEdit=false;
            ngDialog.open({
                template: 'app/configure/environments/addEditNas.html',
                scope: $scope,
                overlay:true,
                modelDialogId:'add-edit-nas-dailog',
                ngDialogStyle:'width:600px;',
                preCloseCallback: function (value) {}
            });
            return true;
        };

        $scope.addCiscoUCSManager = function(add, selectedID) {
            var edit = (add == 0);
            ngDialog.open({
                template: 'app/configure/environments/AddCiscoUCS.html',
                scope: $scope,
                overlay:true,
                name: 'Add-Cisco-UCS',
                id:'addCiscoUCSDialogID',
                ngDialogPostionStyle:'top:60px;',
                ngDialogStyle: 'width:600px;',
                closeByDocument: false,
                closeByEscape: true
            });
            return true;
        };

        $scope.deleteAssetDialog = function() {
            if ($scope.selectedObj) {
                var asset_type = $scope.selectedObj.asset_type;
                if (asset_type == ASSET_TYPE_PHYSICAL || asset_type == ASSET_TYPE_VMWARE_HOST || asset_type == ASSET_TYPE_XEN) {
                    var confirm = PHD.confirmDialog(
                        "<p>"+gettext("Are you sure you want to remove this asset?")+"</p>",
                        { title: gettext("Confirm Asset Removal") }
                    );
                    confirm.done($.proxy($scope.Assets.kill, $scope.Assets));
                } else {
                    PHD.alert("Discovered assets (for example, a virtual machine or database) cannot be removed.");
                }
            } else {
                PHD.alert("You must select one and only one asset at a time for deletion.");
            }
        };

        $scope.deleteAsset = function(){
            var httpMethod = 'delete';
            var url = '/api/clients/'+$scope.selectedObj.id+'/?sid='+$scope.selectedObj.system_id;
             
            var asset_type = $scope.selectedObj.asset_type;
            if (asset_type == ASSET_TYPE_PHYSICAL || asset_type == ASSET_TYPE_VMWARE_HOST || asset_type == ASSET_TYPE_XEN) {
                $http({
                    method: httpMethod,
                    url : url
                }).success(function(status, headers){
                    var newassets = $scope.protectedAssetsAllDataArr;
                    for (var i = 0; i < newassets.length; i++) {
                        if (newassets.id === $scope.selectedObj.id) {
                            delete newassets[i];
                        }
                    }
                    $scope.protectedAssetsDataArr = newassets;
                    $scope.tree_data = newassets;
                    $scope.Assets.updateAssets;
                    $(document).trigger("assetChange");
                    ngDialog.open({
                        dialogType:'information',
                        dialogMessage: $scope.selectedObj.name + " asset removed successfully."
                    });
                }).error(function(response) { 
                        ngDialog.open({
                        dialogType:'Error',
                        dialogMessage:response.result[0].message
                    });
                });
            } else { 
                     ngDialog.open({
                         dialogType:'Warning',
                         dialogMessage: 'Discovered assets (for example, a virtual machine or database) cannot be removed."'
                  });
                }
        };

        $scope.deleteAssetConfirmationDialog = function() {
            if ($scope.selectedObj) {
                $scope.deleteTitle = 'Confirm Asset Removal';
                $scope.confirmMessage1 = 'Are you sure want to delete asset ' + $scope.selectedObj.name + '?';
                $scope.confirmMessage2 = 'When an asset is removed, all of its backups are deleted (backup copies are not deleted).';
                $scope.confirmMessage3 = 'I understand that removing this asset will also delete all of its backups.';
                $scope.submitButtonText = 'Remove Asset and Delete backups';

                ngDialog.open({
                    template: 'app/common/confirmationDialog.html',
                    scope: $scope,
                    overlay:true,
                    ngDialogStyle:'width:600px;height:250px',
                    closeByDocument: false,
                    closeByEscape: true
                });
            } else {
                  ngDialog.open({
                         dialogType:'Warning',
                         dialogMessage: 'You must select one and only one asset at a time for deletion.'
                  });
            }
        };
        function processAssets(PHD, window) {
            var cellFormatter = {
                credentials: function (value, row) {
                    var display_name = row.credentials != undefined && row.credentials.display_name != undefined ? row.credentials.display_name : "None";
                    return display_name;
                }
            };

            var Assets = function($el) {
                $scope.el = $el;
                this.$el = $el;
                this.dbid = this.$el.data("dbid");
                this.$header = $el.children(".environment-header");

                this.$buttons = $el.find(".button-bar a");
                $scope.buttons = this.$buttons;
                this.$options = this.$buttons.filter(".btn-environment-options");
                this.$el.find(".btn-group-display").flyout();
                this.$el.find(".btn-group-add-asset").flyout();
                this.$el.find(".btn-group-update-agent").flyout();

                this.appliancesInit = false;

                this.assets = [];
                this.$selectedAppliance = $();
                this.selectedID = null;
                $scope.selectedID = null;

                this.applianceProcess = null;
                this.detailProcess = null;

                this.timestamp = 0;
                this.refreshInterval = null;
                this.isActive = false;

                this.loadingIndicator = null;
            };

            Assets.prototype.init = function() {
                var self = this;

                this.initButtons();

                /*this.$applianceTable
                    .on("loadfinished updatefinished", function(event, newRows, DataTable) {
                        self.$applianceTable.scrollTable({"height": ".environment-assets"});
                        if(event.type === "loadfinished" && self.assets.length) {
                            //self.AssetsTable.selectByID(self.appliances[0].id);
                        }
                    }); */

                return this;
            };

            Assets.prototype.initButtons = function() {
                var self = this;
                return this;
            };

            Assets.prototype.updateButtons = function() {
                console.log("need to use scope to enable/disable buttons here.");
                /*this.$buttons.filter(".btn-edit-storage")
                    .toggleButton(this.selectedID && this.selectedStorageID && !this.$selectedStorage.is(".sync-status-pending"));
                this.$buttons.filter(".btn-remove-storage")
                    .toggleButton(this.selectedID && this.selectedStorageID && !this.$selectedStorage.is(".sync-status-pending"));
                this.$buttons.filter(".btn-edit-nic").toggleButton(this.selectedID && this.selectedNicID); */

                // Enable Edit button when 1 asset is selected.
                // Disable in case of: multiple assets are selected at level 1, Or Multiple assets at level 2 (enable if VMware VM's), Or multiple assets at multiple levels
                if($scope.selectedArray.length > 1){
                    var index, system_id = $scope.selectedArray[0].system_id, assetType = $scope.selectedArray[0].asset_type;
                    for (index = 0; index < $scope.selectedArray.length; ++index) {
                        if($scope.selectedArray[index].level === 1){
                            this.$buttons.filter(".settings-edit-assets").toggleButton();
                            $scope.button_allowed = false;
                            break;
                        }
                        else if(system_id !== $scope.selectedArray[index].system_id){
                            this.$buttons.filter(".settings-edit-assets").toggleButton();
                            $scope.button_allowed = false;
                            break;
                        }
                        else if($scope.selectedArray[index].level === 2 && ($scope.selectedArray[index].asset_type !== "VMware:VM" || typeof ($scope.selectedArray[index].asset_type) === "undefined")){
                            this.$buttons.filter(".settings-edit-assets").toggleButton();
                            $scope.button_allowed = false;
                            break;
                        }
                        else if($scope.selectedArray[index].level === 3 && (typeof ($scope.selectedArray[index].asset_type) === "undefined")){
                            this.$buttons.filter(".settings-edit-assets").toggleButton();
                            $scope.button_allowed = false;
                            break;
                        }
                        else{
                            this.$buttons.filter(".settings-edit-assets").toggleButton(true);
                            $scope.button_allowed = true;
                        }
                    }
                }
                else{
                    this.$buttons.filter(".settings-edit-assets").toggleButton(true);
                    $scope.button_allowed = true;
                }
                return this;
            };


            Assets.prototype.refresh = function(fn, updateDetails) {
                var self = this;
                if(this.isActive) {
                    fn = fn || this.updateAssets;
                    updateDetails = !(updateDetails === false);

                    this.applianceProcess = this.fetchAssets(fn);

                    $.when(this.applianceProcess).done(function() {
                        self.applianceProcess = null;
                        //if(!self.selectedID && self.appliances.length) self.AssetsTable.selectByID(self.appliances[0].state.id);
                        //if(!self.selectedID && self.assets.length) self.AssetsTable.selectByID(self.assets[0].id);
                        //self.setRefreshInterval();
                    });
                }
            };

            Assets.prototype.fetchAssets = function(fn) {
                if(!_.isFunction(fn)) {
                    fn = this.buildAssets;
                }

                this.loadingIndicator = PHD.showLoadingIndicator($("#config-assets"), false);
                return PHD.Ajax
                    .get("/api/assets/", this.loadingIndicator)
                    .done($.proxy(fn, this));
            };

            $scope.protectedAssetsDataArr = [];
            $scope.protectedAssetsAllDataArr = [];
            $scope.selectedAssets = [];
            Assets.prototype.buildAssets = function(data) {
                if(data) {
                    this.assets = data.data;
                    this.assets.forEach(function(asset, index) {
                       asset.description = (asset.os_type != undefined) ? asset.os_type : asset.asset_type;
                    });
                    $scope.selectedArray = [];
                    $scope.protectedAssetsAllDataArr = this.assets;
                    if($scope.display == ASSET_TYPE_PHYSICAL){
                        $scope.displayPhysical();
                    } else if($scope.display == 'Virtual'){
                        $scope.displayVirtual();
                    } else {
                        $scope.displayAll();
                    }

                    $scope.selectedAssets = $scope.protectedAssetsDataArr[0];
                    if ($scope.selectedAssets !== undefined) {
                        $scope.selectedID = $scope.selectedAssets.id;
                    } else {
                        $scope.selectedID = null;
                    }
                    if ($scope.protectedAssetsDataArr[0] !== undefined && $scope.protectedAssetsDataArr[0].id !== undefined) {
                        $("#" + ($scope.protectedAssetsDataArr[0].id)).css("background-color","#f5f5f5");
                    }
                }
                if(this.applianceProcess) this.applianceProcess.resolve();
            };

            Assets.prototype.updateAssets = function(data) {
                if(data) {
                    this.assets = data.data;
                    this.assets.forEach(function(asset, index) {
                        asset.description = (asset.os_type != undefined) ? asset.os_type : asset.asset_type;
                    });
                    this.timestamp = data.timestamp;
                    $scope.selectedArray = [];
                    $scope.protectedAssetsAllDataArr = this.assets;
                    if($scope.display == ASSET_TYPE_PHYSICAL){
                        $scope.displayPhysical();
                    } else if($scope.display == 'Virtual'){
                        $scope.displayVirtual();
                    } else {
                        $scope.displayAll();
                    }
                }
                if(this.applianceProcess) this.applianceProcess.resolve();
            };

            Assets.prototype.isReady = function() {
                return this.isActive && (this.applianceProcess === null || this.applianceProcess.state() === 'resolved') &&
                    (this.detailProcess === null || this.detailProcess.state() === 'resolved');
            };

            Assets.prototype.setButtonLock = function(locked) {
                this.$buttons.each(function() {
                    $(this).toggleButton(!locked);
                });
            };

            Assets.prototype.initAssets = function() {
                this.refresh(this.buildAssets);
                this.appliancesInit = true;
                return this;
            };

            Assets.prototype.kill = function() {
                var self = this,
                    url = "/api/clients/" + $scope.selectedObj.id + "/?sid=" + $scope.selectedObj.system_id;
                //UNIBP-1708 added loding indicator while removing
                var deleteProtectedAsset = PHD.showLoadingIndicator("body", true, "Removing...");
                var resp = PHD.Ajax.delete(url, null, deleteProtectedAsset);
                resp.done(function(data) {
                    $analytics && $analytics.eventTrack('Delete Asset', {  category: 'Configure', label: 'Configure' });
                    self.selectedID = null;
                    PHD.hideLoadingIndicator(deleteProtectedAsset);
                    self.refresh(self.fetchAssets);
                });
            };

            Assets.prototype.activate = function() {
                this.isActive = true;
                if(!this.appliancesInit) {
                    this.initAssets();
                } else {
                    this.refresh(this.updateAssets);
                }
                return this;
            };

            Assets.prototype.deactivate = function() {
                this.isActive = false;
                clearInterval(this.refreshInterval);
                return this;
            };

            var AssetsTab = function(index, $panel) {
                this.index = index;
                this.$panel = $panel;
                this.$assetsArea = this.$panel.children("#assets-list");
                this.$environments = null;
                this.environmentList = {};
                this.activeEnvironment = null;
                this.isActive = false;
                this.isBootstrapped = false;
            };

            AssetsTab.prototype.bootstrap = function(data) {
                this.$environments = this.$assetsArea.find(".environment");
                this.environmentList = new Assets(this.$environments).init();
                $scope.Assets = this.environmentList;
                this.activeEnvironment = this.environmentList; //this.environmentList.activate();
                this.isBootstrapped = true;
            };

            AssetsTab.prototype.init = function() {
                var self = this;
                $(document)
                    .on("assetChange", function(event, dbid) {
                        if ($scope.Assets !== undefined && $scope.Assets.appliancesInit !== undefined) {
                            if(!$scope.Assets.appliancesInit) {
                                $scope.Assets.initAssets();
                            } else {
                                $scope.Assets.refresh($scope.Assets.updateAssets);
                            }
                        }
                    });

                return this;
            };

            AssetsTab.prototype.activate = function() {
                this.isActive = true;
                if(!this.isBootstrapped) {
                    this.bootstrap();
                }
                if(this.activeEnvironment) {
                    this.activeEnvironment.activate();
                }
                return this;
            };

            AssetsTab.prototype.deactivate = function() {
                this.isActive = false;
                if(this.activeEnvironment) {
                    this.activeEnvironment.deactivate();
                }
                return this;
            };
            
            Assets.prototype.setSelectedAssets = function(selectedId){
                var self = this;
                
                $scope.listViewFlag = true;

                this.$selectedAppliance = $scope.el;
                this.selectedID = selectedId;

                /*var x = this.AssetsTable.$table[0].rows;
                for (var i = 1; i < x.length; i++) {
                    
                    var rowDetails = x[i];
                    
                    if((parseInt(x[i].dataset.dbid)) == selectedId){
                        if(!($(x[i]).hasClass("current-row"))){
                            $(x[i]).addClass("current-row");
                            $scope.selectedID = selectedId;
                            this.$selectedAppliance = $(x[i]);
                            this.selectedID = selectedId;
                        }
                        
                    }else{
                        if($(x[i]).hasClass("clickable current-row")){
                            $(x[i]).removeClass("current-row");
                        }
                    }
                }
                
                this.AssetsTable.$table[0].rows = x;*/
                self.updateButtons();
            };
            
            $scope.selectProtectedAssetsFromList = function(selectedId){
                var arrLength=($scope.protectedAssetsDataArr).length;

                for (var i=0; i < arrLength; i++){
                    if ($scope.protectedAssetsDataArr[i].id===selectedId){
                       $scope.selectedAssets = $scope.protectedAssetsDataArr[i];
                        $scope.selectedObj = $scope.selectedAssets;
                        PHD.appliance_sid = $scope.selectedObj.system_id;
                       $("#" + selectedId).css("background-color","#f5f5f5");
                       $scope.selectedID = selectedId;
                    }else{
                        $("#" + $scope.protectedAssetsDataArr[i].id).css("background-color","#fff");
                    }
                }
                
                Assets.prototype.setSelectedAssets(selectedId);
            };

            PHD.AssetsTab = AssetsTab;
        }

        // Initialize the controller.
        $scope.initCtrl();
    }]);