/* Backup Widget Contorller */
angular.module('backupCopyWidgetWidgetModule',['dynamicdashboardapp','ui.dashboard'])
.controller('backupCopyWidgetContorller', function ($scope,$rootScope, $http){
    $scope.widgetName="Backup Copy";
    $scope.modalShown=false;
    $scope.refreshKey="dash_replication_refresh";
    $scope.daysArray=["7/30","7/31","8/1","8/2","8/3","8/4","8/5"];
    $scope.maxValueArray=[];
    $scope.maxvalue=6;
    $scope.maxValuewithUnits="6 GB/s";
    $scope.dataValues=[[1,1,2,3,4,5,6]];
    $scope.units="MB/s";
    $scope.colorArray =["rgb(40,155,212)", "rgb(139,186,84)"];
    $scope.legends=["Logical", "Physical"]; //["Data Transferred"];
    $scope.reSizeGraph=true;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };
    $scope.runReport = function(reportID, days, sid) {
        days = days || 0;
        sid = sid || 0;
        location.href = "#/reports/" + reportID + '/' + days + '/' + sid;
    };
     $rootScope.targetOptions=[
     { id : 0,  name: "All Targets" }
     ]
      $rootScope.target = {
          id: 0
        };
    $scope.backupCopyProtected=12;
    $scope.backupCopyErrors=1;
	$scope.$on('dialogopenEvent', function (event, widget,index){
         if(widget.name === 'BACKUP COPY - HOT TARGETS'){
            $scope.toggleModal();
             $("[id='id_backup copyRefresh']").val($rootScope.listOfTimer[6]/1000);
			event.defaultPrevented = true;
        }
    });
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'BACKUP COPY - HOT TARGETS'){
		$rootScope.getBackupCopyRefereshData();
		event.defaultPrevented = true;
		    
        }
    });
    
    $rootScope.getBackupCopyRefereshData = function(days){
         $http({
            method: 'GET',
            url: '/api/summary/counts/replication/'
        }).success(function(data, status, headers) {
            //var timestamp=data.timestamp *1000;
            $scope.timeStamp = data.last_updated;//getDateString(timestamp);
            $scope.errors=data.replication_errors;
            $scope.protected=data.replication_protected;
        }).error(function(data, status, headers) {
            console.log('api_summary_days_replication_error');
        });
	}
    $scope.getBackupCopyAverageSpeed = function(days){
        //$scope.averageSpeed="1.56 TB";
        var total=0;
        days =days ||7;
        url ='/api/summary/days/replication/?days='+days;
        $http({
            method: 'GET',
            url: url
        }).success(function(data, status, headers) {
            var avgSpeedArray=data.data[0].replication_speed;
            var dataArray=[];
            var readArray=[];
            var daysArray=[];
            for (var i =0 ; i < avgSpeedArray.length; i++){
                if (i == 0){
                    $scope.units=avgSpeedArray[i].units;
                }
                total +=avgSpeedArray[i].read;
                dataArray[i]=avgSpeedArray[i].write;
                readArray[i] = avgSpeedArray[i].read;
                daysArray[i]=avgSpeedArray[i].day.substring(5,avgSpeedArray[i].day.length).replace("-","/");
            }

            $scope.averageSpeed=(total/7).toFixed(1);
            $scope.dataValues=[readArray, dataArray];
            $scope.daysArray=daysArray;
            $scope.maxvalue=Math.max.apply(Math,readArray);
            $scope.maxValuewithUnits=$scope.maxvalue+$scope.units;
            var avgspeed_width = $('#backup-copy-graph-avgspeed').width();
            var raph_avgspeed=Raphael('backup-copy-graph-avgspeed',"100%","100%");
            plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,
                $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
        }).error(function(data, status, headers) {
            console.log('api_summary_days_replication_error');
        });

    };
    $(window).on("resize", function(event){
        if ($scope.reSizeGraph == true){
            var avgspeed_width = $('#backup-copy-graph-avgspeed').width();
            $('#backup-copy-graph-avgspeed').empty();
            var raph_avgspeed=Raphael('backup-copy-graph-avgspeed',"100%","100%");
            plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,
                $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
        }
    });
    $scope.userPrefernce = function(){
		       $rootScope.manualRefreshControl($rootScope.listOfTimer[6]/1000,$scope.widgetName);
 }
    if ($scope.user.loggedIn) {
        $scope.userPrefernce();
        $rootScope.getBackupCopyRefereshData();
        $scope.getBackupCopyAverageSpeed();
    }
    $(document)
                .on("login", function(event) {
                    stopAll();
                })
                .on("logout", function(event) {
                    stopAll();
                })
                .on("uinav.dashboard", function(event) {
					stopAll();
                })
                .on("uinav.protect", function(event) {
                    stopAll();
                })
                .on("uinav.recover", function(event) {
                    stopAll();
                })
                .on("uinav.jobs", function(event) {
                    stopAll();
                })
                .on("uinav.configure", function(event) {
                    stopAll();
                })
                .on("uinav.reports", function(event) {
                    stopAll();
     });
     function stopAll() {
                clearInterval($rootScope.listOfTimerFunction[6]);
			    $scope.reSizeGraph=false;
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
	}
   
});