/* Backup Widget Contorller */
angular.module('backupCopyStorageWidgetModule',['dynamicdashboardapp','ui.dashboard'])
.controller('backupCopyWidgetStorageContorller', function ($scope,$rootScope, $http){
    $scope.widgetName="Backup Copy Storage";
    $scope.modalShown=false;
    $scope.refreshKey="dash_replication_refresh";
    $scope.daysArray=["7/30","7/31","8/1","8/2","8/3","8/4","8/5"];
    $scope.maxValueArray=[];
    $scope.maxvalue=6;
    $scope.maxValuewithUnits="6 GB/s";
    $scope.dataValues=[[1,1,2,3,4,5,6]];
    $scope.units="GB/s";
    $scope.colorArray =["rgb(40,155,212)"];
    $scope.legends=["Data Transferred"];
    $scope.reSizeGraph=true;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };
    $scope.runReport = function(reportID, days, sid) {
        days = days || 0;
        sid = sid || 0;
        location.href = "#/reports/" + reportID + '/' + days + '/' + sid;
    };
     $rootScope.targetOptions=[
     { id : 0,  name: "All Targets" }
     ]
      $rootScope.target = {
          id: 0
        };
    $scope.backupCopyProtected=12;
    $scope.backupCopyErrors=1;
	$scope.$on('dialogopenEvent', function (event, widget,index){
         if(widget.name === 'BACKUP COPY - COLD TARGETS'){
            $scope.toggleModal();
             $("[id='backup copy storage']").val($rootScope.listOfTimer[6]/1000);
			event.defaultPrevented = true;
        }
    });
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'BACKUP COPY - COLD TARGETS'){
		$rootScope.getBackupCopyStorageRefereshData();
		event.defaultPrevented = true;
		    
        }
    });
    
    $rootScope.getBackupCopyStorageRefereshData = function(days){
         $http({
            method: 'GET',
            url: '/api/summary/counts/archive/'
        }).success(function(data, status, headers) {
            //var timestamp=data.timestamp *1000;
            $scope.timeStamp = data.last_updated;//getDateString(timestamp);
            $scope.errors=data.archive_errors;
            $scope.protected=data.archive_protected;
        }).error(function(data, status, headers) {
            console.log('api_summary_days_replication_error');
        });
	}
    $scope.getBackupCopyStorageAverageSpeed = function(days){
         days =days ||7;
            url ='/api/summary/days/archive/?days='+days
        $http({
            method: 'GET',
            url: url
        }).success(function(data, status, headers) {
            var avgSpeedArray=data.data[1].archive_speed;
            var dataTransfered=data.data[0].archive_size;
            var dataArray=[];
            var daysArray=[];
            var total = 0;
             for (var i =0 ; i < avgSpeedArray.length; i++){
               if (i == 0){
                   $scope.units=dataTransfered[i].units;
                   $scope.speedUnits=avgSpeedArray[i].units;
               }
               dataArray[i]=dataTransfered[i].write;
               daysArray[i]=dataTransfered[i].day.substring(5,dataTransfered[i].day.length).replace("-","/");
              total += avgSpeedArray[i].avg_speed;
		  }
          $scope.averageSpeed=(total/7).toFixed(2);
          $scope.dataValues=[dataArray];
          $scope.daysArray=daysArray;
          $scope.maxvalue=Math.max.apply(Math,dataArray);
          $scope.maxValuewithUnits=$scope.maxvalue+$scope.units;
          var avgspeed_width = $('#backup-copy-storage-graph-avgspeed').width();
          var raph_avgspeed=Raphael('backup-copy-storage-graph-avgspeed',"100%","100%");
          plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,     $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
        }).error(function(data, status, headers) {
            console.log('api_summary_days_archive_error');
        });
	
	}
   $(window).on("resize", function(event){
		    if ($scope.reSizeGraph == true){
             var avgspeed_width = $('#backup-copy-storage-graph-avgspeed').width();
             $('#backup-copy-storage-graph-avgspeed').empty();
			 var raph_avgspeed=Raphael('backup-copy-storage-graph-avgspeed',"100%","100%");
             plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,     $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
            }
	});
    $scope.userPrefernce = function(){
		       $rootScope.manualRefreshControl($rootScope.listOfTimer[8]/1000,$scope.widgetName);
    }
    if ($scope.user.loggedIn) {
        $scope.userPrefernce();
        $rootScope.getBackupCopyStorageRefereshData();
        $scope.getBackupCopyStorageAverageSpeed();
    }
    $(document)
                .on("login", function(event) {
                    stopAll();
                })
                .on("logout", function(event) {
                    stopAll();
                })
                .on("uinav.dashboard", function(event) {
					stopAll();
                })
                .on("uinav.protect", function(event) {
                    stopAll();
                })
                .on("uinav.recover", function(event) {
                    stopAll();
                })
                .on("uinav.jobs", function(event) {
                    stopAll();
                })
                .on("uinav.configure", function(event) {
                    stopAll();
                })
                .on("uinav.reports", function(event) {
                    stopAll();
     });
     function stopAll() {
                clearInterval($rootScope.listOfTimerFunction[8]);
			    $scope.reSizeGraph=false;
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
	}
   
});