var storageWidgetModule = angular.module('storageWidgetModule',['dynamicdashboardapp','ui.dashboard']);

storageWidgetModule.controller('storageWidgetCtrl', ['$scope', '$rootScope', '$http', function($scope, $rootScope, $http){
    
			$scope.refreshKey="dash_storage_refresh";
			$scope.widgetName="Storage";
			$scope.dropdownvalue="0";

            var statelessInfo = PHD.Ajax.get("/api/storage/stateless/?sid=" + PHD.appliance_sid);

            statelessInfo.done(function(dataStateless) {
                $scope.isStateless = dataStateless.stateless;
            });

            var $widget = $("#widget-storage"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $storageTable = $("#dashboard-storage"),
                $storageTotalProgress = $("#storage-widget-total-progress"),
                refreshRate = refreshRates.dash_storage_refresh,
                namespace = "storagewidget",
                StorageTable, UserPreference,
                threshold_lookup = [];

            var dtOptions = {
                select: false,
                multiselect: false,
                className: "storage",
                cellClasses: ["long-text truncate", "long-text truncate", null, "table-icon-small", null, null]
            };


             function usageLookup(usage) {
                var icon = '<i class="icon-uui-backup' + ' icon-large text-standard" title="' + 'Backup' + '"></i> ';
                if (usage == 'archive') {
                    icon = '<i class="icon-uui-backup-copy icon-large text-standard" title="' + 'Backup Copy' + '"></i> ';
                }
                return icon;
            }

            var storage_icon_map = {};
            storage_icon_map[""] = "harddrive";
            storage_icon_map["internal"] = "harddrive";
            storage_icon_map["stateless"] = "harddrive";
            storage_icon_map["disk"] = "harddrive";
            storage_icon_map["iscsi"] = "harddrive";
            storage_icon_map["added_internal"] = "harddrive";

            function getStorageType(row) {
                var type = 'attached';
                var icon_name = 'harddrive';
                if (row.type === 'nas') {
                    if (row.properties !== undefined && row.properties != null) {
                        icon_name = type = row.properties.protocol;
			         }
                } else {
				    icon_name = storage_icon_map[row.type];
			    }
			    var icon = '<i class="icon-uui-' + icon_name + ' icon-large text-standard" title="' + type + '"></i>';
                return icon;
            }
            var cellFormatter = {
				name: function (value, row) {
                    return value;
                },

                icon_type: function(value, row){
                    var usageIcon = usageLookup(row.usage),
                        stoIcon = getStorageType(row);
                    return usageIcon + stoIcon;
                },
                mb_free: function (value, row) {
                    var used_allocated = "";
                    var percent_used = 0;
                    var state = "storage-";
                    if (row.mb_size !== undefined) {
                        var sizeVal = row.mb_size;
                        var freeVal = row.mb_free;
                        if (sizeVal === 0) {
                            used_allocated = "Not Available";
                            state += "unknown";
                            percent_used = 100;
                        } else {
                            var size = PHD.util.formatMB(sizeVal);
                            var used = PHD.util.formatMB(sizeVal - freeVal);
                            used_allocated = "" + used + " / " + size;
                            percent_used = ((sizeVal - freeVal) * 100.0) / sizeVal;
                            if (percent_used < STORAGE_WARNING_THRESHOLD) state += "ok";
                            if (percent_used >= STORAGE_WARNING_THRESHOLD && percent_used < STORAGE_CRITICAL_THRESHOLD) state += "warn";
                            if (percent_used >= STORAGE_CRITICAL_THRESHOLD) state += "critical";
                        }
                    }
                    return '<div class="progress-bar">' +
                                '<div class="progress-meter ' + state + '" style="width:' + percent_used + '%;">'+
                                    '<span style="width:100px;" class="tooltip tooltipstered" title="' + used_allocated + '" >aaa</span>'+
                                '</div>'+                                    
                            '</div>';
                },
                status: function (value, row) {
                    var iconClass = value === "online" ? "okcircle" : "forbidden";
                    var iconColor="";
                    if(value=="online"){
                        iconColor = '#80bc3d';
                    }else if(value != "online"){
                        iconColor = 'hsl(358, 51%, 49%)';
                    }
                    
                    var statusIcon = '<i class="icon-'+ iconClass +' icon-large"  title="' + value + '"></i>';
                    if (row.is_purging === true) {
                        var purge_title = "Purging " + PHD.util.formatMB(row.mb_to_purge);
                        statusIcon = '<i class="icon-phd-sync icon-large" title="' + purge_title + '"></i>';
                    }
                    return '<span style="color:' + iconColor + ';margin-right:2px;" class="storage-status">' + statusIcon + '</span>';
                }
            };
            
        
    
            $rootScope.getStorageData = function(init) {
              
                var resp;

                if (init === true) {
                    StorageTable = PHD.DataTable($storageTable, dtOptions);
                    StorageTable.registerFormatters(cellFormatter);
                }
                resp = PHD.Ajax.get("/api/storage/?usage=backup,archive");

                resp.done(function (data) {
                    var i;
                    if (typeof data.storage !== 'undefined') {
                        if (init === true) {
                           
                            for (i = 0; i < data.storage.length; ++i) {
                                var id = data.storage[i].id;
                                threshold_lookup[id] = {
                                    warn_threshold: (typeof data.storage[i] !== 'undefined') ? data.storage[i].warn_threshold : 0,
                                    stop_threshold: (typeof data.storage[i] !== 'undefined') ? data.storage[i].stop_threshold : 0
                                }
                            }
                            StorageTable.load(data.storage);
                        } else {
                            StorageTable.update(data.storage, true);
                        }
                    }

                    $storageTable.scrollTable({"height": ".widget-content"});

                    totals = data.totals;
                    if (typeof totals !== 'undefined') {
                        $("[data-source-total]").each(function (index) {
                            var $el = $(this),
                                key = $el.attr("data-source-total");

                            if (totals.hasOwnProperty(key)) {
                                $el.text(totals[key]);
                            }
                        });

                        $storageTotalProgress
                            .attr("title", totals["used_allocated"])
                            .children(".progress-meter").css("width", totals["percent_used"] + "%");
                    }
                    $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
				});
            }

            $scope.userPrefernce = function(){
                 $rootScope.manualRefreshControl($rootScope.listOfTimer[2]/1000,$scope.widgetName);
                $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
            }

           if ($scope.user.loggedIn) {
                $scope.userPrefernce();
                $scope.getStorageData(true);
               
            }
            $(document)
                .on("login", function (event) {
                    $scope.getStorageData(true);
                    stopAll();
                })
                .on("logout", function (event) {
                    stopAll();;
                })
                .on("uinav.dashboard", function (event) {

                })
                .on("uinav.protect", function (event) {
                    stopAll();
                })
                .on("uinav.recover", function (event) {
                    stopAll();
                })
                .on("uinav.jobs", function (event) {
                    stopAll();
                })
                .on("uinav.configure", function (event) {
                    stopAll();
                })
                .on("uinav.reports", function (event) {
                    stopAll();
                });

            function stopAll() {
                clearInterval($rootScope.listOfTimerFunction[2]);
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
            }  
            
            $scope.modalShown=false;
                $scope.toggleModal=function(){
                $scope.modalShown= !$scope.modalShown;
            };
            
            $scope.widgetID;

            /* Click Event Listener for open configure model dialog box  */
            $scope.$on('dialogopenEvent', function (event, widget, index){
               
                if(widget.name === 'STORAGE'){
                    $scope.toggleModal();
                    $scope.widgetID='ID'+index;
                    $scope.dropdownvalue = $rootScope.backupTimer /1000;
                    $('#id_storageRefresh').val($rootScope.listOfTimer[2]/1000);
					event.defaultPrevented = true;
                    $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
                    
                }
            });
            
			/* Event listener for manual;Refesh */
			$scope.$on('manualRefreshEvent', function (event, widget,index){
			    if(widget.name === 'STORAGE'){
					$scope.getStorageData(true);
					event.defaultPrevented = true;
                    $("#dashboard-storage .storage-status" ).parent().css( "text-align", "center" );
				}
			});
               
            

}]);