
function processJobsPage(PHD, window, $rootScope, $scope, $analytics) {

    var $activeJobCount = $("#active-job-count"),
        $postProcessCount = $("#post-process-count"),
        UserPreference, JobsTimer,
        tabs = [],
        initialTab = $.cookie("initial_tab_jobs") || 0,
        currentTabIndex = 0,
        DETAIL_TABLE_HEIGHT = 256,
        TOO_LARGE_FOR_SORT = 1000,
        slugs = ['active', 'manage', 'history', 'system', 'post_processing'],
        jobTypeIcon = [];
    $rootScope.isSelectedJobFileLevel  =false;
    $rootScope.isSelectedJobNAS = false;

    jobTypeIcon["replication"] = "backup-copy";
    jobTypeIcon["restore"] = "recover";
    jobTypeIcon["instant recovery"] = "instant-recover";
    jobTypeIcon["backup"] = "backup";
    jobTypeIcon["archive"] = "backup-copy";
    jobTypeIcon['backup copy'] = "backup-copy";

    function getJobIcon(jobType) {
        var icon = "unknown";
        var html;
        if (jobType !== null && jobType !== undefined) {
            jobType = jobType.toLowerCase();
            icon = jobTypeIcon[jobType];
        }
        switch (icon) {
            case "unknown":
                html = '<i class="icon-phd-unknown">' + '</i> ';
                break;
            case "backup-copy":
                html = '<i class="icon-uui-backup-copy">' + '</i> ';
                break;
            case "instant recovery":
                html = '<i class="icon-uui-instant-recover">' + '</i> ';
                break;
            case "backup":
            case "recover":
            case "restore":
            default:
                html = '<i class="icon-uui-' + jobTypeIcon[jobType] + '"></i> ';
                break;
        }
        return html;
    }

    function getJobMode(mode){
        var html = "";
        // don't put colon if undefined or archive as mode (since generic)
        if (mode !== undefined && mode != 'archive' && mode != 'Backup Copy' && mode != 'replication' && mode != 'Backup Copy (optimized)' ) {
           html = ": " + mode;
        }
        return html;
    }

    function getJobType(type, row){
        var html = "";
        if (type !== undefined) {
            switch (type) {
                case "archive":
                case "backup copy":
                    html = "Backup Copy";
                    break;
                case "replication":
                    html = "Backup Copy (" + row.target +")";
                    break;
                default:
                    html = type;
                    break;
            }
        }
        return html;
    }

    var itemMap = [];

    $rootScope.JobsTimer.refreshControl = $("#jobs-page-preferences .timer-refresh");
    JobsTimer = $rootScope.JobsTimer;

    itemMap[APP_ID_VMWARE] = "VMs";
    itemMap[APP_ID_HYPERV_2012] = "VMs";

    function setPageRefresh(interval) {
        refreshRate = interval;
        tabs.forEach(function (tab) {
            tab.setTimerInterval(refreshRate);
        });
    }

    function setActiveJobs(num) {
        $activeJobCount.html("(" + num + ")");
    }

    function setPostProcessCount(num) {
        $postProcessCount.html("(" + num + ")");
    }

    function initTabs() {
        $(".ui-tabs-panel").each(function (index) {
            tabs[index] = new JobTab(index, $(this), slugs[index]).init();
        });

        tabs[currentTabIndex].activate();
    }

    $(document)
        .on("uinav.dashboard", function (event) {
            console.log("=====>Selected Dashboard");
            stopAll();
        })
        .on("uinav.protect", function (event) {
            console.log("=====>Selected Protect");
            stopAll();
        })
        .on("uinav.recover", function (event) {
            console.log("=====>Selected Recover");
            stopAll();
        })
        .on("uinav.jobs", function (event) {
            console.log("=====>Selected Jobs");
		})
        .on("uinav.configure", function (event) {
            console.log("=====>Selected Configure");
            stopAll();
        })
        .on("uinav.reports", function (event) {
            console.log("=====>Selected Reports");
            stopAll();
        })
        .on("userpreferencesave.jobspage", function (event, key, value) {
            setPageRefresh(value);
        })
        .on("timersetmanual.jobspage", function (event, $control) {
            $control.show();
        })
        .on("timerunsetmanual.jobspage", function (event, $control) {
            $control.hide();
        });

    function stopAll() {
        JobsTimer.stop();
        $(document).off("uinav");
        $(document).off("userpreferencesave.jobspage");
        $(document).off("timertick.jobspage");
        $(document).off("timersetmanual.jobspage");
        $(document).off("timerunsetmanual.jobspage");
        delete $(document);
    }

    // lmc - move this up.
    var expandedItemsFormatter = {
        instances: function (value, row) {
            var nameArray = getJobAssets(row);
            var names = nameArray.toString();
            var formattedNames = names.replace(/,/gi, "<br/>");
            return '<span class="truncate-long" title="' + names + '">' + formattedNames + '</span>';
        },
        message: function(value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        },
        comment: function(value, row) {
            return '<span title="' + value + '">' + value + '</span>';
        }
    };

    function getJobAssets(row) {
        var assets = [];
        switch (row.app_id) {
            case APP_ID_VMWARE:
                if (row.instances !== undefined) {
                    assets = _.isArray(row.instances) ? _.pluck(row.instances, "secondary_name") : [row.instances];
                }
                break;
            case APP_ID_XEN:
                if(row.instances !== undefined) {
                    assets = assets = _.isArray(row.instances) ? _.pluck(row.instances, "secondary_name") : [row.instances];
                }
                break;
            case APP_ID_FILE_LEVEL:
                if (row.clients !== undefined && _.isArray(row.clients)) {
                    assets = _.pluck(row.clients, "name");
                }
                break;
            default:
                if (row.instances !== undefined) {
                    if (_.isArray(row.instances)) {
                        row.instances.forEach(function (obj, index) {
                            var part1 = (obj.primary_name !== undefined) ? obj.primary_name : "";
                            var part2 = (obj.secondary_name !== undefined) ?  obj.secondary_name : "";
                            var name = (part1 !== "") ? part1 + ((part2 !== "") ? "/" + part2 : "") : ((part2 !== "") ? part2 : "");
                            assets.push(name);
                        });
                    }
                }
                break;
        }
        return assets;
    }

    var JobTab = function (index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.$table = this.$panel.find(".active-table");
        this.$buttons = this.$panel.find(".button-bar");
        this.$inventory = this.$panel.find(".job-detail");
        this.$inventoryTable = this.$inventory.find("table");

        this.$dragHandle = this.$panel.find(".handle");
        this.namespace = "jobs" + slug;

        this.dataTable = PHD.DataTable(this.$table, {
            select: this.index != JOB_TAB_SYSTEM ? 'click' : false,
            scrollSelect: this.index != JOB_TAB_HISTORY,  // lmc - added to prevent scroll on row selection.
            placeholder: gettext("There are no jobs to display"),
            prefix: "job_",
            integerIDs: this.index == JOB_TAB_SYSTEM,
            sortable: true,
            cellClasses: this.index == JOB_TAB_SYSTEM ? [null, "numerical", null, null, "long-text", null] :
                         this.index == JOB_TAB_MANAGER ? [null, null, null, "long-text", null, null] : null
        }).registerFormatters(cellFormatter);

        /*if(this.index === JOB_TAB_ACTIVE || this.index === JOB_TAB_HISTORY || this.index === JOB_TAB_SYSTEM) {
         // Enable TreeTable and DataTable for job inventory detail table
         this.JobInventoryTreeTable = PHD.TreeTable(this.$inventory, {});
         this.JobInventory = PHD.JobInventory(this.$inventoryTable, this.JobInventoryTreeTable, {});
         } else {
         this.JobInventory = PHD.DataTable(this.$inventoryTable, {"select": false});
         this.JobInventory.registerFormatters(expandedItemsFormatter);
         } */
        // lmc - no hierarchy
        var inventoryTableDefaults = {
            select: false,
            sortable: true,
            cellClasses: this.index == JOB_TAB_ACTIVE ? ["numerical", null, null, "long-text truncate-wide"] :
                                                        [null, null, "truncate-long", "long-text"]
        };
        this.JobInventory = PHD.DataTable(this.$inventoryTable, inventoryTableDefaults);
        this.JobInventory.registerFormatters(expandedItemsFormatter);

        this.$buttons.find(".jobcreate-btn-group").flyout();

        this.$selected = this.$table.find(".current-row");
        this.selectedID = null;
        this.rowData = null;

        this.isActive = false;
        this.timestamp = 0;
        this.inventoryTimestamp = 0;
        this.inventoryOpen = false;
        this.sort = null;
        this.showSystem = true;

        //lmc - if Job manager, use joborders resource; otherwise use jobs resource.
        this.inventoryTableHeight = DETAIL_TABLE_HEIGHT;
        if (slug == 'manage') {
            this.url = "/api/joborders";
        } else {
            if (slug == 'history'){
                this.url = "/api/jobs/history/?showFlat=true&sort=desc&limit=" + $rootScope.jobHistoryLimit;
            } else if (slug == 'system') {
                this.url = "/api/jobs/system/?sort=desc&limit=" + $rootScope.systemJobHistoryLimit;
            }else {
                this.url = "/api/jobs/" + slug
            }
        }
    };

    JobTab.prototype.init = function () {
        var self = this;
        this.$inventory.hide();

        this.initButtons();

        // Initialize table sorting
        this.$table.sortTable({
            sort_two_dates: sort_two_dates,
            sort_duration: sort_duration
        });

        $(document)
            .on("timertick.jobspage", $.proxy(this.handleTimerTick, this))
            .on("editJob", function(event) {
                // If Job manager, update.  No need if on another tab as the tab activation will trigger a refresh.
                if (self.isActive && self.index === JOB_TAB_MANAGER) {
                    self.update();
                }
            })
            .on("limit-changed", function(event, limit_type, newValue) {
                if (self.index === limit_type) {
                    self.update();
                    console.log("limit changed: limit_type = " + limit_type + " and new value = " + newValue);
                }
            });


        // Handle events thrown by DataTable
        this.$table
            .on("rowselect", "tr.clickable", $.proxy(this.handleRowSelect, this))
            .on("rowdelete", $.proxy(this.handleRowDelete, this))
            .on("updatefinished", $.proxy(this.handleRowAddition, this));

        this.$dragHandle.dragdelta({
            autoHide: true,
            disabled: true,
            min: 360,
            max: window.innerHeight - 90
        }).on("dragdeltastop", function (event, ui) {
            //console.log(ui.delta);
            self.adjustJobDetails(ui.delta);
        });

        return this;
    };

    JobTab.prototype.handleTimerTick = function (event, timer, interval) {
        if (this.isActive) {
            this.update();
        }
    };

    JobTab.prototype.update = function (resetTable, resetTimer) {
        var self = this,
            reset = (this.timestamp === 0) || (resetTable === true),
            tableProcess, inventoryProcess;

        tableProcess = this.updateTable(reset);
        inventoryProcess = this.updateInventory(reset, this.selectedID);

        $.when(tableProcess, inventoryProcess).done(function () {
            if (reset || resetTimer) {
                JobsTimer.start();
            } else {
                JobsTimer.resume();
            }
            if (self.$table.is(":visible")) {
                self.$table.scrollTable();
            } else {
                console.log("Table not visible, no scroll.");
            }
        });
    };

    JobTab.prototype.deleteRow = function (jobID) {
        this.dataTable.deleteRow(jobID);
    }

    JobTab.prototype.updateTable = function (reset) {
        var self = this,
            url = this.getUpdateUrl(reset),
            process = $.Deferred();

        var load = (reset) ? PHD.showLoadingIndicator(this.$panel) : null;
        var request = PHD.Ajax.get(url, load);

        request.done(function (data) {
            // Only get active job count when active job API is called.
            if (currentTabIndex == JOB_TAB_ACTIVE) {
            //    var jobs = data.data;
            //    var active = (jobs !== undefined && jobs !== null) ? jobs.length : 0;
                var postprocess = 0;
             //   setActiveJobs(active);
                setPostProcessCount(postprocess);
            } else if (currentTabIndex == JOB_TAB_HISTORY) {
                $scope.limitTitle = "Recent Jobs Limits";
                $scope.currentTabIndex = 2;
                if (data.limited === true) {
                    $rootScope.jobHistoryLimitHit = " (limited to " + $rootScope.jobHistoryLimit + " Jobs)";
                    setTimeout(function () {
                        $scope.$apply();
                    }, 250);
                } else {
                    if ($rootScope.jobHistoryLimitHit !== "") {
                        $rootScope.jobHistoryLimitHit = "";
                        setTimeout(function () {
                            $scope.$apply();
                        }, 250);
                    }
                }
            } else if (currentTabIndex == JOB_TAB_SYSTEM) {
                $scope.limitTitle = "Recent System Jobs Limits";
                $scope.currentTabIndex = 3;
                if (data.limited === true) {
                    $rootScope.systemJobHistoryLimitHit = " (limited to " + $rootScope.systemJobHistoryLimit + " Jobs)";
                    setTimeout(function () {
                        $scope.$apply();
                    }, 250);
                } else {
                    if ($rootScope.systemJobHistoryLimitHit !== "") {
                        $rootScope.systemJobHistoryLimitHit = "";
                        setTimeout(function () {
                            $scope.$apply();
                        }, 250);
                    }
                }
            }
          
            if (data.timestamp === self.timestamp) {
                self.timestamp += 1;
            } else {
                self.timestamp = data.timestamp;
            }

            if (reset) {
                self.dataTable.load(data.data);
                self.$table.columnResize();
            } else {
                self.dataTable.update(data.data, true);
            }

            PHD.hideLoadingIndicator(load);

            if (!self.showSystem) {
                self.$table.find(".system-true").addClass("hidden");
            }

            self.selectRowByID();
            self.updateButtons();

            process.resolve();
            // if a reset, we have sorted on the server side, so no sort is needed.
            // if an update, check length of data before deciding to sort.
            if ( data.data.length <= TOO_LARGE_FOR_SORT) {
                    if(currentTabIndex == JOB_TAB_ACTIVE){
                        self.$table.sortTable();
                    }else if(reset){
                        self.$table.sortTable();        
                    }
                
            }
         
        });
        
        return process;
    };

    JobTab.prototype.updateInventory = function (reset, jobID) {
        var process = $.Deferred();

        if (this.inventoryOpen && this.selectedID != null && this.selectedID == jobID) {
            var self = this;
            var data;
            if (this.index === JOB_TAB_HISTORY) {
                data = [];
                if (self.rowData.backups !== undefined) {
                    console.log("in UPDATE INVENTORY");
                    data = self.rowData.backups;
                    data.forEach(function(obj, index) {
                        //obj.system_name = self.rowData.system_name;
                        obj.server = (self.rowData.app_name == "VMware") ? obj.primary_name : self.rowData.client_name;
                        obj.instance = (self.rowData.app_name == "VMware") ? obj.secondary_name :
                            (self.rowData.app_name.indexOf("Hyper-V") != -1) ? obj.primary_name : "N/A";
                        obj.app_name = (self.rowData.app_name);
                    });
                    self.JobInventory.load(data);
                    self.$inventoryTable.scrollTable({height: self.inventoryTableHeight - 6});
                    self.$inventoryTable.sortTable();
                    self.$inventoryTable.columnResize();
                    self.updateButtons();
                }
                process.resolve();
            } else {
                var load = (reset) ? PHD.showLoadingIndicator(this.$inventory) : null;
                var url = this.getInventoryUrl();
                var request = PHD.Ajax.get(url, load, handleDetailsError);

                request.done(function (data) {
                    //if (reset) {
                    //    PHD.hideLoadingIndicator(load);
                    //}
                    // get the one active object for the details.
                    var found = false;
                    if (data.data) {
                        for (var i = 0; i < data.data.length; i++) {
                            var o = data.data[i];
                            if (o.id == self.selectedID) {
                                // copy relevant items from main row.
                                if (self.rowData != null) {
                                    var row = self.rowData;
                                    o.system_name = (row.system_name != undefined) ? row.system_name : "";
                                    o.description = (typeof row.description != 'undefined') ? row.description : "";
                                    o.next_time = (typeof row.next_time != 'undefined') ? row.next_time : "";
                                    o.calendar_str = (typeof row.calendar_str != 'undefined') ? row.calendar_str : "";
                                    o.application = (row.application_name != undefined && row.application_name != "") ? row.application_name :
                                                    (row.application != undefined & row.application != "") ? row.application : null;
                                    switch (row.type) {
                                        case 'replication':
                                            o.client_name = row.target;
                                            o.application = o.app_name;
                                            break;
                                        case 'archive':
                                            o.application = o.application_name;
                                            break;
                                        default:
                                            if (o.client_name == undefined || o.client_name == null || o.client_name == "") {
                                                if (o.instances !== undefined && o.instances.length > 0) {
                                                    var first = o.instances[0];
                                                    if (first.client_name !== undefined) {
                                                        o.client_name = first.client_name;
                                                    } else {
                                                        o.client_name = first.primary_name;
                                                    }
                                                }
                                            }
                                            break;
                                    }
                                }
                                data.data = [o];
                                found = true;
                                break;
                            }
                        }
                    }
                    if (!found) {
                        data.data = [];
                    }
                    self.inventoryTimestamp = data.timestamp;
                    if (reset) {
                        self.JobInventory.load(data.data);
                    } else {
                        self.JobInventory.update(data.data);
                    }

                    self.$inventoryTable.scrollTable({height: self.inventoryTableHeight - 6});
                    self.updateButtons();
                    process.resolve();
                });
            }
        } else {
            process.resolve();
        }
        
        /*
         * If the details API fails, clear the inventory area so stale results are removed.
         * If the error is that the schedule that is not editable in Satori, display that in the bottom area rather than a popup.
         */
        function handleDetailsError(jqXHR, textStatus, errorThrown) {
            var data = [];
            var item = {};
            item.id = self.selectedID;
            var json = jqXHR.responseJSON;
            var results = json.result !== undefined ? json.result : null;
            if (results.length > 0) {
                var response = results[0];
                if (response !== undefined && response.message !== undefined && response.message.indexOf('not editable in Satori') !== -1) {
                    item.name = "This job's details are only visible in the Legacy UI";
                } else {
                    PHD.ajaxError(jqXHR, textStatus, errorThrown);
                }
            } else {
                PHD.ajaxError(jqXHR, textStatus, errorThrown);
            }
            data = [item];
            self.JobInventory.load(data);
            self.$inventoryTable.scrollTable({height: self.inventoryTableHeight - 6});
            self.updateButtons();
        }

        return process;
    };

    JobTab.prototype.queueSelection = function (dbid) {
        var self = this;
        this.$table.one("loadfinished", function () {
            if (self.dataTable.selectByID(dbid)) {
                self.$buttons.find(".btn-view-details").trigger("click");
            }
        });
    }

    JobTab.prototype.handleRowSelect = function (event, dbid, $row, DataTable, DataRow) {
        this.$selected = $row;
        if (DataRow !== undefined) {
            this.selectedID = dbid;
            this.rowData = DataRow.data;
        } else {
            this.selectedID = null;
            this.rowData = null;
        }
        var jobIDPieces = String(dbid).split('.');
        var jobType = jobIDPieces[0].slice(-1);
        $rootScope.isSelectedJobCopy = jobType === 'a' || jobType === 'x';
        $rootScope.selectedJobIdToEdit = dbid;

        if (this.rowData != null && DataRow.data.application_name === "file-level"){
            if (this.rowData.is_nas !== undefined) {
                $rootScope.isSelectedJobNAS = this.rowData.is_nas;
                $rootScope.isSelectedJobFileLevel = !$rootScope.isSelectedJobNAS;
            } else {
                $rootScope.isSelectedJobFileLevel = true;
                $rootScope.isSelectedJobNAS = false;
            }
        }else{
            $rootScope.isSelectedJobFileLevel = false;
            $rootScope.isSelectedJobNAS = false;
        }
        //console.log("in handleRowSelect, id = " + dbid + " and rowData = " + JSON.stringify(this.rowData));
        this.updateButtons();
        if (this.inventoryOpen) {
            console.log("Inventory is OPEN");
            this.showJobDetails();
        }
    };

    JobTab.prototype.handleRowDelete = function (event, dbid, DataTable) {
        if (this.selectedID === dbid) {
            this.$selected = $();
            this.selectedID = null;
            this.$inventory.find("table tbody tr").remove();
            this.hideJobDetails();
        }
    };

    JobTab.prototype.handleRowAddition = function (event, newRows, DataTable) {
        if (newRows) {
            if (DataTable.count() <= TOO_LARGE_FOR_SORT) {
                this.$table.sortTable();
            }
        }
    };

    JobTab.prototype.selectRowByID = function (id) {
        id = id || this.selectedID;
        if (!id) {
            return false;
        }
        this.dataTable.selectByID(id);
    };

    JobTab.prototype.getUpdateUrl = function (reset) {
        var $column;
        var direction;
        if (this.namespace == "jobshistory"){
                $column = this.$table.find("th[data-source=start_time]");
                direction = ($column !== undefined && $column.data('sort-dir') !== undefined && $column.data('sort-dir') !== null) ? $column.data('sort-dir') : 'desc';
            this.url = "/api/jobs/history/?showFlat=true&sort=" + direction + "&limit=" + $rootScope.jobHistoryLimit;
        } else if (this.namespace == "jobssystem"){
                $column = this.$table.find("th[data-source=event_time]");
                direction = ($column !== undefined && $column.data('sort-dir') !== undefined && $column.data('sort-dir') !== null) ? $column.data('sort-dir') : 'desc';
            this.url = "/api/jobs/system/?sort=" + direction + "&limit=" + $rootScope.systemJobHistoryLimit;
        }
        return this.url;
    };

    JobTab.prototype.getInventoryUrl = function () {
        var url = "/api/jobs";
        switch (this.index) {
            case JOB_TAB_ACTIVE:
                url += "/active";
                break;
            case JOB_TAB_HISTORY:
                url += "/history/";
                break;
            case JOB_TAB_SYSTEM:
                url += "/system/";
                break;
            case JOB_TAB_MANAGER:
                url = "/api/joborders/" + this.selectedID;
                if (this.rowData !== null && this.rowData.sid !== undefined) {
                    url += "/?sid=" + this.rowData.sid;
                }
                break;
        }
        return url;
    };

    JobTab.prototype.initButtons = function () {
        var tab = this;
        this.$buttons.find("a").each(function (index) {
            var $but = $(this);
            PHD.buttonLogic($but, null, tab, null, null, {provider: $analytics, source: 'Jobs'});
        });
    };

    JobTab.prototype.updateButtons = function ($button) {
        var $row = this.$selected,
            id = this.selectedID,
            rowData = this.rowData;
        tab = this;

        if ($button !== void 0) {
            PHD.buttonLogic($button, $row, tab, id, rowData, {provider: $analytics, source: 'Jobs'});
        } else {
            this.$buttons.find("a").each(function (index) {
                var $but = $(this);
                PHD.buttonLogic($but, $row, tab, id, rowData, {provider: $analytics, source: 'Jobs'});
            });
        }
    };

    JobTab.prototype.adjustJobDetails = function (delta) {
        this.inventoryTableHeight -= delta;
        if (!this.$inventory.is(":hidden")) {
            this.$inventoryTable.adjustTableHeight(this.inventoryTableHeight - 6);
            this.$table.offsetTableHeight(delta);
        }
    };

    JobTab.prototype.showJobDetails = function () {
        this.inventoryTimestamp = 0;
        if (this.$inventory.is(":hidden")) {
            this.$table
                .adjustTableHeight(this.$table.getAvailableVerticalSpace(".full-height") - this.inventoryTableHeight);
            this.$inventory.show("slide", {direction: "down"});
            this.inventoryOpen = true;
            this.updateInventory(true, this.selectedID);
            console.log("in showJobDetails " + this.selectedID);
            this.$dragHandle.dragdelta("option", "disabled", false);
        } else {
            this.updateInventory(true, this.selectedID);
        }
        this.updateButtons(this.$panel.find(".btn-view-details"));
    };

    JobTab.prototype.hideJobDetails = function () {
        var self = this;
        this.$dragHandle.dragdelta("option", "disabled", true);
        this.$inventory.hide("slide", {direction: "down"}, function () {
            self.$table
                .adjustTableHeight(self.$table.getAvailableVerticalSpace(".full-height"));
            self.inventoryOpen = false;
            self.updateButtons(self.$panel.find(".btn-view-details"));
        });
    };

    JobTab.prototype.toggleSystemJobs = function (show) {
        var self = this;
        this.$table.find(".system-true").toggleClass("hidden", !show);
        this.$table.scrollTable();
        this.showSystem = show;
    };

    JobTab.prototype.setTimerInterval = function (interval) {
        JobsTimer.setInterval(refreshRate);
        if (this.$panel.is(":visible")) {
            JobsTimer.reset();
        }
    };

    JobTab.prototype.activate = function () {
        this.isActive = true;
        this.$dragHandle.dragdelta("option", "max", window.innerHeight - 90);
        this.update(false, true);
    };

    JobTab.prototype.deactivate = function () {
        this.isActive = false;
        JobsTimer.stop();
    };

    var sort_two_dates = function (a, b) {
        var x, y;
        if (a.value === EMPTY_CELL_TEXT || a.value == 'Never' || a.value == 'N/A') {
            if (a.value == 'Never' && b.value == 'N/A'){
                return 1;
            }else{
                return -1;    
            }
            
        }
        if (b.value === EMPTY_CELL_TEXT || b.value == 'Never'|| b.value == 'N/A') {
            if (b.value == 'Never' && a.value == 'N/A'){
                return -1;
            }else{
                return 1;    
            }
        }
        if (_.isArray(a.value)) {
            x = a.value.map(function (val) {
                return new Date(val);
            });
            x = x[0] < x[1] ? x[0] : x[1];
        } else {
            x = new Date(a.value)
        }
        if (_.isArray(b.value)) {
            y = b.value.map(function (val) {
                return new Date(val);
            });
            y = y[0] < y[1] ? y[0] : y[1];
        } else {
            y = new Date(b.value)
        }
        return (x < y) ?
            -1 : (x > y) ?
            1 : 0;
    };

    var sort_duration = function (a, b) {
        if (a.value === EMPTY_CELL_TEXT || b.value === null) {
            return 1;
        }
        if (b.value === EMPTY_CELL_TEXT || a.value === null) {
            return -1;
        }
        var aVals = a.value.split(":").map(function (val) {
                return parseInt(val, 10);
            }),
            bVals = b.value.split(":").map(function (val) {
                return parseInt(val, 10);
            });

        a = (aVals[0] * 60 * 60) + (aVals[1] * 60) + aVals[2];
        b = (bVals[0] * 60 * 60) + (bVals[1] * 60) + bVals[2];
        return a - b;
    };

    // Object to convert raw values to display-friendly values
    var cellFormatter = {
        name: function (value, row) {
            var display = typeof row.environment !== "undefined" ? value + " (" + row.environment + ")" : value;
            return '<span class="truncates item-name" title="' + display + '">' + display + '</span>';
        },
        // for system jobs
        username: function (value, row) {
            var icon = '</i>';
            var icon_class = value == 'System' ? 'icon-managedhosting' :
                             value.indexOf('bypass') !== -1 ? 'icon-logprograms' :  'icon-useralt' ;
            icon = '<i class="' + icon_class + ' icon">' + icon;
            return '<span class="job-type-display">' + icon + value + '</span>';
        },
        // lmc
        type: function (value, row) {
            var icon = getJobIcon(row.type);
            var type = getJobType(value, row);
            var mode = getJobMode(row.mode);
            return '<span class="job-type-display">' + icon + type + mode + '</span>';
        },
        calendar_str: function (value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        },
        joborderbackup__schedule_type: function (value, row) {
            return Array.isArray(value) ? value.join("<br>") : value;
        },
        job_status: function (value, row) {
            var title = row.message != undefined ? row.message :
                        row.status != undefined ? row.status : "";
            var icon = getStatusIcon(row);
            return '<span class="job-status-display" title="' + title + '">' + icon + value + '</span>';
        },
        /*fake_status: function (value, row) {
            var icon = "</i>",
                val = row.fake_status,
                status = row.fake_status,
                title = row.expanded_error !== undefined ? row.expanded_error : row.message;

            if (row.fake_status == 'Error' || row.fake_status == 'Cancelled') {
                icon = '<i class="icon-phd-error icon">' + icon;
            } else if (row.fake_status == 'Warning') {
                icon = '<i class="icon-phd-warning icon">' + icon;
            } else if (row.fake_status == 'Active' || row.fake_status == 'Queued') {
                icon = '<i class="icon-hourglass icon">' + icon;
            } else {
                icon = '<i class="icon-phd-success icon">' + icon;
            }
            return '<span class="joborder-status-display" title="' + title + '">' + icon + val + '</span>';
        },*/
        start_date_unf: function (value, row) {
            if (value === EMPTY_CELL_TEXT) {
                return value;
            }
            return moment(value).format("MMM D, YYYY h:mm A");
        },
        data_written: function (value, row) {
            return PHD.util.formatBytes(value);
        },
        current_speed: function (value, row) {
            return PHD.util.formatBytes(value) + "/s";
        }
    };
    cellFormatter.vm_name = cellFormatter.name;
    //cellFormatter.last_time = cellFormatter.next_time;
    cellFormatter.total_storage = cellFormatter.data_written;
    cellFormatter.speed = cellFormatter.average_speed = cellFormatter.current_speed;
    cellFormatter.job_type_extra = cellFormatter.job_type;
    // lmc - add these
    cellFormatter.start_date = cellFormatter.start_date_unf;
    cellFormatter.finish_date = cellFormatter.start_date_unf;
    cellFormatter.status = cellFormatter.job_status;
    cellFormatter.comment = cellFormatter.calendar_str;
    cellFormatter.message = cellFormatter.comment;
    // lmc - end of add these

    var lookupIcon = [];
    lookupIcon['on hold'] = "unknown";
    lookupIcon["queued"] = "";
    lookupIcon["connecting"] = "active";
    lookupIcon["active"] = "active";
    lookupIcon["running"] = "active";
    lookupIcon["db update"] = "active";
    lookupIcon["cancelled"] = "canceled";
    lookupIcon["warning"] = "";
    lookupIcon["success"] = "";
    lookupIcon["successful"] = "success";
    lookupIcon['error'] = "";
    lookupIcon["complete"] = "";
    lookupIcon["process terminated"] = "error";
    lookupIcon["unknown"] = "unknown";
    lookupIcon["incomplete/cancelled"] = "canceled";
    lookupIcon["available"] = "";
    lookupIcon["idle"] = ""; // clear this from idle, as flag doesn't change properly when enabled/disabled.
    
    function getStatusIcon(row) {
        var iconStart =  '<i class="icon-phd-';
        var iconEnd = ' icon"></i>';
        var icon = iconStart;
        var status;
        if (row.status !== null && row.status !== undefined) {
            var raw_status = row.status.toLowerCase();
            status = lookupIcon[raw_status.toLowerCase()];
            if (status == 'active') {
                // This icon does not start with icon-phd
                iconStart = '<i class="icon-hourglass';
            } else if (status == '') {
                // If '', use the lowercase status.
                iconStart += raw_status;
            } else {
                // use the mapped/return status
                iconStart += status;
            }
        } else {
            iconStart += 'unknown';
        }
        return iconStart + iconEnd;
    }


    function handlePlugin() {
        var params = PHD.util.getParams();
        if (params) {
            if (params.hasOwnProperty("action")) {
                $(document).trigger("launchdialog", [params]);
            }

            if (params.hasOwnProperty("select")) {
                // lmc - add this to kill the other timers.
                var e = $.Event('uinav.protect');
                $(document).trigger(e);
                tabs[0].queueSelection(params.select);
            }
            // lmc - don't do this
            //window.history.replaceState({}, "", window.location.origin + window.location.pathname);
        }
    }

    function handleTabChange() {
        $(document).trigger("tabchange", ["jobs" + slugs[currentTabIndex]]);
    }

    /*
     *   DOM Ready Function
     */
    $(function () {
        // Quick and dirty way to change what tab opens by default via URL
        if (!isNaN(PHD.util.getHashInt())) {
            initialTab = PHD.util.getHashInt();
        }

        UserPreference = PHD.UserPreference($("#jobs-page-preferences .preference-trigger"), {
            name: gettext("Jobs Page"),
            namespace: "jobspage",
            key: "page_jobs_refresh",
            defaultValue: refreshRate
        });

        /*JobsTimer = PHD.Timer({
            namespace: "jobspage",
            interval: refreshRate,
            refreshControl: $("#jobs-page-preferences .timer-refresh")
        }); */

        // Initialize the tabs
        $('.tabs-wrapper').tabs({
            active: initialTab,
            create: function (event, ui) {
                currentTabIndex = ui.tab.index();
                $scope.currentTabIndex = currentTabIndex;
                initTabs();
                handleTabChange();
            },
            activate: function (event, ui) {
                $(".loading").hide();
                currentTabIndex = ui.newTab.index();
                $.cookie("initial_tab_jobs", currentTabIndex, {expires: 365, path: '/'});
                tabs[ui.oldTab.index()].deactivate();
                tabs[currentTabIndex].activate();
                handleTabChange();
            }
        });

        // Handle actions from plugin
        handlePlugin();
    });

//})(jQuery, window.PHD || (window.PHD = {}), window);
}
