angular.module('backupJobModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','fileBrowserDialogApp','ngGrid','ui.bootstrap','inventory','checklist-model','ui.grid.selection', 'backup-now-dialog'])
.directive('angularDatepicker', function ($parse) {
    return function (scope, element, attrs, controller) {
        var ngModel = $parse(attrs.ngModel);
        $(function(){
            element.datepicker({
               showOn: "both",
                buttonText: '<img src="assets/images/calendar.png" width="24" height="24">',
                dateFormat: DATE_FORMAT,
                onSelect:function (dateText, inst) {
                    scope.$apply(function(scope){
                        // Change binded variable
                        ngModel.assign(scope, dateText);
                    });
                }
            });
        });
    }
}).directive('angulartimeEntry', function ($rootScope, $parse) {
     return {
         restrict: 'A',
         scope: {ngModel: "="},
         link: function(scope,elm,attrs){
             elm.timeEntry({
                 noSeparatorEntry: true,
                 ampmNames: ['am', 'pm'],
                 ampmPrefix: " "
             });
             if (attrs.timetype === 'end_time') {
                 elm.timeEntry('option', 'timeSteps', [1, 0, 0]);
                 elm.timeEntry('option', 'beforeSetTime', lastMinuteOnly);

                 function lastMinuteOnly(oldTime, newTime, minTime, maxTime) {
                     newTime.setMinutes(59);
                     return newTime;
                 }
             }
             scope.$watch('ngModel', function (newValue, oldValue) {
                 $(elm).timeEntry('setTime', newValue);
             })
         }
    }
}).directive('recurspinner', function ($parse) {
        return function (scope, element, attrs, controller) {
            var ngModel = $parse(attrs.ngModel);
            $(element).spinner({
                spin: function(event, ui) {
                    setTimeout(function() {
                        scope.$apply(function() {
                            ngModel.assign(scope, element.val());
                        });
                    }, 0);
                }
            });
        }
})
.config(['ngDialogProvider', function (ngDialogProvider) {
    ngDialogProvider.setDefaults({
        plain: false,
        closeByDocument: true,
        closeByEscape: true,
        appendTo: false,
        preCloseCallback: function (value) {
        }
    });
}])
.factory('sharedGridData', function(){
    return {
        tempArray:[]
        
    };
})
.service('includeExcludeLabelService', function () {
	   var label = 'inclusion';
         return {
            getLabel: function () {
                return label;
            },
            setLabel: function(value) {
                label = value;
            }
        };
})

.controller('backupJobController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc) {
        $scope.jobName='Backup Job'; //default job name plaveholder
        $scope.backupJobNameModel='Backup Job';
        $scope.joborder={};
        //init empty joboredr
        $scope.joborder.name = "Backup Job"; //TODO init to textfield from HTML
        $scope.joborder.type = "backup"; //this is always backup.
        $scope.joborder.verify = "none";
        $scope.joborder.app_id = "1"; //default assetType is server and hence app_id will be 1 i.e. file-level
        $scope.joborder.sid = "1"; // default sid = 1
        $scope.joborder.clients = [];
        $scope.joborder.instances = [];
        $scope.joborder.calendar = [];
        $scope.scheduleTypeSelection = {
                name: 'Scheduled'
        };
        $scope.errorField=false;
        $scope.startDateError=false;
        $scope.dayError=false;
        $scope.startTimeError=false;
        $scope.recuranceError=false;
        $scope.recursTime=[{id:0,name:'Hour(s)'},{id:1,name:'Minutes'}];
        $scope.isScheduled = true;
        $scope.joborder.storage = null;
		$scope.recursEveryError = false;
        $scope.startDateFormatError = false;
        
        $scope.isIncrementalOrDifferntial= false;
        
        $scope.joborder.email_report = true;
        $scope.joborder.failure_report = true;
        $scope.selectedTreeNode = [];
        $scope.selectedAsset =[];
        $scope.calendarDays=[
             {'name':'SUN',   'value' : "0"},
             {'name':'MON',   'value' : "1"},
             {'name':'TUE',  'value' : "2"},
             {'name':'WED','value' : "3"},
             {'name':'THU', 'value' : "4"},
             {'name':'FRI',   'value' : "5"},
             {'name':'SAT', 'value' : "6"}
            ];
        $scope.backupModes = [];
        $scope.backupModesForNow=[];
        $scope.backupModesForSchedule=[];
        $scope.backupStrategies=[];
        $scope.backup_types = {};
        $scope.backupModesforJob = {};
        $scope.scheduleForm = {};
        $scope.hideEdit=false;
        $scope.jobErrorDialog = false;
		
        $scope.daysFull=[{name:'SUN',id:'run_on_sun_full',val:"0"},{name:'MON',id:'run_on_mon_full',val:"1"},{name:'TUE',id:'run_on_tue_full',val:"2"},{name:'WED',id:'run_on_wed_full',val:"3"},{name:'THR',id:'run_on_thr_full',val:"4"},{name:'FRI',id:'run_on_fri_full',val:"5"},{name:'SAT',id:'run_on_sat_full',val:"6"}];
        $scope.daysIncr=[{name:'SUN',id:'run_on_sun_incr',val:"0"},{name:'MON',id:'run_on_mon_incr',val:"1"},{name:'TUE',id:'run_on_tue_incr',val:"2"},{name:'WED',id:'run_on_wed_incr',val:"3"},{name:'THR',id:'run_on_thr',val:"4"},{name:'FRI',id:'run_on_fri',val:"5"},{name:'SAT',id:'run_on_sat_incr',val:"6"}];

        
        var templateWithTooltip = '<div style="word-wrap:normal;font-size:1.2em;padding-top:5px;" title="{{row.getProperty(col.field)}}">{{row.getProperty(col.field)}}</div>';
        $scope.inventoryColumnDefs = [ 
            {field:'id',displayName:'Id',visible:false},
            {field:'nodeId',displayName:'Node Id',visible:false},
            {field: 'name',displayName:'Name',width:'30%'},
            {field:'rules',displayName:'Protection Rules',cellClass: 'cellToolTip',cellTemplate: templateWithTooltip,width:'50%'},
            {field:'edit' ,displayName:'', cellTemplate: '<div ng-hide="hideEdit" style="padding-left:25px;padding-top:5px;" ng-click="openEditSettingServerDialog(row.entity,row.getProperty(col.field), col.field)"><img src="assets/images/edit_pencil.png" style="height:11.5px;cursor:pointer;"/><span style="font-size:11px;padding-left:5px;font-weight:bold">Edit<span></div>',width:'20%'} 
        ];
        $scope.inventoryGridOptions={columnDefs: $scope.inventoryColumnDefs,data:'inventoryData', rowHeight: 32, enableHorizontalScrollbar:0,enableVerticalScrollbar:2,resizable: true};
        $scope.assetType={};
        $scope.assetTypeList=[
            { name: "Agent-Based Assets", hypervisor:"1" ,id:INVENTORY_TYPE_FAMILY_CLIENT},
            { name: "VMware Assets", hypervisor:"3" ,id:INVENTORY_TYPE_FAMILY_VMWARE},
            { name: "Hyper-V Assets", hypervisor:"2" ,id:INVENTORY_TYPE_FAMILY_HYPER_V},
            { name: "NAS",    hypervisor:"1"    ,id:INVENTORY_TYPE_FAMILY_CLIENT_NAS}
        ];

        if($rootScope.isXenUEB){
            $scope.assetTypeList.push({ name: "XenServer Assets", hypervisor:"4" ,id:INVENTORY_TYPE_FAMILY_XEN});
        }
        if(!($rootScope.isCE || $rootScope.isGoogle)){

            $scope.assetTypeList.push({ name: "Exchange", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_EXCHANGE});
            $scope.assetTypeList.push({ name: "Oracle", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_ORACLE});
            $scope.assetTypeList.push({ name: "SQL", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_SQL});
            $scope.assetTypeList.push({ name: "Sharepoint", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_SHAREPOINT});
            $scope.assetTypeList.push({ name: "Cisco UCS", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_CISCO_UCS});
            $scope.assetTypeList.push({ name: "NDMP", hypervisor:"0", id:INVENTORY_TYPE_FAMILY_NDMP});

        }

        $scope.stretch_database = false;

        $scope.PM_ADJUST_EXTRA  = 13;
        $scope.PM_ADJUST = 12;
        $scope.showtoolTipForEmailVerification = function(){
            var form = angular.element("#test-job-form");
            form.find(".definition").popover({
                appendTo: form
            });
        };
        if($scope.isEdit){
            $http({
                method: 'get',
                url : '/api/joborders/'+$scope.jobId
            }).success(function(data, status, headers){
                $scope.joborder=data.data[0];
                document.getElementById("backupJobID").value=$scope.joborder.name;
                $scope.assetType.id= $scope.getAssetType($scope.joborder);
                $scope.isHypervisorHostSelected = $scope.isRegexJob($scope.joborder);
                $scope.hideEdit = checkHideEdit($scope.assetType.id);
                $scope.isNAS = $rootScope.isSelectedJobNAS;
                $scope.setRecurrenceModel();
                $scope.setEndHour();
                $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
                //$scope.checkNodesOnLoadEdit();
            }).error(function(response){
                ngDialog.open({
                    dialogType:'Error',
                    dialogMessage:response.result[0].message
                })
            });

        }else{
            $scope.assetType.id= parseInt($scope.selectedAssetType);
            setTimeout(function(){
                $scope.filterInventory();}, 1000);
        }


        /*
         * If an end hour is specified, recurrences run through that hour (minute 59).
         */
        $scope.setEndHour = function(){
            for (var i = 0 ; i < $scope.joborder.calendar.length ; i++){
                $scope.setCalendarEntryEndHour(i);
            }
        };

        $scope.setCalendarEntryEndHour = function(i) {
            var minute = "59";
            var ampm = " pm";
            if ($scope.joborder.calendar[i] !== undefined) {
                var endHour = parseInt($scope.joborder.calendar[i].end_hour);
                if (endHour > 13){
                    endHour -= $scope.PM_ADJUST_EXTRA;
                    $scope.joborder.calendar[i].end_hour = endHour+":"+minute+ampm;
                } else {
                    ampm = (endHour == 13) ? " pm" : " am";
                    endHour--;
                    $scope.joborder.calendar[i].end_hour = endHour+":"+minute+ampm;
                }
            }
        };

       $scope.setRecurrenceModel = function(){
            for (var i =0 ; i <$scope.joborder.calendar.length ; i ++){
             if(typeof($scope.joborder.calendar[i].recurrence) !='undefined'){
                 $scope.joborder.calendar[i].recursCheck  =true;
                 if($scope.joborder.calendar[i].recurrence < 60){
                     $scope.joborder.calendar[i].recursTimeSelect=1;
                 }else{
                     $scope.joborder.calendar[i].recurrence = $scope.joborder.calendar[i].recurrence/60;
                     $scope.joborder.calendar[i].recursTimeSelect=0;
                 }
                 // Wrap with timeout so that recurs loads as a spinner.
                 (function(){const index = i;
                     setTimeout(function(){$scope.recurstimeModeChange(index,$scope.joborder.calendar[index].recursTimeSelect)},0,index);})();
             }else{
                 $scope.joborder.calendar[i].recursCheck = false;
                 // No recurrence, but initialize potential values in case the user wants recurrences.
                 $scope.joborder.calendar[i].recursTimeSelect = 0;
                 $scope.joborder.calendar[i].recurrence = 1;
                 $scope.joborder.calendar[i].end_hour = 24;
             }
            }
        };
        $scope.treeConfig = {
            core : {
                multiple : !$scope.isNAS, //TODO check if it needs to single select in case of NAS
                animation: true,
                error : function(error) {$log.error('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            types : {
                default : {icon : 'icon-hv-datacenter icon'},
                star : {icon : 'icon-hv-host icon'},
                cloud : {icon : 'icon-hv-host icon'}
            },
            version : 1,
            plugins : ['types','checkbox','search']
        };
        
        $scope.setAssetType=function(){
            if($rootScope.isSelectedJobFileLevel){
                 $scope.assetType.id= $scope.assetTypeList[0].id;
            }else if($rootScope.isSelectedJobNAS){
                 $scope.assetType.id= $scope.assetTypeList[3].id;
            }else{
                 $scope.assetType.id= $scope.assetTypeList[3];
            }
        }

        $scope.filterInventory = function(){
            $('#jstreeDivId').jstree(true).uncheck_all();
            $scope.joborder={};
            //init empty joboredr
            $scope.joborder.name = "Backup Job"; //TODO init to textfield from HTML
            $scope.joborder.type = "backup"; //this is always backup.
            $scope.joborder.verify = "none";
            $scope.joborder.app_id = "1"; //default assetType is server and hence app_id will be 1 i.e. file-level
            $scope.joborder.sid = "1"; // default sid = 1
            $scope.joborder.clients = [];
            $scope.joborder.instances = [];
            $scope.joborder.calendar = [];
            $scope.joborder.email_report = true;
            $scope.joborder.failure_report = true;
            $scope.joborder.storage = null;
            $scope.isHypervisorHostSelected = false;
            $rootScope.clearRegex();


            $scope.hideEdit = checkHideEdit($scope.assetType.id);
            $scope.isNAS = false;
            if($scope.assetType.id == INVENTORY_TYPE_FAMILY_CLIENT_NAS){
                $scope.isNAS = true;
                $('#jstreeDivId').jstree(true).settings.core.multiple = false;
            } else {
                $('#jstreeDivId').jstree(true).settings.core.multiple = true;
            }
            $rootScope.treeData=[];
            $scope.selectedAsset =[];
            $scope.inventoryData =[];
            $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
        };
        
        //
        // Based on the asset type, returns an indication of whether or not the edit button should be visible for the job.
        //
        function checkHideEdit(assetType) {
            return (assetType == INVENTORY_TYPE_FAMILY_HYPER_V || assetType == INVENTORY_TYPE_FAMILY_EXCHANGE || assetType == INVENTORY_TYPE_FAMILY_SQL ||
                    assetType == INVENTORY_TYPE_FAMILY_ORACLE || assetType == INVENTORY_TYPE_FAMILY_SHAREPOINT || assetType == INVENTORY_TYPE_FAMILY_CISCO_UCS ||
                    assetType == INVENTORY_TYPE_FAMILY_NDMP);
        }
        
        $scope.getAssetType = function(joborder){
            var app_id= joborder.app_id;

            if(app_id === APP_ID_FILE_LEVEL){
                if(joborder.clients[0].name.indexOf("-NAS-RRC")>-1){ //hack till backend fix it.
                    return INVENTORY_TYPE_FAMILY_CLIENT_NAS;
                }
                return INVENTORY_TYPE_FAMILY_CLIENT;
            } else if(app_id === APP_ID_VMWARE){
                return INVENTORY_TYPE_FAMILY_VMWARE;
            } else if(app_id === APP_ID_XEN){
                return INVENTORY_TYPE_FAMILY_XEN;
            } else if(app_id === APP_ID_HYPERV_2008_R2 || app_id === APP_ID_HYPERV_2012){
                return INVENTORY_TYPE_FAMILY_HYPER_V;
            } else if (app_id === APP_ID_EXCHANGE_2003 || app_id === APP_ID_EXCHANGE_2007 || app_id === APP_ID_EXCHANGE_2010 || app_id === APP_ID_EXCHANGE_2013 || app_id === APP_ID_EXCHANGE_2016) {
                return INVENTORY_TYPE_FAMILY_EXCHANGE;
            }else if (app_id === APP_ID_SQL_SERVER_2005 || app_id === APP_ID_SQL_SERVER_2008 || app_id === APP_ID_SQL_SERVER_2008_R2 
                || app_id === APP_ID_SQL_SERVER_2012 || app_id === APP_ID_SQL_SERVER_2014 || app_id === APP_ID_SQL_SERVER_2016) {
                return INVENTORY_TYPE_FAMILY_SQL;
            }else if (app_id === APP_ID_SHAREPOINT_2007 || app_id === APP_ID_SHAREPOINT_2010 || app_id === APP_ID_SHAREPOINT_2013 || app_id === APP_ID_SHAREPOINT_2016) {
                return INVENTORY_TYPE_FAMILY_SHAREPOINT;
            }else if (app_id === APP_ID_ORACLE_11 || app_id === APP_ID_ORACLE_12 || app_id === APP_ID_ORACLE_10) {
                return INVENTORY_TYPE_FAMILY_ORACLE;
            } else if(app_id === APP_ID_CISCO_UCS_SERVICE_PROFILE){
                return INVENTORY_TYPE_FAMILY_CISCO_UCS;
            } else if (app_id === APP_ID_NDMP) {
                return INVENTORY_TYPE_FAMILY_NDMP;
            }
        }

        $scope.getClientOrInstance = function(joborder){
            var app_id= joborder.app_id;
            if(app_id === APP_ID_FILE_LEVEL){
                if(joborder.clients[0].name.indexOf("-NAS-RRC")>-1){ //hack till backend fix it.
                    return joborder.clients;
                }
                return joborder.clients;
            } else {
                /* for all other apps, return instances.
                    APP_ID_EXCHANGE_2003 = 2,
                    APP_ID_EXCHANGE_2007 = 3,
                    APP_ID_EXCHANGE_2010 = 4,
                    APP_ID_EXCHANGE_2013 = 5,
                    APP_ID_SQL_SERVER_2005 = 21,
                    APP_ID_SQL_SERVER_2008 = 22,
                    APP_ID_SQL_SERVER_2008_R2 = 23,
                    APP_ID_SQL_SERVER_2012 = 24,
                    APP_ID_SQL_SERVER_2014 = 25,
                    APP_ID_ARCHIVE = 30,
                    APP_ID_VMWARE = 40,
                    APP_ID_HYPERV_2008_R2 = 50,
                    APP_ID_HYPERV_2012 = 51,
                    APP_ID_ORACLE_11 = 100,
                    APP_ID_ORACLE_12 = 101,
                    APP_ID_ORACLE_10 = 102,
                    APP_ID_SHAREPOINT_2007 = 110,
                    APP_ID_SHAREPOINT_2010 = 111,
                    APP_ID_SHAREPOINT_2013 = 112; */
                return joborder.instances;
            }
        };

        $scope.uncheckNotEligibleNode=function(uncheckNodeId){
            var node_id='li#'+uncheckNodeId;
            $('#jstreeDivId').jstree(true).uncheck_node(node_id);
        }

        $scope.readyTree=function(event){
            if($scope.isEdit){
                 setTimeout(function(){
                   $scope.checkNodesOnLoadEdit();
                   $rootScope.loadRegex();
                }, 1000);
            } else {
                if($scope.selectedNodeList.length>0){
                    setTimeout(function(){
                       $scope.checkNodesOnPreSelect();
                       $rootScope.initRegex(false);
                    }, 1000);
                }
            }
        };

        $scope.checkNodesOnPreSelect=function(){
            $('#jstreeDivId').jstree(true).open_all();
            for(var i=0; i< $scope.selectedNodeList.length ; i++){
                var node_id='li#';
                node_id = node_id +$scope.selectedNodeList[i];
                $('#jstreeDivId').jstree(true).check_node(node_id);
            }
        }
        $scope.checkNodesOnLoadEdit=function(){
                var nodeIdArray =Object.keys($('#jstreeDivId').jstree(true)._model.data);
                var arrayAssets = $scope.getClientOrInstance($scope.joborder);
                $('#jstreeDivId').jstree(true).open_all();
                if(arrayAssets !=undefined){
                    for(var i=0; i< arrayAssets.length ; i++){
                        var node_id='li#';
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            if (nodeMatches(nodeIdArray[j], arrayAssets[i], $scope.joborder)) {
                                arrayAssets[i].nodeId = nodeIdArray[j];
                                if(arrayAssets[i].incl_list == undefined || arrayAssets[i].incl_list == null){
                                    arrayAssets[i].incl_list = [];   
                                }
                                if(arrayAssets[i].excl_list == undefined || arrayAssets[i].excl_list == null){
                                    arrayAssets[i].excl_list = [];   
                                }

                                $scope.selectedAsset[nodeIdArray[j]] = arrayAssets[i];
                                node_id = node_id+nodeIdArray[j];
								$scope.before_command = arrayAssets[i].before_command;
								$scope.after_command = arrayAssets[i].after_command;
                                break;
                            }
                        }
                        if ($scope.isHypervisorHostSelected) {
                            var obj = inventorysvc.nodeToObject(node_id);
                            $rootScope.joborderHypervisorID = obj.system_id + '_' + obj.client_id + '_' + obj.app_id + '_' + obj.host_guid;
                        }
                        $('#jstreeDivId').jstree(true).check_node(node_id);
                    }
                    $('#jstreeDivId').jstree(true).close_all();
                }
        };

        function nodeMatches(node, asset, joborder) {
            var match = false;
            var asset_node = joborder.sid + "_";
            if (parseInt(joborder.app_id) === APP_ID_FILE_LEVEL) {
                asset_node += asset.id;
                match = node.indexOf(asset_node) === 0;
            } else {
                asset_node += joborder.client_id + "_" + joborder.app_id + "_";
                if (node.indexOf(asset_node) === 0) {
                    var parts = node.split('_');
                    match = isNaN(parts[parts.length - 1]) ? false : (asset.id === parseInt(parts[parts.length - 1]));
                }
            }
            return match;
        }


        $scope.deslectNodeFun = function(e,item){
            if (item.node.data !== undefined && item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
                $rootScope.joborderHypervisorID = item.node.id;
                $scope.isHypervisorHostSelected = false;
                $scope.$apply(function() {
                    $scope.isHypervisorHostSelected = false;
                });
            } else {
                if(item.selected.length == 0){
                    $scope.joborder.clients =[];
                    $scope.selectedAsset =[];
                }
                if($scope.joborder.sid == inventorysvc.nodeToObject(item.node.id).system_id){
                    delete $scope.selectedAsset[item.node.id];
                }
                $scope.inventoryData =[];
                var nodeIdArray =Object.keys($scope.selectedAsset);
                for(var j=0 ;j<nodeIdArray.length;j++){
                    var obj = $scope.selectedAsset[nodeIdArray[j]];
                    obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);
                    $scope.inventoryData.push(obj);
                }
                $(window).resize();
            }
        };

        $scope.slectNodeFun = function(e,item){
            /*
             * Until iSeries is integrated into the system, protect it from being seleected or pre-selected in a backup job.
             * Rather than disabling, use the selection to display a helpful message to user on how to protect an iSeries asset.
             */
            if (item.node.data !== undefined && item.node.data.type === INVENTORY_ID_CLIENT_I_SERIES) {
                var message  = "An iSeries asset may not be included in a backup job in the web-based user interface.  To protect iSeries data, please use the menu-based console interface.";
                $scope.uncheckNotEligibleNode(item.node.id);

                if ($scope.jobErrorDialog == false) {
                    // Set the dialog flag so that multiple dialogs are not opened, as this function can be
                    // called multiple times when the user selects multiple nodes at once, i.e., on pre-selection.
                    $scope.jobErrorDialog = true;
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'BackupPostErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                }
            } else {
                if(item.selected.length>1){
                    if($scope.joborder.sid == inventorysvc.nodeToObject(item.node.id).system_id){
                        if($scope.selectedAsset[item.node.id] ==null || $scope.selectedAsset[item.node.id] == undefined){
                            $scope.selectedAsset[item.node.id] ={nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id,incl_list:[],excl_list:[]};
                        }
                    }else{
                        $scope.uncheckNotEligibleNode(item.node.id);
                    }
                }else{
                    $scope.joborder.sid = inventorysvc.nodeToObject(item.node.id).system_id;
                    $scope.joborder.app_id = inventorysvc.nodeToObject(item.node.id).app_id;
                    if (item.node.data !== undefined && item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
                        $scope.isHypervisorHostSelected = true;
                        $rootScope.joborderHypervisorID = item.node.id;
                    } else {
                        if($scope.selectedAsset[item.node.id] == undefined ||$scope.selectedAsset[item.node.id] ==null){
                            $scope.selectedAsset[item.node.id] ={nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id,incl_list:[],excl_list:[]};
                        }
                    }
                }

                $scope.inventoryData =[];
                var nodeIdArray =Object.keys($scope.selectedAsset);
                for(var j=0 ;j<nodeIdArray.length;j++){
                    var obj = $scope.selectedAsset[nodeIdArray[j]];
                    if(item.node.data.type === INVENTORY_ID_VMWARE_VM || item.node.data.type ===INVENTORY_ID_XEN_VM){
                        $scope.getExcludedDatastore(nodeIdArray[j]);
                    }
                    obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);
                    $scope.inventoryData.push(obj);
                }
                $(window).resize();
            }
        };

        $scope.setProtectionRule = function(incl_list,excl_list) {
            var protectionruleInclusion="Inclusions =[ ";
            var protectionruleExclusion="Exclusions =[ ";
            var protectionRules ="";

            if(incl_list!=undefined && incl_list!=null &&incl_list.length>0){
                protectionruleInclusion = protectionruleInclusion+incl_list.toString()+" ] ";
                protectionRules = protectionRules + protectionruleInclusion;
            }

            if(excl_list!=undefined && excl_list!=null &&excl_list.length>0){
                protectionruleExclusion = protectionruleExclusion+excl_list.toString()+" ] ";
                protectionRules = protectionRules + protectionruleExclusion;
            }

            return protectionRules;
        }

        $scope.refreshInventoryData = function(assets){
            var assets = assets || false;
            if (assets) {
                $scope.selectedAsset = assets;
            }
            $scope.inventoryData =[];
            var nodeIdArray =Object.keys($scope.selectedAsset);
            for(var j=0 ;j<nodeIdArray.length;j++){
                var obj = $scope.selectedAsset[nodeIdArray[j]];
                obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);
                $scope.inventoryData.push(obj);
            }
            $(window).resize();

        }

        $scope.applyModelChanges = function() {
            if($scope.isScheduled){
                if(typeof($scope.backupModesforJob.name) !='undefined'){
                    $scope.getBackupTypeForSelectedStrategies($scope.backupModesforJob.name);
                }
            }
            
            
        }

        $scope.search = function(){
            var to = false;   
            if(to) { clearTimeout(to); }
            to = setTimeout(function () {
                var v = $('#inventorySearchInputId').val();
                $('#jstreeDivId').jstree(true).search(v);
            }, 200);
        }

        $scope.addNewInventory=function(item,id){
        }

        $scope.getProtectionRulesArray = function(inclusionData,exclusionData){
        }

        $scope.functiontofindIndexByKeyValue = function(arraytosearch, key, valuetosearch) {
            for (var i = 0; i < arraytosearch.length; i++) {
                if (arraytosearch[i][key] == valuetosearch) {
                  return i;
                 }
            }
                return null;
        };

        $scope.isRegexJob = function(job) {
            return (job !== undefined && job.regular_expressions !== undefined && job.regular_expressions.length > 0);
        };

        $scope.canAutoInclude = function(asset_type) {
            var result = false;
            switch (asset_type) {
                // Note: no VMware here - use regular expressions to include new.
                // Also, remoted SharePoint below - there is only 1 item (the farm)
                // If Satori ever supports Cisco UCS, it does not do auto-include either.
                case INVENTORY_TYPE_FAMILY_EXCHANGE:
                case INVENTORY_TYPE_FAMILY_ORACLE:
                //case INVENTORY_TYPE_FAMILY_SHAREPOINT:
                case INVENTORY_TYPE_FAMILY_SQL:
                    $scope.assetItems = "databases";
                    result = true;
                    break;
                case INVENTORY_TYPE_FAMILY_NDMP:
                    $scope.assetItems = "volumes";
                    result = true;
                    break;
                case INVENTORY_TYPE_FAMILY_HYPER_V:
                    $scope.assetItems = "VMs";
                    result = true;
                    break;
            }
            return result;
        };

/*************************************************************************
2ndstep
*/  
        $scope.validationForForm=function(){
            $scope.errorField=false;
            $scope.startDateError=false;
            $scope.dayError=false;
            $scope.startTimeError=false;
            $scope.recuranceError=false;
			$scope.endHourError =false;
			$scope.recursEveryError = false;
            $scope.startDateFormatError = false;
			

            if ($scope.joborder.calendar === undefined || $scope.joborder.calendar.length == 0 ){
                return true;
            }else{
                for (var i =0 ; i < $scope.joborder.calendar.length ; i++){
			        if($scope.joborder.calendar[i].run_on.length <=0){
                        $scope.errorField=true;
                        $scope.dayError=true;
                    }
                  if(typeof($scope.joborder.calendar[i].start_date) == 'undefined'){
                        $scope.errorField=true;
                        $scope.startDateError=true;
                    }
                 if(typeof($scope.joborder.calendar[i].start_time) == 'undefined'){
                        $scope.errorField=true;
                        $scope.startTimeError=true;
                   }
                 else{
                     var checkStartDateFormatError = $scope.validateStartDate($scope.joborder.calendar[i].start_date);
                     if(checkStartDateFormatError){
                         $scope.startDateFormatError = true;
                         $scope.errorField = true;
                     }
                 }
				   if( $scope.joborder.calendar[i].recursCheck){
                      if(typeof($scope.joborder.calendar[i].recurrence )==='undefined'  || $scope.joborder.calendar[i].recurrence==null || $scope.joborder.calendar[i].recurrence==="" || $scope.joborder.calendar[i].recurrence==0 ){
                          $scope.errorField=true;
                          $scope.recuranceError=true;
                          $scope.recursEveryError=true;
                      }
                  }
                  if( $scope.joborder.calendar[i].recursCheck){
                      if(typeof($scope.joborder.calendar[i].end_hour) == 'undefined') { //} || ($scope.joborder.calendar[i].end_hour< 0 && $scope.joborder.calendar[i].end_hour > 24) ){
                           $scope.errorField=true;
                           $scope.endHourError=true;
                      }
                      var start_hour = $scope.getHourFromString($scope.joborder.calendar[i].start_time);
                      var end_hour = $scope.getHourFromString($scope.joborder.calendar[i].end_hour);
                      if (start_hour >= end_hour) {
                          $scope.errorField=true;
                          $scope.endHourError=true;
                      }
                  }
                  
                  if($scope.errorField){
                      $scope.error_backupType =$scope.joborder.calendar[i].backup_type;
                        break;
                    }
                    
                }
                
                return !$scope.errorField;
            }
      
        }

        $scope.validateStartDate = function (date) {
            if(date === ''){
                return true;
            }
            var DatePattern = /^(\d{1,2})(\/|-)(\d{1,2})(\/|-)(\d{4})$/;
            var DateArray = date.match(DatePattern);
            if(DateArray === null){
                return true;
            }
            var Month = DateArray[1];
            var Day= DateArray[3];
            var Year = DateArray[5];
            var leapYear;
            if (Month < 1 || Month > 12){
                return true;
            }
            else if (Day < 1 || Day> 31){
                return true;
            }
            else if ((Month==4 || Month==6 || Month==9 || Month==11) && Day ==31){
                return true;
            }
            else if (Month == 2)
            {
                if(Year % 4 == 0 && (Year % 100 != 0 || Year % 400 == 0)){
                    leapYear = true;
                }
                if (Day> 29 || (Day ==29 && !leapYear)){
                    return true;
                }
            }
            return false;
        };
        
        $scope.removeUnwantedKeys = function(){
            for (var i =0 ; i < $scope.joborder.calendar.length ; i++){
                if(!$scope.joborder.calendar[i].recursCheck){
                    delete $scope.joborder.calendar[i].recurrence;
                }
                else if ($scope.joborder.calendar[i].recursTimeSelect == 0 ){
                    $scope.joborder.calendar[i].recurrence =$scope.joborder.calendar[i].recurrence * 60;
                }
                $scope.joborder.calendar[i].end_hour = $scope.getHourFromString($scope.joborder.calendar[i].end_hour);
                delete $scope.joborder.calendar[i].$$hashKey;
                delete $scope.joborder.calendar[i].recursTimeSelect;
                delete $scope.joborder.calendar[i].recursCheck;
                if ($scope.joborder.calendar[i].begin_hour !== undefined) {
                    delete $scope.joborder.calendar[i].begin_hour;
                }
            }
        };

        $scope.getHourFromString =function(hourString){
            var hourStringArray = hourString.split(" ");
            var hourArray = hourStringArray[0].split(":");
            var Hour  = parseInt(hourArray[0]);
            var Minute = parseInt(hourArray[1]);
            if (hourStringArray[1] === "pm"){
                if (Hour < 12) {
                    Hour += $scope.PM_ADJUST;
                }
            } else {
                if (Hour == 12) {
                    Hour -= $scope.PM_ADJUST;
                }
            }
            if (Minute == 59) {
                Hour++;
            }
            return Hour;
        };
		
        $scope.nextWizard = function($event){
            if(wizardTitle == "Select Items"){
		        console.log($scope.selectedAsset);
                $scope.stretch_database = false;
                if( Object.keys($scope.selectedAsset).length == 0){
                    return;
                }
                var nodeIdArray =Object.keys($scope.selectedAsset);
                var flag = false;
                for(var j=0 ;j<nodeIdArray.length;j++){
                    var obj = $scope.selectedAsset[nodeIdArray[j]];
                    var idLength = obj.nodeId.split('_');
                    if(idLength[2] == APP_ID_SQL_SERVER_2016 && !flag){
                        flag = true;
                        $scope.stretch_database = true;
                    }
                }
                $rootScope.$broadcast("nextBtnClick");
                if($scope.isEdit == true){
                    $scope.isScheduled = true;
                    $scope.scheduleTypeSelection.name ='Scheduled';
                }
                $scope.getStorage();
                $scope.getBackupStrategies();
				$scope.showtoolTipForEmailVerification();


            }
            if(wizardTitle == "Define Job Settings"){
                if(document.getElementById("backupJobID").value == ""){
                    $scope.jobNameError=true;
                    return;
                 }if($scope.joborder.storage === 'object' && $scope.joborder.storage.value == 'SelectBackupTarget'){
                      $scope.backuptarget=true;
                      $scope.errorField=true;
                    return;
                 }
                 $scope.backuptarget=false;
                 $scope.errorField=false;
                 $scope.jobNameError=false;
                  if($scope.validationForForm()){
                   $scope.saveBackupJobData(); //To save backupjob data.
                  }else{
                    console.log('validation error');
                }
            }
        };
        
		$scope.saveBackupJobData = function(){
			    $scope.joborder.name=document.getElementById("backupJobID").value;
                     if($scope.assetType.id ===INVENTORY_TYPE_FAMILY_CLIENT || $scope.assetType.id ===INVENTORY_TYPE_FAMILY_CLIENT_NAS){
                        $scope.joborder.clients =[];// $scope.j
                        var nodeIdArray =Object.keys($scope.selectedAsset);
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            $scope.joborder.app_id = inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).app_id;
                            $scope.selectedAsset[nodeIdArray[j]].id = parseInt($scope.selectedAsset[nodeIdArray[j]].id);
                            $scope.joborder.clients.push($scope.selectedAsset[nodeIdArray[j]]);
                            if($scope.isNAS){
                                var client = $scope.joborder.clients[0];
                                $scope.joborder.client_id = client.id;
                                $scope.joborder.incl_list = client.incl_list;
                                $scope.joborder.excl_list = client.excl_list ;
                                $scope.joborder.before_command = client.before_command;
                                $scope.joborder.after_command = client.after_command;
                                delete $scope.joborder.clients;
                                delete $scope.joborder.instances;
                            }
                        }

                    }else{

                        $scope.joborder.instances =[];// $scope.j
                        var nodeIdArray =Object.keys($scope.selectedAsset);
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            $scope.joborder.app_id = inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).app_id;
                            $scope.selectedAsset[nodeIdArray[j]].id = parseInt(inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).instance_id);
                            $scope.joborder.instances.push($scope.selectedAsset[nodeIdArray[j]]);
                        }

                    }
                    var jobOrderUrl='';
                    var dataObj ={};
                    var httpMethod='';
                    var meassageforLoad=(!$scope.isEdit)?"Creating Job":"Updating Job";
                    var loadJobindicator = PHD.showLoadingIndicator("body", true, meassageforLoad);
                    // Get the joborder value - if an object, get its value.
                    $scope.joborder.storage = (typeof $scope.joborder.storage === 'object' && $scope.joborder.storage.value !== null) ?
                                                    $scope.joborder.storage.value : $scope.joborder.storage;
                    if($scope.isScheduled){
                        $scope.removeUnwantedKeys();
                        if($scope.isEdit == true){
                            httpMethod = 'put';
                            jobOrderUrl = '/api/joborders/'+$scope.joborder.id+'/?sid='+$scope.joborder.sid;

                        }else{
                            jobOrderUrl = '/api/joborders/?sid='+$scope.joborder.sid;
                            httpMethod = 'post';
                        }dataObj =JSON.stringify($scope.joborder)
                        console.log($scope.joborder);
                    }else{
                        console.log($scope.backupModesforJob.name);
                        if(typeof ($scope.joborder.calendar) != 'undefined'){
                            delete $scope.joborder.calendar;
                        }
                        $scope.joborder.backup_type=$scope.backupModesforJob.name;
                        console.log($scope.joborder);
                        jobOrderUrl = '/api/backups/?sid='+$scope.joborder.sid;
                        dataObj =JSON.stringify($scope.joborder)
                        httpMethod = 'put';
                    }

                    $http({ method: httpMethod,
                        url : jobOrderUrl,
                        data: dataObj
                    }).success(function(data, status, headers){
                        PHD.hideLoadingIndicator(loadJobindicator);
                        if (!$scope.isScheduled) {
                            $analytics && $analytics.eventTrack('On Demand Backup Job', {  category: 'Backup', label: 'Protect' });
                            ngDialog.open({
                                modelDialogId:'backupNowDialog',
                                template: 'app/protect/backup-job/backupNowDialog.html',
                                scope:$scope,
                                data: data.data,
                                overlay:true,
                                ngDialogStyle:"width:700px;height:400px;"
                            });
                        } else {
                            if (!$scope.isEdit) {
                                var pageLabel = (window.location.href.indexOf("#/protect") !== -1) ? 'Protect' : 'Jobs';
                                $analytics && $analytics.eventTrack('Add Backup Job', {  category: 'Backup', label: pageLabel });
                                var message = "Job created successfully!<br/><br/>Use the Job Manager tab to view and manage your newly created job.";
                                console.log(data);
                                console.log(status);
                                console.log(headers);

                                ngDialog.open({
                                    dialogType: 'Success',
                                    dialogMessage: message
                                });
                                if (pageLabel === 'Jobs') {
                                    $(document).trigger("editJob");
                                }
                            } else {
                                $analytics && $analytics.eventTrack('Edit Backup Job', {  category: 'Backup', label: 'Jobs' });
                                ngDialog.close('backup-physical-dailog');
                                $(document).trigger("editJob");
                            }
                        }

                    }).error(function(response) {
                        var message = response.result[0].message;
                        $analytics && $analytics.eventTrack('Failure: ' + message, {  category: 'Backup', label: 'Protect' });
                        PHD.hideLoadingIndicator(loadJobindicator);
                        ngDialog.open({
                            dialogType:'Error',
                            modelDialogId:'BackupPostErrorDialog',
                            scope:$scope,
                            dialogMessage: message,
                            onConfirmOkButtonClick:'onConfirmError()'
                        });
                        if ($scope.isScheduled) {
                            // re-set the elements deleted before the save.
                            $scope.setRecurrenceModel();
                            $scope.setEndHour();
                        }
                    });
			
		}
        $scope.onConfirmError = function () {
            ngDialog.close('BackupPostErrorDialog');
            $scope.jobErrorDialog = false;
        };

         $scope.getBackupMode = function() {
            if($scope.scheduleTypeSelection.name == "Now") {
                $scope.backupJobNameModel='On-Demand';
                $scope.jobNameError=false;    
                $scope.isScheduled = false;  
                $scope.joborder.calendar=[];
                $scope.backupModes=$scope.backupModesForNow;
				$scope.backupModesforJob.name= $scope.backupModes[0];

            } else {
                if ($scope.backupJobNameModel == 'On-Demand'){
                    $scope.backupJobNameModel='Backup Job';
                }
                $scope.isScheduled = true;
                $scope.backupModes=$scope.backupModesForSchedule;

                var index =0;
                for ( var i =0 ; i < $scope.backupModes.length ; i++){
                    if ($scope.backupModes[i] == 'Incremental Forever'){
                        index=i;
                        break;
                    }
                }

                $scope.backupModesforJob.name= $scope.backupModes[index];
                $scope.getBackupTypeForSelectedStrategies($scope.backupModes[index]);

            }
            

        };
        $scope.getBackupTypeForSelectedStrategies = function(backupStratiges){
            $scope.joborder.calendar=[];
            var dataArray=[];
            for (var i =0 ; i <$scope.backupStrategies.length ; i++ ){
                if(backupStratiges == $scope.backupStrategies[i].name){
                    dataArray =  $scope.backupStrategies[i].backup_types;
                }
            }
            for (j = 0 ; j < dataArray.length ; j++){
                var calendarObj={
                    start_date:new Date().toLocaleDateString('en-US'),
                    start_time:"03:00 AM",
                    backup_type:dataArray[j],
                    recursCheck:false,
                    recursTimeSelect:0,
                    recurrence:1,
                    schedule_run: 0,
                    end_hour:24
                };
                // Set up calendar frequencies based on type.
                switch (calendarObj.backup_type) {
                    case "Incremental":
                        if (dataArray.length == 1) {
                            calendarObj.run_on = ["0", "1", "2", "3", "4", "5", "6"];
                        } else {
                            calendarObj.run_on = ["1", "2", "3", "4", "5", "6"];
                        }
                        break;
                    case "Differential":
                    case "Transaction":
                        calendarObj.run_on = ["1", "2", "3", "4", "5", "6"];
                        break;
                    case "Full":
                    default:
                        calendarObj.run_on = ["0"];
                        break;
                }
                $scope.joborder.calendar.push(calendarObj);
                $scope.recurstimeModeChange(j,0);
                $scope.setCalendarEntryEndHour(j);
            }
        };
	    $scope.setBackupModeForEdit = function(){
            var StrategiesObject={};
            for (var i=0 ; i < $scope.backupStrategies.length ; i++){
                var backupstrategyType="";
                for(var j=0 ; j < $scope.backupStrategies[i].backup_types.length ; j++){
                backupstrategyType +=$scope.backupStrategies[i].backup_types[j];
                }
                StrategiesObject[backupstrategyType]=$scope.backupStrategies[i].name;
            }
            var backupType="";
            for ( var i = 0 ; i < $scope.joborder.calendar.length; i++){
             backupType +=$scope.joborder.calendar[i].backup_type;
            }
            var selectedBackupType=StrategiesObject[backupType];
            $scope.backupModesforJob.name= $scope.backupModes[$scope.backupModes.indexOf(selectedBackupType)];
        }
        $scope.getBackupStrategies = function() {
                var scheduleApi = "/api/backups/strategies/"+$scope.joborder.app_id+"/";
                if($scope.isNAS){
                    scheduleApi = "/api/backups/strategies/"+$scope.joborder.app_id+"/?isNAS=true";
                }
                $http.get(scheduleApi)
                .then(function(response){
                        $scope.backup_types ={};
                        $scope.backupModesForSchedule = [];
                        $scope.backupModesForNow = response.data.on_demand;
                        var tempMap = new Object();
                        $scope.backupStrategies=response.data.strategies;
                        for(var i=0; i< response.data.strategies.length;i++) {    
                            $scope.backup_types[response.data.strategies[i].name] = response.data.strategies[i].backup_types;
                            $scope.backupModesForSchedule[i]=response.data.strategies[i].name;
                        }
                        if($scope.isScheduled){
                            $scope.backupModes=$scope.backupModesForSchedule;
                             if ($scope.isEdit){
                                 $scope.setBackupModeForEdit();
                                 
                             }else{
                                 $scope.backupModesforJob.name= $scope.backupModes[0];
                             }
                        }else {
                            $scope.backupModes=$scope.backupModesForNow;
                             $scope.backupModesforJob.name= $scope.backupModes[0];
                        }
                    if (!$scope.isEdit){
                        $scope.getBackupMode();
                    }
                },function(reason){
                    console.log(reason);
                });
            };
            $scope.recurstimeModeChange = function(index,timeSelect){
                var timmerId="#recurs_spinner_field"+index;
                if(timeSelect == 0){
                    $(timmerId).spinner({min: 1, max: 12});
                }else{
                    $(timmerId).spinner({min: 1, max: 60});
                }
            };
            $scope.getStorage = function(){
                var storageApi = "/api/storage/?sid="+$scope.joborder.sid+"&usage=backup";
                $scope.backupTarget ={};
                $scope.backupTarget.targets = [];
                $scope.backupTarget.targets.push({name:'Select Backup Target',value:'SelectBackupTarget'});

                $http.get(storageApi)
                    .then(function(response){
                        console.log(response.data.storage.length);
                        var defaultStorageIndex = 0;
                        var storageIndex = 0;

                        for(var j=0;j<response.data.storage.length ;j++){
                            $scope.backupTarget.targets.push({name:response.data.storage[j].name,value:response.data.storage[j].name});
                            if (response.data.storage[j].is_default){
                                // Add 1 to the index as the targets array includes the "Selection" entry.
                                defaultStorageIndex = j + 1;
                            }
                            if($scope.joborder.storage == response.data.storage[j].name) {
                                // Add 1 to the index as the targets array includes the "Selection" entry.
                                storageIndex = j + 1;
                            }
                        }

                        if (!$scope.isEdit){
                            $scope.joborder.storage = $scope.backupTarget.targets[defaultStorageIndex];
                        } else if ($scope.joborder.storage === "") {
                            $scope.joborder.storage = $scope.backupTarget.targets[defaultStorageIndex];
                        } else {
                            $scope.joborder.storage = $scope.backupTarget.targets[storageIndex];
                        }

                    },function(reason){
                        console.log(reason);
                    });
            };

        $scope.getExcludedDatastore = function(selectedNodeId){
            
            var url ='/api/inventory/'+selectedNodeId +'/?disks=1';
                console.log(url);
            $http({
                method: 'GET',
                url: url
            }).success(function(data, status, headers) {
                console.log(data.inventory.nodes);
                var obj = $scope.selectedAsset[selectedNodeId];
                for(var i=0;i<data.inventory.nodes.length;i++){
                    if(data.inventory.nodes[i].is_excluded){
                      obj.excl_list.push(data.inventory.nodes[i].name); 
                    }
                }
                obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);

            }).error(function(data, status, headers) {
                console.log('api_inventory_error');
            });
            
        }    
        
       
        $scope.openEditSettingServerDialog = function(row,cell,column){

            $scope.selectedAssetId = row.id;
            $scope.selectedAssetName = row.name;
            $scope.selectedNodeId = row.nodeId;
            if($scope.assetType.id == INVENTORY_TYPE_FAMILY_VMWARE || $scope.assetType.id == INVENTORY_TYPE_FAMILY_XEN){
                 ngDialog.open({
                            template: 'app/protect/backup-job/edit-vmware.html',
                            scope: $scope,
                            overlay:true,
                            modelDialogId:'edit-vmware-dailog',
                            ngDialogStyle:'width:600px;height:520px;',
                            preCloseCallback: function (value) {}
                });
            }
            if($scope.assetType.id ==INVENTORY_TYPE_FAMILY_CLIENT_NAS ||$scope.assetType.id == INVENTORY_TYPE_FAMILY_CLIENT ){
                ngDialog.open({
                            template: 'app/protect/backup-job/edit-asset.html',
                            scope: $scope,
                            overlay:true,
                            modelDialogId:'edit-asset-dailog',
                            ngDialogStyle:'width:600px;height:520px;',
                            preCloseCallback: function (value) {}
                });
            }
      }

}])
.controller('editAssetController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared','includeExcludeLabelService',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared,includeExcludeLabelService) {
        $scope.tab = 1;
        $scope.currentTab = 1;
        $scope.ADVANCED_TAB = 3;

        var index = $scope.$parent.selectedAssetName.indexOf("-NAS-RRC");
        if(index != undefined && index !=null && index > -1){
            $scope.isNAS = true;
        }

        $scope.inclusionGridOptions = {};       
        $scope.inclusionColumnDefs = [{field: 'name',displayName:'Name'},
                                            {field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity,1)"/></div>'}];
        $scope.exclusionFileGridOptions = {};      
        $scope.exclusionFileColumnDefs = [{field: 'name',displayName:'Name'},
                                            {field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity,2)"/></div>'}];

        $scope.inclusionGridOptions = {columnDefs: $scope.inclusionColumnDefs,data:'inclusionData',enableHorizontalScrollbar:0};
        $scope.exclusionFileGridOptions = {columnDefs: $scope.exclusionFileColumnDefs,data:'exclusionData',enableHorizontalScrollbar:0};


        $scope.inclusionData = [];
        $scope.exclusionData = [];
        $scope.originalInclusionData = [];
        $scope.originalExclusionData = [];
        for(var i =0;i<$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list.length;i++){
            $scope.inclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list[i]});
            $scope.originalInclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list[i]});
        }

        for(var i =0;i<$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list.length;i++){
            $scope.exclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list[i]});
            $scope.originalExclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list[i]});
        }
        
		if($scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].before_command != undefined){
			$scope.before_command = $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].before_command ;
		}else{
			$scope.before_command = ""; 
		}

		if($scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].after_command != undefined){
	       $scope.after_command = $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].after_command;
		}else{
			$scope.after_command = ""; 
		}

        $scope.showCurrentTab = function(currentTab){
            $scope.currentTab = currentTab;
            // Setup the warning popover for system state if the advanced tab.
            if ($scope.currentTab == $scope.ADVANCED_TAB) {
                $scope.showtoolTipForSystemState();
            }
            $(window).resize();
        }

        $scope.selectTab = function (setTab){
            $scope.tab = setTab;
        };
        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };

        $scope.deleteRow = function(row,grid){
            if(grid == 1){
                var index = $scope.inclusionData.indexOf(row);
                $scope.inclusionData.splice(index, 1);
            }else{
                var index = $scope.exclusionData.indexOf(row);
                $scope.exclusionData.splice(index, 1); 
            }
        }

        $scope.openBrowseFileDialog  = function(tab){
            var dataObj={};
            var fileId = $scope.$parent.selectedAssetId;
            var dirName = "";
			var inclusionExclusionLabel ="";

			if(tab == 1){
				inclusionExclusionLabel = "inclusion";
				includeExcludeLabelService.setLabel(inclusionExclusionLabel);
			}else{

				inclusionExclusionLabel = "exclusion";
				includeExcludeLabelService.setLabel(inclusionExclusionLabel);
			}

            if($scope.isNAS){
                var index = $scope.$parent.selectedAssetName.indexOf("-NAS-RRC");
                dirName ="&dir="+"/mnt/nas/"+$scope.$parent.selectedAssetName.substring(0,index);
            }

            var url = '/api/clients/files/'+fileId+'/?sid='+inventorysvc.nodeToObject($scope.$parent.selectedNodeId).system_id+dirName;
            var fileBrowserTreeNodeUrl = '/api/clients/files/'+fileId+'/?sid='+inventorysvc.nodeToObject($scope.$parent.selectedNodeId).system_id+'&dir=';
            dataObj = {fileBrowserTreeNodeUrl:fileBrowserTreeNodeUrl,url:url};
            
            fileBrowserDialogService.getfileBrowserTreeData(dataObj); // to open andget data for file browser tree.
        }
        $scope.savefileServerSettingData = function(){
             $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list =[];
             $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list =[];
            if($scope.inclusionData===undefined || $scope.inclusionData===null || $scope.inclusionData.length===0){
                $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list =[];
            } else {
                for(var i =0;i<$scope.inclusionData.length;i++){
                    $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list.push($scope.inclusionData[i].name);
                }
            }
            if($scope.exclusionData===undefined || $scope.exclusionData===null || $scope.exclusionData.length===0){
                $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list =[];
            } else {
                for(var i =0;i<$scope.exclusionData.length;i++){
                    $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list.push($scope.exclusionData[i].name);
                }
            }
			$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].before_command = $scope.before_command;
			$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].after_command =  $scope.after_command;
            $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].metanames = $scope.excludeSystemStateModel ? ['registry'] : [];
			
            $scope.$parent.$parent.refreshInventoryData();
            unbind();
            ngDialog.close('edit-asset-dailog');
        }
        $scope.closeEditServerSettingDialog =function(){
            unbind();
                if($scope.isInclusionExclusionChanged() || $scope.haveAdvancedSettingsChanged()) {
                  ngDialog.open({
                     template: 'app/protect/backup-job/confirm-backup-job.html',
                     scope: $scope,
                     overlay: true,
                     modelDialogId: 'confirm-edit-backup',
                     showHelpArticleButton: true,
                     ngDialogStyle: 'width:46em; height:15em;  top: 70px;left: 27px;right: 27px;'
                 });
               } else {
                ngDialog.close('edit-asset-dailog');
            }
        }
        
         $scope.isInclusionExclusionChanged = function(){
            $scope.isInclusionModified = false;
            if(angular.equals($scope.inclusionData, $scope.originalInclusionData)!==true || angular.equals($scope.exclusionData,$scope.originalExclusionData)!==true ){
                $scope.isInclusionModified = true;
            }else{
                $scope.isInclusionModified = false;
            }
            return $scope.isInclusionModified;
        }

        $scope.haveAdvancedSettingsChanged = function(){
            var stateChanged = !(angular.equals($scope.excludeSystemStateModel, $scope.originalSystemSateModel));
            return stateChanged;
        };
        
        $scope.closeEditBackupDialogs = function(){
            ngDialog.close('edit-asset-dailog');
            ngDialog.close('confirm-edit-backup');
        }
        $scope.cancelEditBackup = function(){
            ngDialog.close('confirm-edit-backup'); 
        }

        var unbind= $scope.$watch(function(){
            return dataToBeShared.objectList;
        }, function(newValue,oldValue){
             if(!angular.isUndefined(newValue) &&(angular.isUndefined(oldValue) || newValue.name != oldValue.name)){
                 console.log(newValue);
                 $scope.addBrowseItem(newValue);
                 dataToBeShared.objectList=undefined;
             }
        });

        $scope.addIncludeText = function(){
           var obj = {name:$scope.includeText};
            var uniqueFlag = containsObject(obj,$scope.inclusionData);
            if(uniqueFlag != true && $scope.includeText != undefined){
                $scope.inclusionData.push(obj);
            }
            $scope.includeText="";
        }
         
        $scope.addExcludeText = function(){
            var obj = {name:$scope.excludeText};
            var uniqueFlag = containsObject(obj,$scope.exclusionData);
            if(uniqueFlag != true && $scope.excludeText != undefined){
                $scope.exclusionData.push(obj);
            }
            $scope.excludeText="";
        }
        function containsObject(obj, list) {
            if(!angular.isUndefined(list)){
                var i;
                for (i = 0; i < list.length; i++) {
                    if (list[i].name === obj.name) {
                        return true;
                    }
                }
            }
            return false;
        }

        $scope.addBrowseItem = function(listArray){
            for(var i=0;i<listArray.length;i++){
                var dirName = "";
                if($scope.isNAS){
                    var index = $scope.$parent.selectedAssetName.indexOf("-NAS-RRC");
                    if(index != undefined && index !=null && index > -1) {
                        var name = listArray[i].name;
                        // Don't add /mnt/nas if already there.
                        if (name.indexOf("@@@:/mnt/nas/") === -1) {
                            dirName = "/mnt/nas/" + $scope.$parent.selectedAssetName.substring(0, index) + "/";
                        }
                    }
                }
                listArray[i].name = dirName+listArray[i].name;
                if($scope.currentTab == 1) {
                    $scope.inclusionData.push(listArray[i]);
                }else{
                    $scope.exclusionData.push(listArray[i]);
                }
            }
      
            $(window).resize();
        }

		$scope.addPresets = function(tab){
        	if(tab == 1){
				$scope.inclusionData = [];
		    	for(var i=0;i< $scope.originalInclusionData.length;i++){
				  $scope.inclusionData.push( $scope.originalInclusionData[i]);
				}
			}else{
				$scope.exclusionData =[];
				for(var j=0;j<$scope.originalExclusionData.length;j++){
				  $scope.exclusionData.push($scope.originalExclusionData[j]);
				}
		    }
		};

        $scope.excludeStateWarningMessage = 'Only select this option for protecting data volumes. ' +
                                            'Recovery of this backup will not restore server metadata,' +
                                            ' and these backups cannot be selected for Unitrends Bridge.';

        $scope.showExcludeStateWarning = function() {
            if ($scope.excludeSystemStateModel) {
                ngDialog.open({
                    dialogType:'warning',
                    dialogMessage: $scope.excludeStateWarningMessage,
                    modelDialogId: 'exclude-state-dialog',
                    scope: $scope,
                    onConfirmOkButtonClick:'onConfirmStateWarning()'
                });
            }
        };

        $scope.onConfirmStateWarning = function() {
            ngDialog.close('exclude-state-dialog');
        };

        $scope.isStateExcluded = function(selectedAsset) {
            var stateExcluded = false;
            if (selectedAsset !== undefined && selectedAsset.metanames !== undefined && Array.isArray(selectedAsset.metanames)) {
                var metanames = selectedAsset.metanames;
                for (var i = 0; i < metanames.length; i++) {
                    if (metanames[i] == 'registry') {
                        stateExcluded = true;
                        break;
                    }
                }
            }
            return stateExcluded;
        };

        $scope.excludeSystemStateModel = $scope.isStateExcluded($scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId]);
        $scope.originalSystemSateModel = $scope.excludeSystemStateModel;


        $scope.showtoolTipForSystemState = function(){
            var element = angular.element("#exclude-state-checkbox");
            element.find(".definition").popover({
                appendTo: element
            });
        };

    }]).controller('editVmWareController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared) {
        $scope.tab =1;
        $scope.excluded_datastore = $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list;
        $scope.showCheckError=false;
        console.log('editVmWareController');
        $scope.gridOptions={
                    multiSelect: true,
                    showHeader: false,
                    enableFullRowSelection : true,
                    gridMenuShowHideColumns:false,
                    columnDefs: [
                          { field: 'name', showHeader: false, displayName:"" },
                         { field: 'id', visible:false , showHeader: false}
                    ]
                };
    
        //$scope.gridOptions.data=[{'name':'Abc','id':'1'}];
         $scope.selectTab = function (setTab){
            $scope.tab = setTab;
        };
        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };

        var selectedNodeId = $scope.$parent.selectedNodeId;
        console.log(selectedNodeId);
        var url ='/api/inventory/'+selectedNodeId +'/?disks=1';
         console.log(url);
         $http({
            method: 'GET',
            url: url
        }).success(function(data, status, headers) {
             console.log(data.inventory.nodes);
          $scope.gridOptions.data=data.inventory.nodes;
           
        }).error(function(data, status, headers) {
            console.log('api_inventory_error');
        });
        
         $scope.gridOptions.onRegisterApi = function(gridApi){
                    //set gridApi on scope
                    $scope.gridApi = gridApi;
                    gridApi.selection.on.rowSelectionChanged($scope,function(row){
                        if (row.isSelected){
                            $scope.showCheckError=false;
                        }
                    });

                };
         $scope.gridOptions.isRowSelectable =function(row){
                    for(var i=0; i<$scope.excluded_datastore.length;i++){
                        if($scope.excluded_datastore[i] === row.entity.name){
                            return true;
                        }
                    }
                    row.setSelected(true);
                    return true;
                };


        $scope.saveVmWareSettingData = function(){
            $scope.selectedDataStores = $scope.gridApi.selection.getSelectedRows();
            //console.log($scope.selectedDataStores);
            if($scope.selectedDataStores.length > 0){
                $scope.showCheckError=false;
            }else{
                $scope.showCheckError=true;
            }
            
            if(!$scope.showCheckError){
                var dataStoreGridData = $scope.gridOptions.data;
                var filterExcludeDataStore = dataStoreGridData.filter(function(obj) { return $scope.gridApi.selection.getSelectedRows().indexOf(obj) == -1; })
                //console.log(filterExcludeVolumeArray);
                $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list =[];
                for(var i=0;i<filterExcludeDataStore.length;i++){
                    $scope.excluded_datastore.push(filterExcludeDataStore[i].name);
                    $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list.push(filterExcludeDataStore[i].name);
                }
                $scope.$parent.$parent.refreshInventoryData();
                ngDialog.close('edit-vmware-dailog');
            }
        }
        

        $scope.closeEditServerSettingDialog =function(){
            $scope.closeThisDialog();
        }

}]).controller('filterVMwareController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared) {

        $scope.containers = [
            { name: 'Enter name',       id: -1},
            { name: 'Datacenters',      id: 4 },
            { name: 'ESX Clusters',     id: 5 },
            { name: 'ESX Servers',      id: 6 },
            { name: 'Datastores',       id: 7 },
            { name: 'Resource Pools',   id: 8 },
            { name: 'vApps',            id: 9 },
            { name: 'Folders',          id: 10 },
            { name: 'VM DisplayName',   id: 11 }
        ];

        $scope.actions = [
            { name: 'Enter action',     id: -1},
            { name: 'Equal',            id: 0 },
            { name: 'Not Equal',        id: 1 },
            { name: 'Contains',         id: 2 },
            { name: 'Not Contains',     id: 3 },
            { name: 'Starts with',      id: 4 },
            { name: 'Ends With',        id: 5 }
        ];

        $scope.default_regex = {
            container: $scope.containers[0],
            action: $scope.actions[0],
            filter: '',
            isEdit: false
        };
        $scope.regexList = [];
        $scope.ROW_HEIGHT = 28;
        $scope.MAX_REGEX_COUNT = 2;

        $scope.addRegex = function(regex) {
            if ($scope.regexList.length < $scope.MAX_REGEX_COUNT) {
                var regex = regex || null;
                if (regex) {
                    $scope.regexList.push(regex);
                } else {
                    $scope.regexList.push(jQuery.extend(true, {}, $scope.default_regex));
                    $scope.regexList[$scope.regexList.length - 1].container = $scope.containers[0];
                    $scope.regexList[$scope.regexList.length - 1].action = $scope.actions[0];
                }

                var $tree = $("#jstreeDivId");
                var $controls = $("#protect-tree-controls");
                var $footer = $("#protect-treeview-footer-dialog");
                $tree.height($tree.height() - $scope.ROW_HEIGHT);
                $controls.height($controls.height() + $scope.ROW_HEIGHT);
                $footer.height($footer.height() + $scope.ROW_HEIGHT);
            }
        };

        $scope.removeRegex = function() {
            var $tree = $("#jstreeDivId");
            var $controls = $("#protect-tree-controls");
            var $footer = $("#protect-treeview-footer-dialog");

            $scope.regexList.pop();
            console.log($footer);
            $tree.height($tree.height() + $scope.ROW_HEIGHT);
            $controls.height($controls.height() - $scope.ROW_HEIGHT);
            $footer.height($footer.height() - $scope.ROW_HEIGHT);
            if ($scope.regexList.length == 0) {
                $scope.joborder.instances =[];
                $scope.$parent.$parent.refreshInventoryData([]);
            }
        };

        $rootScope.clearRegex = function() {
            var item_count = $scope.regexList.length;
            for (var i = 0; i < item_count; i++) {
                $scope.removeRegex();
            }
        };

        $scope.applyRegex = function() {
            var node = $rootScope.joborderHypervisorID;
            var url = '/api/hypervisor/regex/?sid=' + 1;
            var regex = $scope.getRegex();
            console.log('regex');
            console.log(regex);
            var validObj = isValid(regex);
            if (validObj.valid) {
                var obj = {};
                obj.host = node;
                obj.regex = regex;
                var json_obj = JSON.stringify(obj);
                var load = PHD.showLoadingIndicator('body', true, 'Searching for VMs that meet the filter criteria....');
                var resp = PHD.Ajax.put(url, json_obj, load, handleError);
                resp.done(function(data) {
                    console.log(data.data);
                    $scope.selectedAsset = [];
                    for (var i = 0; i < data.data.length; i++) {
                        var vm = data.data[i];
                        var item = {};
                        item.nodeId = $rootScope.joborderHypervisorID + '_' + vm.instance_id;
                        item.name = vm.name;
                        item.id = vm.instance_id;
                        item.incl_list = [];
                        item.excl_list = [];
                        $scope.selectedAsset[item.nodeId] = item;
                    }
                    $scope.$parent.$parent.refreshInventoryData($scope.selectedAsset);
                    $scope.joborder.regular_expressions = regex;
                    // if max of 2 regexes.
                    if ($scope.regexList.length < $scope.MAX_REGEX_COUNT) {
                        $scope.addRegex();
                    }
                });
            } else {
                ngDialog.open({
                    dialogType:'Error',
                    modelDialogId:'regex-dialog-not-valid',
                    scope:$scope,
                    dialogMessage: validObj.message,
                    onConfirmOkButtonClick:'closeOnConfirmError()'
                });
            }
        };
		$scope.closeOnConfirmError = function () {
            ngDialog.close('regex-dialog-not-valid');
        };
        function isValid(regex) {
            var obj = {valid: true, message: ''};
            for (var i = 0; i < regex.length; i++) {
                var item = regex[i];
                if (item.container_id < 0) {
                    obj.message = "Please select a filter name.";
                    obj.valid = false;
                    break;
                }
                if (item.action_id < 0) {
                    obj.message = "Please select a filter action.";
                    obj.valid = false;
                    break;
                }
                if (item.filter.replace(/\s/g, "").length <= 0) {
                    obj.message = "Please enter filter text.";
                    obj.valid = false;
                    break;
                }
            }
            return obj;
        }

        function handleError(jqXHR, textStatus, errorThrown) {
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var error = data.result[0].message;
                    console.log("The error is:" + error);
                    //PHD.hideLoadingIndicator(AddStorage);
                    ngDialog.open({
                        dialogType:'retry',
                        modelDialogId:'regex-dialog',
                        scope:$scope,
                        dialogMessage: error
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.getRegex = function() {
            var regex = [];
            for (var i = 0; i < $scope.regexList.length; i++) {
                var item = $scope.regexList[i];
                var obj = {};
                obj.container_id = item.container.id;
                obj.action_id = item.action.id;
                obj.filter = item.filter;
                regex.push(obj);
            }
            return regex;
        };

        $rootScope.initRegex = function(isEdit) {
            $scope.regexList = [];
            var $tree = $("#jstreeDivId");
            var $controls = $("#protect-tree-controls");
            var $footer = $("#protect-treeview-footer-dialog");
            if (isEdit) {
                $tree.height(450);
                $controls.height(30);
                $footer.height(30);
            } else {
                $tree.height(400);
                $controls.height(30);
                $footer.height(30);
            }
        };

        $rootScope.loadRegex = function() {
            $rootScope.initRegex(true);
            if ($scope.joborder.regular_expressions !== undefined) {
                for (var i = 0; i < $scope.joborder.regular_expressions.length; i++) {
                    var short_regex = $scope.joborder.regular_expressions[i];
                    var container = _.findWhere($scope.containers, {"id": short_regex.id});
                    var action =  _.findWhere($scope.actions, {"id": short_regex.action});
                    var regex = {};
                    regex.container = container;
                    regex.action = action;
                    regex.filter = short_regex.filter;
                    // so that it will be disabled, part of schedule.
                    regex.isEdit = true;
                    console.log(regex);
                    $scope.addRegex(regex);
                }
            }
        };
}]);