
angular.module('backupPhysicalModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','fileBrowserDialogApp','ngGrid','ui.bootstrap'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
		  });
    	}])
        .factory('sharedGridData', function(){
            return {
                    excludeListArray:[],
                    includeListArray:[],
                    tempArray:[],
                    inclusionData:[],
                    exclusionData:[],
                    directoryId:'',
                    currentTab:1,
				    protectionRulesArray:[]
            };
        })
      .controller('backupPhysicalCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService) {
        $scope.fullObj={};
        $scope.incrObj={};
        $scope.diffObj={};
	    $scope.ignoreChanges = false;
        $scope.newNode = {};
		$scope.inventoryData = [ ];	
	    $scope.jobOrders={}; //final object to post jobOrdersData
        sharedGridData.includeListArray = [];
        sharedGridData.excludeListArray = [];
        sharedGridData.inclusionData=[];
        sharedGridData.exclusionData=[];
        $scope.assetType={};
        sharedGridData.protectionRulesArray = [];
        $scope.assetTypeList=[
            { name: "Server", hypervisor:"0" ,id:"PHYSICALSERVER"},
			{ name: "VMware", hypervisor:"3" ,id:"VMware"},  
            { name: "HyperV", hypervisor:"4" ,id:"HyperV"},
			{ name: "NAS",    hypervisor:"0"    ,id:"NAS"}
        ];
        $scope.setAssetType=function(){
            if($rootScope.isSelectedJobFileLevel){
                 $scope.assetType.id= $scope.assetTypeList[0].id;
            }else if($rootScope.isSelectedJobNAS){
                 $scope.assetType.id= $scope.assetTypeList[3].id;
            }else{
                 $scope.assetType.id= $scope.assetTypeList[3];
            }
        }
        $scope.filterInventory = function(){
            $rootScope.treeData=[];
            $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
        };
        if(!$scope.isEdit){
             $rootScope.treeData=[];
         }
        if($scope.isEdit){
            $scope.setAssetType();
            $http({
                method: 'get',
                url : '/api/joborders/'+$scope.jobId
            }).success(function(data, status, headers){

                if(data.data!=null && data.data !=undefined && data.data.length >0){
                    $scope.jobOrders=data.data[0]; //final object to post jobOrdersData
                    $scope.backupJobNameModel= data.data[0].name;
				
					var inclusionList = data.data[0].incl_list;
					var exclusionList = data.data[0].excl_list;
					
					var inclusionListArr =[];
					var exclusionListArr =[];
					if(!angular.isUndefined(inclusionList)){
						for(var i=0;i<inclusionList.length;i++){
							inclusionListArr.push({name:inclusionList[i]});
						}
					}
					if(!angular.isUndefined(exclusionList)){
						for(var j=0;j<exclusionList.length;j++){
							exclusionListArr.push({name:exclusionList[j]});
						}
					}
					
					$scope.inclusionData = inclusionListArr;
					$scope.exclusionData = exclusionListArr;
					
					console.log($scope.inclusionData);
		            console.log($scope.exclusionData);
                    if(data.data[0].incl_list !=null && data.data[0].incl_list !=undefined){
                        $rootScope.includeListArray=data.data[0].incl_list;
                    }
                    if(data.data[0].excl_list !=null && data.data[0].excl_list !=undefined){
                        $rootScope.excludeListArray=data.data[0].excl_list;
                    }
                    $rootScope.tempArray = [];  
                }
            }).error(function(response){
                 ngDialog.open({
                            dialogType:'Error',
                            dialogMessage:response.result[0].message
                          })
            });
                
        }else {
		  $scope.jobOrders.app_id = 1; //Assume its default 1 , till user selects node on tree.
          $scope.backupJobNameModel=$scope.backupDialogType ==="NAS"?"Backup NAS Job" : "Backup Physical Server Job";
          $rootScope.includeListArray=[];
          $rootScope.excludeListArray=[];
          $rootScope.tempArray = [];  
   
        }
        $scope.isNAS = $scope.backupDialogType ==="NAS"?true:false;
	    
		var templateWithTooltip = '<div style="word-wrap:normal;font-size:1.2em;padding-top:2px;" title="{{row.getProperty(col.field)}}">{{row.getProperty(col.field)}}</div>';


        $scope.selectedTreeNode = [];
        $scope.treeConfig = {
            core : {
                multiple : !$scope.isNAS,
                animation: true,
                error : function(error) {$log.error('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            types : {
                default : {icon : 'icon-hv-datacenter icon'},
                star : {icon : 'icon-hv-host icon'},
                cloud : {icon : 'icon-hv-host icon'}
            },
            version : 1,
            plugins : ['types','checkbox','search']
        };

        $scope.nodeCreated=function(e,item){
            if($scope.jobOrders.clients !=null && $scope.jobOrders.clients !=undefined && $scope.jobOrders.clients.length > 0){
                var nodeIdArray =Object.keys($('#jstreeDivId').jstree(true)._model.data);
                for(var i=0; i< $scope.jobOrders.clients.length ; i++){
                    var node_id='li#';//$scope.jobOrders.app_id+'_'+$scope.jobOrders.clients[i].id;
                    for(var j=0 ;j<nodeIdArray.length;j++){
                        if(nodeIdArray[j].indexOf($scope.jobOrders.app_id+'_'+$scope.jobOrders.clients[i].id)== 0 ){
                            node_id = node_id+nodeIdArray[j];
                            break;
                        }
                    }
                    
                    $('#jstreeDivId').jstree(true).check_node(node_id);
/*                    if( $scope.jobOrders.client_id != null){
                            $('#jstreeDivId').jstree(true).check_node(node_id);
                        }else{
                            console.log('from Basic Physical');
                    }
*/                }
            }else if($scope.isEdit){
                setTimeout(function(){
                  var event = e;
                  var item = item;
                  $scope.nodeCreated(e,item);
                }, 1000);
            }
        }
		
		/**********************on node expand send ajax call to get root node children***********************/
			
		 $scope.beforeOpenFun = function(e,item){
		
		 }
		
		/******************************************to find index of an item in JavaScript Object Array****************/
		$scope.functiontofindIndexByKeyValue = function(arraytosearch, key, valuetosearch) {
			for (var i = 0; i < arraytosearch.length; i++) {
				if (arraytosearch[i][key] == valuetosearch) {
				  return i;
				 }
			}
				return null;
		}
		
		/**************************** On deselect node remove item from  inventory setting table********************/
		
		$scope.deslectNodeFun = function(e,item){
			var i, j, r = [];
			$scope.inventoryData = [];
            $scope.instanceArray = [];
            for(i = 0, j = item.selected.length; i < j; i++) {
                r.push(item.instance.get_node(item.selected[i]).text);
				$scope.addNewInventory(item.instance.get_node(item.selected[i]).text,item.instance.get_node(item.selected[i]).id);
            }
	
		 }
	   
		/**************************** On select a node add node to inventory setting table************************/
	
		$scope.changedCB = function(e,item) {
			var gridDivId = $("#inventoryGridId");
			load = PHD.showLoadingIndicator(gridDivId);
            var i, j, r = [];
			$scope.instanceArray = [];	
			$scope.inventoryData = [ ];
			
            for(i = 0, j = item.selected.length; i < j; i++) {
                r.push(item.instance.get_node(item.selected[i]).text);
				$scope.jobOrders.app_id = Number(item.selected[i].split("_")[0]);
				$scope.node_id = item.instance.get_node(item.selected[i]).id;
				$scope.node_text = item.instance.get_node(item.selected[i]).text;	
				
				if(item.instance.get_node(item.selected[i]).text.indexOf("NAS-RRC") > -1){
				    $scope.addNewInventory($scope.node_text,$scope.node_id);
                } else if(item.instance.get_node(item.selected[i]).data.type == 17){
                    $scope.addNewInventory($scope.node_text,$scope.node_id);
                }
		   }
		    angular.copy(r,$scope.selectedTreeNode);
			$scope.selectedItem = $scope.selectedTreeNode.toString();
			$(window).resize();
			PHD.hideLoadingIndicator(load); 
/*		    setTimeout(function(){
			   PHD.hideLoadingIndicator(load); 
		       $(window).resize();
		   }, 500); */
        };
   
			
        $scope.applyModelChanges = function() {
	        return true;
        };
/************************************************************Inventory Setting Grid********************************************/
 $scope.inventoryGridOptions = {};
 $scope.inventoryColumnDefs = [ 
 {field:'id',displayName:'Id',visible:false},
 {field: 'name',displayName:'Name',width:'30%'},
 {field:'rules',displayName:'Protection Rules',cellClass: 'cellToolTip',cellTemplate: templateWithTooltip,width:'50%'},
 {field:'edit' ,displayName:'', cellTemplate: '<div style="padding-left:25px;padding-top:5px;" ng-click="openEditSettingServerDialog(row.entity,row.getProperty(col.field), col.field)"><img src="assets/images/edit_pencil.png" style="height:14px;cursor:pointer;"/><span style="font-size:11px;padding-left:5px;font-weight:bold">Edit<span></div>',width:'20%'} ];
 
 $scope.inventoryGridOptions={columnDefs: $scope.inventoryColumnDefs,data:'inventoryData', enableHorizontalScrollbar:0,enableVerticalScrollbar:2,resizable: true};
 			
 $scope.addNewInventory=function(item,id){

	    if(sharedGridData.inclusionData[id] ==undefined || sharedGridData.inclusionData[id] ==null){
		  sharedGridData.inclusionData[id]=[];
        }
        if(sharedGridData.exclusionData[id] == undefined || sharedGridData.exclusionData[id] ==null){
		  sharedGridData.exclusionData[id]=[];
        }
		if($scope.jobOrders.clients !=null && $scope.jobOrders.clients !=undefined && $scope.jobOrders.clients.length>0){  
            for(var x =0; x<$scope.jobOrders.clients.length;x++){
                    var node_id=$scope.jobOrders.app_id+'_'+$scope.jobOrders.clients[x].id;
    			    if(id.indexOf(node_id)== 0){
                        if($scope.jobOrders.clients[x].incl_list !=null && $scope.jobOrders.clients[x].incl_list!= undefined){
                            sharedGridData.includeListArray=$scope.jobOrders.clients[x].incl_list.slice();
                            sharedGridData.inclusionData[id] =[];
                            for(var i =0 ; i<sharedGridData.includeListArray.length;i++){
                                sharedGridData.inclusionData[id].push({ name: sharedGridData.includeListArray[i]});
                            }
                        }
                        if($scope.jobOrders.clients[x].excl_list !=null && $scope.jobOrders.clients[x].excl_list!= undefined){
    				        sharedGridData.excludeListArray=$scope.jobOrders.clients[x].excl_list.slice();
                            sharedGridData.exclusionData[id] =[];
                            for(var i =0 ; i<sharedGridData.excludeListArray.length;i++){
                                sharedGridData.exclusionData[id].push({ name: sharedGridData.excludeListArray[i]});
                            }
                        }
                        sharedGridData.directoryId = id;
                        sharedGridData.inventoryInstanceName = item;
                    }
            }
        }
	  

    var protectionrules = $scope.getProtectionRulesArray(sharedGridData.inclusionData[id],sharedGridData.exclusionData[id]);
     if(angular.isUndefined(protectionrules)){
         protectionrules ="";
     }
     $scope.inventoryData.push({id:id,name:item,rules:protectionrules});
     $scope.instanceArray.push({id:id,name:item});

 }
	
 	$scope.getProtectionRulesArray = function(inclusionData,exclusionData){
		    var protectionRulesInclusionArray = [];
		    var protectionRulesExclusionArray = [];
            var protectionRulesArray =[];
            if(!angular.isUndefined(inclusionData)){
    		    for(var i =0; i<inclusionData.length;i++){
    			    protectionRulesInclusionArray.push(inclusionData[i].name)
    		    }
                protectionRulesArray.push("Included List: "+protectionRulesInclusionArray.toString());
            }
            if(!angular.isUndefined(exclusionData)){
    		    for(var j =0; j<exclusionData.length;j++){
    			   protectionRulesExclusionArray.push(exclusionData[j].name);
    		    }
                protectionRulesArray.push("Excluded List: "+protectionRulesExclusionArray.toString());
            }
		  
            return protectionRulesArray.toString();
		}
   /***********************************Search functionality of Jstree*************************************************/
    	$scope.search = function(){
		  var to = false;	
		if(to) { clearTimeout(to); }
		to = setTimeout(function () {
		  var v = $('#inventorySearchInputId').val();
		  $('#jstreeDivId').jstree(true).search(v);
		}, 200);
	  }
  
  /********************************************************end of Tree view***************************************************************************************/
  
  /***************************************************** Schedular intialization code *****************************************************************************/
        $scope.daysFull=[{name:'SUN',id:'run_on_sun_full',val:"0"},{name:'MON',id:'run_on_mon_full',val:"1"},{name:'TUE',id:'run_on_tue_full',val:"2"},{name:'WED',id:'run_on_wed_full',val:"3"},{name:'THR',id:'run_on_thr_full',val:"4"},{name:'FRI',id:'run_on_fri_full',val:"5"},{name:'SAT',id:'run_on_sat_full',val:"6"}];
    
            $scope.daysIncr=[{name:'SUN',id:'run_on_sun_incr',val:"0"},{name:'MON',id:'run_on_mon_incr',val:"1"},{name:'TUE',id:'run_on_tue_incr',val:"2"},{name:'WED',id:'run_on_wed_incr',val:"3"},{name:'THR',id:'run_on_thr',val:"4"},{name:'FRI',id:'run_on_fri',val:"5"},{name:'SAT',id:'run_on_sat_incr',val:"6"}];
            
            $scope.recursTimeSelect = {};
			$scope.fullRecurseSelectModel ={};
			
			$scope.recursCheck = false;
			$scope.fullsRecurenceCheck = false;
			
			$scope.recursTime=[{id:0,name:'Hour'},{id:1,name:'Minutes'}];
			
            $scope.recursTimeSelect.id = $scope.recursTime[0].id;
			$scope.fullRecurseSelectModel.id = $scope.recursTime[0].id;
			
			$scope.recursObj= {};
			
	      
            $scope.backupModes = [];
            $scope.backup_types = {};
            $scope.full_DaySelectionError = false;
            $scope.incr_DaySelectionError = false;
            $scope.calendarData = [];
            $scope.backupModesforJob = {};
            $scope.scheduleForm = {};
            $scope.isFull = true;
            $scope.isIncremental = false;
            $scope.isDifrrential = false;
            $scope.fullDaySelection = ["SUN"];
            $scope.incrDaySelection = ["SUN"];
            $scope.setJobScheduleDefaults = function(){
				$scope.starttimeIncr =  "05:00 AM";
                $scope.starttimeFull =  "05:00 AM";
                $scope.scheduleTypeSelection = {
                    name: 'Now'
                };
                $scope.isScheduled = false;
                $scope.checkboxModel = {
                    jobReport : true,
                    failureReport : true
                };
                
            }
            $scope.setEditJobOrderCalendarData=function(calendarObjectArray){
                console.log($scope.jobOrders);
                $scope.isScheduled = true;
                $scope.checkboxModel = {
                    jobReport : $scope.jobOrders.email_report,
                    failureReport : $scope.jobOrders.failure_report
                };
                $scope.scheduleTypeSelection = {
                    name: 'Scheduled'
                };
                if(!angular.isUndefined(calendarObjectArray) && calendarObjectArray.length > 1){
                    var backuptypeFirst= "Fulls and ";

                    var backuptypeSecond= calendarObjectArray[1].backup_type+"s";
                    $scope.isIncremental=(calendarObjectArray[1].backup_type=='Incremental')?true:false;
                    $scope.isDifrrential=(calendarObjectArray[1].backup_type=='Difrrential')?true:false;
                    $scope.backup_type=backuptypeFirst+backuptypeSecond;
                    $scope.starttimeFull=calendarObjectArray[0].start_time;
                    $scope.starttimeIncr=calendarObjectArray[1].start_time;
                    $scope.fullDaySelection=$scope.changeNumberToDaysArray(calendarObjectArray[0].run_on);
                    $scope.incrDaySelection=$scope.changeNumberToDaysArray(calendarObjectArray[1].run_on);
                    $("#id_job_start_date_full").val(calendarObjectArray[0].start_date);
                    $scope.start_date_full =calendarObjectArray[0].start_date;
                    $scope.start_date_incr=calendarObjectArray[1].start_date;
                    $("#id_job_start_date_incr").val(calendarObjectArray[0].start_date);

                }else{
                    console.log(calendarObjectArray[0].run_on);
                    $scope.isDifrrential = false;
                    if (calendarObjectArray[0].backup_type == 'Incremental') {
                        $scope.backup_type= "Incremental Forever";
                        $scope.isIncremental = true;
                        $scope.isFull = false;
                    } else {
                        $scope.backup_type= calendarObjectArray[0].backup_type+"s";
                    }
                    $("#id_job_start_date_full").val(calendarObjectArray[0].start_date);
                    $scope.start_date_full =calendarObjectArray[0].start_date;
                    $scope.start_date_incr=calendarObjectArray[0].start_date;
                    $("#id_job_start_date_incr").val(calendarObjectArray[0].start_date);
                    $scope.fullDaySelection=$scope.changeNumberToDaysArray(calendarObjectArray[0].run_on);
                    $scope.incrDaySelection=$scope.changeNumberToDaysArray(calendarObjectArray[0].run_on);
                    console.log( $scope.fullDaySelection);
                    $scope.starttimeFull=calendarObjectArray[0].start_time;
                    $scope.starttimeIncr=calendarObjectArray[0].start_time;

                }
                //Recurrence Intraday.
                $scope.setEditRecurrenceData(calendarObjectArray);
            }
			
			$scope.setEditRecurrenceData = function(calendarObjectArray){
			    	var reccurencVal ="";
				    var fullReccurenceVal ="";

                if (calendarObjectArray[0] !== undefined) {
                    if(calendarObjectArray[0].recurrence !== undefined &&
                        calendarObjectArray[0].recurrence !=""  && calendarObjectArray[0].recurrence != 0) {
                        if (!$scope.isFull && $scope.isIncremental) {
                            $scope.recursObj.recursCheck = true;
                        } else {
                            $scope.recursObj.fullsRecurenceCheck = true;
                        }

                        if(calendarObjectArray[0].recurrence >= 60){
                            if(!angular.isUndefined(calendarObjectArray[0])){
                                fullReccurenceVal = parseInt(calendarObjectArray[0].recurrence/60);
                            }
                        }else{
                            fullReccurenceVal= calendarObjectArray[0].recurrence;
                            $scope.fullRecurseSelectModel.id =1;
                        }
                        if (!$scope.isFull && $scope.isIncremental) {
                            $('#recurs_spinner_field').val(fullReccurenceVal);
                            $scope.recursObj.time =fullReccurenceVal;
                        } else {
                            $('#fullsRecurenceSpinnerField').val(fullReccurenceVal);
                            $scope.recursObj.fullsRecurenceTime =fullReccurenceVal;
                        }
                    }else{
                        if (!$scope.isFull && $scope.isIncremental) {
                            $scope.recursObj.recursCheck = false;
                        } else {
                            $scope.recursObj.fullsRecurenceCheck = false;
                        }
                    }
                }

                if (calendarObjectArray[1] !== undefined) {
                    if(calendarObjectArray[1].recurrence !== undefined &&
                        calendarObjectArray[1].recurrence !="" && calendarObjectArray[1].recurrence != 0) {
                        $scope.recursObj.recursCheck = true;

                        if(calendarObjectArray[1].recurrence >= 60){
                            if(!angular.isUndefined(calendarObjectArray[1])){
                                reccurencVal = parseInt(calendarObjectArray[1].recurrence/60);
                            }
                        }else{
                            reccurencVal = calendarObjectArray[1].recurrence;
                            $scope.recursTimeSelect.id = 1;
                        }
                        $('#recurs_spinner_field').val(reccurencVal);
                        $scope.recursObj.time = reccurencVal;
                    }else{
                        $scope.recursObj.recursCheck = false;
                    }
                }
			}
			
            $scope.backupTypeLabel = "Incremental Backup";
            
             $scope.schedulerData = {
                 name: "VM schedule",
                 calendar: $scope.calendarData,
                 storage: "Internal",
                 instances: [ 3, 34 ],
                 email_report: false,
                 failure_report: false,
                 legal_hold_backups: false,
                 email_addresses: ""
            };

			
/************************************************* On click of wizard next button**************************************************************/            
            $scope.nextWizard = function($event){
                $scope.recursObj.time  = 1;
				$scope.recursObj.fullsRecurenceTime  = 1;
				
               if(wizardTitle == "Select Items"){//1st step 
                    if(document.getElementById("backupJobID").value == "" || $scope.inventoryData.length == 0){
                        return;
                    }
                    
                   $(".datepicker input:text").datepicker({
                        showOn: "both",
                        buttonText: '<img src="assets/images/calendar.png" width="24" height="24">',
                        dateFormat: DATE_FORMAT
                    }).attr("placeholder", DATE_DISPLAY_FORMAT);
                    if($scope.isEdit){
                        console.log('$scope.isEdit' + $scope.isEdit);
                        $scope.setEditJobOrderCalendarData($scope.jobOrders.calendar);
                       // $(".datepicker input:text").datepicker("setDate", new Date());
                    }else{
                        $(".datepicker input:text").datepicker("setDate", new Date());
                        $scope.start_date_full = $("#id_job_start_date_full").val();
                        $scope.start_date_incr = $("#id_job_start_date_incr").val();
                        $scope.setJobScheduleDefaults();
                        console.log('$scope.isEdit' + $scope.isEdit);
                        
                    }
                    $('#cal_start_time_full').timeEntry();
                    $('#cal_start_time_incr').timeEntry();
				    $('#recurs_time').timeEntry();
				    $scope.recurstimeModeChange();
                    $scope.getSchedule();
                    $scope.getStorage();
                   
                   $rootScope.$broadcast("nextBtnClick");   
                   
                }
              
                if(wizardTitle == "Define Job Settings"){ //2nd step 
             	
				    $scope.timeInHrsflag = false;
					$scope.timeInMinflag = false;
				
                    $scope.incr_start_time = $("#cal_start_time_incr").val();
                    $scope.full_start_time = $("#cal_start_time_full").val();
                  
                    if($scope.fullDaySelection.length ==0 && $scope.isScheduled) {
                        $scope.full_DaySelectionError = true;
                    }else {
                        $scope.full_DaySelectionError = false;
                        
                    }
                    
                    if($scope.incrDaySelection.length ==0 && $scope.isScheduled) {
                        $scope.incr_DaySelectionError = true;
                    }else {
                        $scope.incr_DaySelectionError = false;
                        
                    }
                    console.log($scope.scheduleForm.myForm.$valid && $scope.incr_DaySelectionError == false && $scope.full_DaySelectionError == false);
                    if($scope.scheduleForm.myForm.$valid && $scope.incr_DaySelectionError == false && $scope.full_DaySelectionError == false) {
                        var clientId=0;
                    
                    var clientsList = [];
                        for(var i=0;i<$scope.inventoryData.length;i++){
                            var client ={};
                            client.id = Number($scope.inventoryData[i].id.split("_")[1]);
                            client.incl_list =[];
                            var selectedNodeId = $scope.inventoryData[i].id;
                            for(var j=0;j<sharedGridData.inclusionData[selectedNodeId].length;j++){
                                client.incl_list.push(sharedGridData.inclusionData[selectedNodeId][j].name);
                            }
                            client.excl_list = [];
                            for(var j=0;j<sharedGridData.exclusionData[selectedNodeId].length;j++){
                                client.excl_list.push(sharedGridData.exclusionData[selectedNodeId][j].name);
                            }
                            
                            clientsList.push(client);
                        }
                
                    if($scope.isScheduled){
						$scope.timeInHrsErrflag =false;
						$scope.timeInMinErrflag=false;
						$scope.recurrenceFullHrsErrflag =false;
						$scope.recurrenceFullMinErrflag=false;
						
						var recurrenceVal = $('#recurs_spinner_field').val();
						var fullRecurrenceVal = $('#fullsRecurenceSpinnerField').val();
					
						if(recurrenceVal > 12 && $scope.recursTimeSelect.id == 0 ){
							$scope.timeInHrsErrflag =true;
							return;
						}
						if(recurrenceVal > 60 && $scope.recursTimeSelect.id == 1){
							$scope.timeInMinErrflag=true;
							return;
						}
						if(fullRecurrenceVal > 12 && $scope.fullRecurseSelectModel.id == 0 ){
							$scope.recurrenceFullHrsErrflag =true;
							return;
						}
						if(fullRecurrenceVal > 60 && $scope.fullRecurseSelectModel.id == 1){
							$scope.recurrenceFullMinErrflag=true;
							return;
						}
						
						$scope.collectRecurrenceData(recurrenceVal,fullRecurrenceVal);
						
                        var httpMethod = 'post';
                            var jobOrderUrl = '/api/joborders/?sid='+$scope.jobOrders.app_id;

                            if($scope.isEdit == true){
                                httpMethod = 'put';
                                jobOrderUrl = '/api/joborders/'+$scope.jobOrders.id+'/?sid='+$scope.jobOrders.app_id;

                            }

                        if($scope.isNAS){
                            if($scope.backupModesforJob.name !== 'Selective'){
                                    clientsList[0].incl_list = [];
                            }
                            $scope.jobOrdersSubmit = { 
                                                name:$scope.backupJobNameModel,
                                                type:"backup",
                                                verify:"none",
                                                app_id:1,
                                                client_id:clientsList[0].id,
                                                email_report: $scope.checkboxModel.jobReport,
                                                failure_report:$scope.checkboxModel.failureReport,
                                                calendar:$scope.calendarData,
                                                incl_list:clientsList[0].incl_list,
                                                excl_list:clientsList[0].excl_list,
                                                storage:$scope.backupTarget.selectedBackupTarget
                                          };
                           
                                console.log("NAS Joborder:-"+$scope.jobOrdersSubmit);
                        } else {

                            $scope.jobOrdersSubmit = { 
                                                name:$scope.backupJobNameModel,
                                                type:"backup",
                                                verify:"none",
                                                app_id:1,
                                                clients:clientsList,
                                                email_report: $scope.checkboxModel.jobReport,
                                                failure_report:$scope.checkboxModel.failureReport,
                                                calendar:$scope.calendarData,
                                                storage:$scope.backupTarget.selectedBackupTarget
                                          };
                           
                                console.log("Not NAS Joborder:-"+ $scope.jobOrdersSubmit);

                        }      
                             $http({
                                method: httpMethod,
                                url : jobOrderUrl,
                                data: JSON.stringify($scope.jobOrdersSubmit )
                            }).success(function(data, status, headers){
                                    // ngDialog.close('backup-physical-dailog');
                                    console.log(JSON.stringify(data));
                                    ngDialog.open({
                                        dialogType:'information',
                                        dialogMessage:"Job order created successfully."
                                    });
                                     sharedGridData.includeListArray = [];
                                     sharedGridData.excludeListArray = [];
                                     sharedGridData.protectionRulesArray = [];
                                    $(document).trigger("editJob");
                            }).error(function(response) { 
                                    ngDialog.open({
                                     dialogType:'retry',
                                     dialogMessage:response.result[0].message
                                    })
                            });
                        }else{

                            if($scope.isNAS){
                                
                                if($scope.backupModesforJob.name !== 'Selective'){
                                    clientsList[0].incl_list = [];
                                }

                                  $scope.backupJob = { 
                                            type:"backup",
                                            verify:"none",
                                            client_id:clientsList[0].id,
                                            email_report: false,
                                            failure_report:false,
                                            instances:[],
                                            incl_list:clientsList[0].incl_list,
                                            excl_list:clientsList[0].excl_list,
                                            storage:$scope.backupTarget.selectedBackupTarget,
                                            backup_type:$scope.demandObj.backup_type
                                      };
                       
                            console.log("NAS On demand:-"+$scope.backupJob );
                        } else {
                                $scope.backupJob = { 
                                            type:"backup",
                                            verify:"none",
                                                clients:clientsList,
                                            email_report: false,
                                            failure_report:false,
                                            instances:[],
                                            storage:$scope.backupTarget.selectedBackupTarget,
                                            backup_type:$scope.demandObj.backup_type
                                      };
                       
                            console.log("Not NAS On demand:-"+$scope.backupJob );
                            

                        }   
                         $http({
                                method: 'put',
                                url : '/api/backups/?sid='+$scope.jobOrders.app_id,
                                data: JSON.stringify($scope.backupJob )
                            }).success(function(data, status, headers){
                                    var message ="";
                                    for(var i=0; i<Object.keys(data.data).length;i++){
                                        if(data.data[i].job_id === -1){
                                            message = message +"<br>"+ "Failed to create Backup Job for client "+data.data[i].client_name+". "+data.data[i].message;
                                        }else {
                                            message = message +"<br>"+ "Backup Job for client "+data.data[i].client_name+" created successfully and job id is "+data.data[i].job_id;
                                        }    

                                    }
                                    ngDialog.open({
                                        dialogType:'information',
                                        dialogMessage:message
                                    });
                                    //ngDialog.close('backup-physical-dailog');
                                    sharedGridData.includeListArray = [];
                                    sharedGridData.excludeListArray = [];
                                    sharedGridData.protectionRulesArray= [];
                            }).error(function(response) { 
                                    ngDialog.open({
                                     dialogType:'retry',
                                     dialogMessage:response.result[0].message
                                    })
                            });

                        }
                    }
                }
            };
            
             $scope.getStorage = function(){
                var storageApi = "/api/storage/?sid="+$scope.jobOrders.app_id+"&usage=backup";
                $scope.backupTarget ={};

                 $http.get(storageApi)
                .then(function(response){ 
                    $scope.backupTarget.targets =[];
                    $scope.backupTarget.selectedBackupTarget = response.data.storage[0].name;
                    for(var j=0;j<response.data.storage.length ;j++){
                        $scope.backupTarget.targets.push({name:response.data.storage[j].name,value:response.data.storage[j].name});
                        if ($scope.isEdit && $scope.jobOrders.storage != "") {
                            $scope.backupTarget.selectedBackupTarget = $scope.jobOrders.storage;
                        } else {
                            if(response.data.storage[j].is_default){
                                $scope.backupTarget.selectedBackupTarget = response.data.storage[j].name;
                            }
                        }
                    }
                },function(reason){
                    console.log(reason);
                });
            }

            $scope.getSchedule = function() {
                var scheduleApi = "/api/backups/strategies/1/";
                if($scope.isNAS){
                    scheduleApi = "/api/backups/strategies/1/?isNAS=true";
                }
                $http.get(scheduleApi)
                    .then(function(response){

                        if($scope.isScheduled == false) {
                            $scope.backupModes = response.data.on_demand;
                            if($scope.isEdit){
                                $scope.backupModesforJob.name= $scope.backup_type;
                            }else {
                                $scope.backupModesforJob.name= $scope.backupModes[0];
                                if($scope.isNAS){
                                    $scope.backupModesforJob.name= "Selective";
                                }
                            }

                        } else {
                            var tempMap = new Object();
                            for(var i=0; i< response.data.strategies.length;i++) {
                                $scope.backup_types[response.data.strategies[i].name] = response.data.strategies[i].backup_types;
                                $scope.backupModes[i] = response.data.strategies[i].name;
                                if($scope.isEdit){
                                    $scope.backupModesforJob.name= $scope.backup_type;
                                }else {
                                    $scope.backupModesforJob.name= $scope.backupModes[0];
                                    if($scope.isNAS){
                                        $scope.backupModesforJob.name= "Selective";
                                    }
                                }
                            }
                        }

                        $scope.backupmodeChange(true);
                    },function(reason){
                        console.log(reason);
                    });
            }
            
			
			
		//Set backend recurrence data
			$scope.collectRecurrenceData = function(recurrenceVal,fullRecurrenceVal){
				$scope.recursObj.time = recurrenceVal;
				$scope.recursObj.fullsRecurenceTime = fullRecurrenceVal;

				// For Incremental and differential
				if($scope.recursObj.recursCheck){
					if($scope.recursTimeSelect.id == 0){
						$scope.incrObj.recurrence = recurrenceVal*60;
						$scope.diffObj.recurrence = recurrenceVal*60;
					}else{	
						$scope.incrObj.recurrence = recurrenceVal;
						$scope.diffObj.recurrence = recurrenceVal;
					}
				 }else{ 
						$scope.incrObj.recurrence = "";
						$scope.diffObj.recurrence = "";
				 }
					//For full recurrence.
				if($scope.recursObj.fullsRecurenceCheck){
					if($scope.fullRecurseSelectModel.id == 0){
					  $scope.fullObj.recurrence = fullRecurrenceVal*60;

					}else{
					  $scope.fullObj.recurrence = fullRecurrenceVal;
					}
				 }else $scope.fullObj.recurrence = "";

				 console.log(fullRecurrenceVal+":::"+recurrenceVal);
    		}
			
			
		 //Recurrence Intraday.	
		$scope.recurstimeModeChange	= function(){
			if($scope.recursTimeSelect.id == 0){
				$("#recurs_spinner_field").spinner({min: 1, max: 12});
		 	}else{
				$("#recurs_spinner_field").spinner({min: 1, max: 60});
			}
			if($scope.fullRecurseSelectModel.id == 0){
				$("#fullsRecurenceSpinnerField").spinner({min: 1, max: 12});
		 	}else{
				$("#fullsRecurenceSpinnerField").spinner({min: 1, max: 60});
			}
			
		}
	    //End
		
        $scope.changeDaysToNumberArray = function(daysArray){
            var daysNumberArray = [];
            for(var i =0; i<daysArray.length; i++){
                if(daysArray[i] === "SUN"){
                    daysNumberArray.push(0);                     
                }else if(daysArray[i] === "MON"){
                    daysNumberArray.push(1);                     
                }else if(daysArray[i] === "TUE"){
                    daysNumberArray.push(2);                     
                }else if(daysArray[i] === "WED"){
                    daysNumberArray.push(3);                     
                }else if(daysArray[i] === "THR"){
                    daysNumberArray.push(4);                     
                }else if(daysArray[i] === "FRI"){
                    daysNumberArray.push(5);                     
                }else if(daysArray[i] === "SAT"){
                    daysNumberArray.push(6);                     
                } 
            }

            return daysNumberArray;

        }    
        $scope.changeNumberToDaysArray = function(numberArray){
            var numberToDays = [];
            for(var i =0; i<numberArray.length; i++){
                if(numberArray[i] == 0){
                    numberToDays.push("SUN");                     
                }else if(numberArray[i] == 1 ){
                    numberToDays.push("MON");                     
                }else if(numberArray[i] == 2){
                    numberToDays.push("TUE");                     
                }else if(numberArray[i] == 3 ){
                    numberToDays.push("WED");                     
                }else if(numberArray[i] == 4){
                    numberToDays.push("THR");                     
                }else if(numberArray[i] == 5){
                    numberToDays.push("FRI");                     
                }else if(numberArray[i] == 6){
                    numberToDays.push("SAT");                     
                } 
            }

            return numberToDays;

        } 
		$scope.backupmodeChange = function(edit) {
            var edit = edit || false;
          
			console.log($scope.recursObj.time);
			$scope.recurstimeModeChange();
			 $scope.fullObj = {
                run_on: $scope.changeDaysToNumberArray($scope.fullDaySelection),
                schedule_run: 0,
                start_date: $scope.start_date_test,
                start_time: $scope.starttimeFull,
                backup_type: ""
            };
            $scope.incrObj = {
                run_on: $scope.changeDaysToNumberArray($scope.incrDaySelection),
                schedule_run: 0,
                start_date: $scope.start_date_test,
                start_time: $scope.starttimeIncr,
                backup_type: "", 
            };
    
            $scope.diffObj = {
                run_on: $scope.changeDaysToNumberArray($scope.incrDaySelection),
                schedule_run: 0,
                start_date: $scope.start_date_test,
                start_time: $scope.starttimeIncr,
                backup_type: "", 
            };
            $scope.demandObj = {
                backup_type: $scope.backupModesforJob.name 
            };
            
            if($scope.backupModesforJob.name == "Fulls") {

                if (!edit) {
                    $scope.incrDaySelection = ["SUN"];
                }
                $scope.isIncremental = false;
                $scope.isDifrrential = false;
                $scope.isFull = true;
                
                 $scope.fullObj.backup_type = $scope.backup_types['Fulls'][0];
                
                $scope.calendarData.splice(0,$scope.calendarData.length);
                
                $scope.calendarData.push($scope.fullObj);
            } else if($scope.backupModesforJob.name == "Incremental Forever") {

                if (!edit) {
                    $scope.incrDaySelection = ["SUN", "MON", "TUE", "WED", "THR", "FRI", "SAT"];
                }
                $scope.isIncremental = true;
                $scope.isDifrrential = false;
                $scope.isFull = false;
                
                //$scope.fullObj.backup_type = $scope.backup_types['Incremental Forever'][0];
                
                $scope.incrObj.backup_type = $scope.backup_types['Incremental Forever'][0];

				$scope.calendarData.splice(0,$scope.calendarData.length);
                
                //$scope.calendarData.push($scope.fullObj);
				$scope.calendarData.push($scope.incrObj);
                
			} else if($scope.backupModesforJob.name == "Fulls and Incrementals") {
                
                $scope.isIncremental = true;
                $scope.isDifrrential = false;
                $scope.isFull = true;
                
                $scope.backupTypeLabel = "Incremental Backup";
                
                $scope.fullObj.backup_type = $scope.backup_types['Fulls and Incrementals'][0];
                
                $scope.incrObj.backup_type = $scope.backup_types['Fulls and Incrementals'][1];

				$scope.calendarData.splice(0,$scope.calendarData.length);

				$scope.calendarData.push($scope.fullObj);
				$scope.calendarData.push($scope.incrObj);
                
			} else if($scope.backupModesforJob.name == "Fulls and Differentials") {
                
                $scope.isIncremental = false;
                $scope.isDifrrential = true;
                $scope.isFull = true;
                
                $scope.backupTypeLabel = "Diffrential Backup";
                
                $scope.fullObj.backup_type = $scope.backup_types['Fulls and Differentials'][0];
                
                $scope.diffObj.backup_type = $scope.backup_types['Fulls and Differentials'][1];


				$scope.calendarData.splice(0,$scope.calendarData.length);

				$scope.calendarData.push($scope.fullObj);
				$scope.calendarData.push($scope.diffObj);
                
			} else {
                
                $scope.demandObj.backup_type = $scope.backupModesforJob.name;
                
                $scope.calendarData.splice(0,$scope.calendarData.length);
                $scope.calendarData.push($scope.demandObj);
            }
		};


		$scope.fullSelections = function (dayName) {
			var idx = $scope.fullDaySelection.indexOf(dayName);

			if (idx > -1) {
				$scope.fullDaySelection.splice(idx, 1);
			}
			else {
				$scope.fullDaySelection.push(dayName);
			}

            $scope.fullObj.run_on= $scope.changeDaysToNumberArray($scope.fullDaySelection);
             

		};

        $scope.updateDateTime = function () {
           
            $scope.incr_start_time = $("#cal_start_time_incr").val();
            $scope.full_start_time = $("#cal_start_time_full").val();
            $scope.start_date_full = $("#id_job_start_date_full").val();
            $scope.start_date_incr = $("#id_job_start_date_incr").val();
                  
            $scope.fullObj.start_date = $scope.start_date_full;
            $scope.fullObj.start_time = $scope.full_start_time;
            $scope.incrObj.start_date = $scope.start_date_incr;
            $scope.diffObj.start_date = $scope.start_date_incr;
            $scope.incrObj.start_time = $scope.incr_start_time;
            $scope.diffObj.start_time = $scope.incr_start_time;
        }

		$scope.incrSelections = function (dayName) {
			var idx = $scope.incrDaySelection.indexOf(dayName);

			if (idx > -1) {
				$scope.incrDaySelection.splice(idx, 1);
			}
			else {
				$scope.incrDaySelection.push(dayName);
			}
             $scope.incrObj.run_on= $scope.changeDaysToNumberArray($scope.incrDaySelection);
             $scope.diffObj.run_on = $scope.changeDaysToNumberArray($scope.incrDaySelection);
                
		};   

		$scope.jobType = function() {
            if($scope.scheduleTypeSelection.name == "Now") {
              $scope.isScheduled = false;  
            } else {
				$scope.recurstimeModeChange();
			    $scope.isScheduled = true;  
            }
            $scope.getSchedule();
		};	  

			
/********************************************************end of first Tree view  and main Dialog*******************************************************************/
  
		
/********************************************************Start of Edit setting Server Dialog***********************************************************************/
		 
      $scope.openEditSettingServerDialog = function(row,cell,column){
		  
		   $rootScope.selectedCell = cell;
           $rootScope.selectedRow = row;
           $rootScope.selectedColumn = column;
		    sharedGridData.directoryId = row.id;
            sharedGridData.inventoryInstanceName = row.name;
            var index = sharedGridData.inventoryInstanceName.indexOf("-NAS-RRC");
            if(index != undefined && index !=null && index > -1){
                $scope.isNAS = true;
            }else{
                $scope.isNAS = false;
            }

            
		  
           ngDialog.open({
                            template: 'app/protect/backup-physical/fileServerSettingDialogTemplate.html',
                            scope: $scope,
                            overlay:true,
                            modelDialogId:'file-serverSetting-dailog',
							ngDialogStyle:'width:600px;height:520px;',
                            preCloseCallback: function (value) {}
            });
	  }
	  
	  /*******************************For verify backup tooltip***********************************/
	  $scope.showtoolTipForVerifyBackup = function(){
		  var form1 = angular.element("#test-job-form");
			console.log(form1)
	   	   form1.find(".definition").popover({
				position: {
					my: "left top",
					at: "right+20 top"
				},
				appendTo: form1
			});
      }
	
   }])

 .controller('editServerSettingCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','dataToBeShared','sharedGridData',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,dataToBeShared,sharedGridData) {
		
		//$scope.tab = $scope.isNAS? 2 : 1 ;
            $scope.tab =1;
            
      	//sharedGridData.currentTab = $scope.isNAS? 2 :1;
            sharedGridData.currentTab = 1;
            
		    $scope.inclusionCheckboxModel = false;	
			console.log(sharedGridData);
 /******************************************************************Browse file Setting Grid********************************************/
		  $scope.browsefileSettingGridOptions = {};		
		  $scope.browseFileSettingColumnDefs = [{field: 'name',displayName:'Name'},
												{field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity,1)"/></div>'}];
		  $scope.browseExcludeFileGridOptions = {};		 
		  $scope.browseExcludeFileColumnDefs = [{field: 'name',displayName:'Name'},
												{field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity,2)"/></div>'}];
		
		  $scope.browsefileSettingGridOptions = {columnDefs: $scope.browseFileSettingColumnDefs,data:'inclusionData',enableHorizontalScrollbar:0,};
	 	 // $scope.browsefileSettingGridOptions.data= sharedGridData.inclusionData[sharedGridData.directoryId];
	 
	      $scope.browseExcludeFileGridOptions = {columnDefs: $scope.browseExcludeFileColumnDefs,data:'exclusionData',enableHorizontalScrollbar:0,};
	 	  //$scope.browseExcludeFileGridOptions.data= sharedGridData.exclusionData[sharedGridData.directoryId];
			
		  $scope.inclusionData = sharedGridData.inclusionData[sharedGridData.directoryId];
		  $scope.exclusionData = sharedGridData.exclusionData[sharedGridData.directoryId];
		
			
		   $scope.showCurrentTab = function(currentTab){
			  sharedGridData.currentTab = currentTab;
              $(window).resize();
	    	}
	
           $scope.addBrowseItem = function(listArray){
             if(sharedGridData.currentTab == 1) {
				 for(var i=0;i<listArray.length;i++){
				    var temparray= sharedGridData.inclusionData[sharedGridData.directoryId];
				    temparray.push(listArray[i]);
				    $scope.inclusionData = temparray;
				    sharedGridData.inclusionData[sharedGridData.directoryId] = temparray;
				 }
				  
			   }else{ 
				    for(var j=0;j<listArray.length;j++){
					   var temparray= [];
					   var temparray =sharedGridData.exclusionData[sharedGridData.directoryId];
					   sharedGridData.exclusionData[sharedGridData.directoryId]=[];
					   var index = sharedGridData.inventoryInstanceName.indexOf("-NAS-RRC");
					   var dirName = ""
					   if(index != undefined && index !=null && index > -1){
						dirName ="/mnt/nas/"+sharedGridData.inventoryInstanceName.substring(0,index)+"/";
					   }
					   listArray[j].name = dirName+listArray[j].name;
					   temparray.push(listArray[j]);
				 	   $scope.exclusionData = temparray;
				       sharedGridData.exclusionData[sharedGridData.directoryId] = temparray;
				    }
			   }
           }    
         $rootScope.$on('clearInventorySettingGrid', function (event){		
			 if(sharedGridData.currentTab == 1) {
				  sharedGridData.browseIncludeFileData = [];
				  ngDialog.close('file-browserSetting-dailog');
			  }else{
				  sharedGridData.browseExcludeFileData = [];
				  ngDialog.close('file-browserSetting-dailog');
			 }
		   });

			
		$scope.selectTab = function (setTab){
			$scope.tab = setTab;
		};
		$scope.isSelected = function(checkTab) {
			
			return $scope.tab === checkTab;
		};
			
        $scope.addIncludeText = function(){
		   var obj = {name:$scope.includeText};
			var uniqueFlag = containsObject(obj,$scope.inclusionData);
			if(uniqueFlag != true && $scope.includeText != undefined){
				var tempVal= $scope.inclusionData;
				tempVal.push(obj);
				$scope.inclusionData = tempVal;
				sharedGridData.inclusionData[sharedGridData.directoryId] = tempVal;
			}
			$scope.includeText="";
		}
		 
		$scope.addExcludeText = function(){
			var obj = {name:$scope.excludeText};
			var uniqueFlag = containsObject(obj,$scope.exclusionData);
			if(uniqueFlag != true && $scope.excludeText != undefined){
				var tempVal= $scope.exclusionData;
				tempVal.push(obj)
				$scope.exclusionData = tempVal;
				sharedGridData.exclusionData[sharedGridData.directoryId] = tempVal;
			}
			$scope.excludeText="";
		}
		 
		
		function containsObject(obj, list) {
			if(!angular.isUndefined(list)){
				var i;
				for (i = 0; i < list.length; i++) {
					if (list[i].name === obj.name) {
						return true;
					}
				}
			}
			return false;
		}
		$scope.deleteRow = function(row,grid){
		 if(grid == 1){
			  var index = $scope.inclusionData.indexOf(row);
			  $scope.inclusionData.splice(index, 1);
			 }else{
		      var index = $scope.exclusionData.indexOf(row);
			  $scope.exclusionData.splice(index, 1); 
				 }
		 
	     }
		 $scope.$watch(function(){
            return dataToBeShared.objectList;
        }, function(newValue,oldValue){
             if(!angular.isUndefined(newValue) &&(angular.isUndefined(oldValue) || newValue.name != oldValue.name)){
                 console.log(newValue);
				 $scope.addBrowseItem(newValue);
                 dataToBeShared.objectList=undefined;
             }
        });
		$scope.savefileServerSettingData = function(){
			
			   sharedGridData.includeListArray =[];
			   sharedGridData.excludeListArray =[];
			   sharedGridData.protectionRulesArray =[];
			
			   for(var i=0;i<$scope.inclusionData.length;i++){
				   sharedGridData.includeListArray.push($scope.inclusionData[i].name);
			   }
			   for(var j=0;j<$scope.exclusionData.length;j++){
				   sharedGridData.excludeListArray.push($scope.exclusionData[j].name);
			   }
			  
			   sharedGridData.protectionRulesArray = [];
               if(sharedGridData.includeListArray.toString() !=null 
                && sharedGridData.includeListArray.toString()!=undefined
                && sharedGridData.includeListArray.toString()!= ""){
                    sharedGridData.protectionRulesArray[0]= "Included List: "+sharedGridData.includeListArray.toString();
               }
               if(sharedGridData.excludeListArray.toString() !=null 
                && sharedGridData.excludeListArray.toString()!=undefined
                && sharedGridData.excludeListArray.toString()!= ""){
                    sharedGridData.protectionRulesArray[1]= "Excluded List: "+sharedGridData.excludeListArray.toString();
               }
               
			
			   $rootScope.selectedColumn = "rules";
			   $rootScope.selectedRow[$rootScope.selectedColumn] = sharedGridData.protectionRulesArray.toString();
			   ngDialog.close('file-serverSetting-dailog');
		}
		
		$scope.closeEditServerSettingDialog =function(){
			sharedGridData.protectionRulesArray =[];
			ngDialog.close('file-serverSetting-dailog');
			
		}
		
		
		$scope.addPresets = function(tab){
			if(tab == 1){
				$scope.inclusionData = [];
				sharedGridData.inclusionData[sharedGridData.directoryId] = [];
				sharedGridData.includeListArray = [];
				sharedGridData.protectionRulesArray =[];
			}else{
				$scope.exclusionData = [];
				sharedGridData.exclusionData[sharedGridData.directoryId] = [];
				sharedGridData.excludeListArray = [];
				sharedGridData.protectionRulesArray =[];
		   }
		}
		
		$scope.openBrowseFileDialog	 = function(tab){
		    console.log(sharedGridData.directoryId +" --- "+sharedGridData.inventoryInstanceName);
			var dataObj={};
            var fileId = sharedGridData.directoryId.split("_")[1];
            if(fileId === null || fileId === undefined){
                fileId = sharedGridData.directoryId;
            }
            var index = sharedGridData.inventoryInstanceName.indexOf("-NAS-RRC");
            var dirName = ""
            if(index != undefined && index !=null && index > -1){
                dirName ="&dir="+"/mnt/nas/"+sharedGridData.inventoryInstanceName.substring(0,index);
            }

			var url = '/api/clients/files/'+fileId+'/?sid='+$scope.jobOrders.app_id+dirName;
			var fileBrowserTreeNodeUrl = '/api/clients/files/'+fileId+'/?sid='+$scope.jobOrders.app_id+'&dir=';
			dataObj = {fileBrowserTreeNodeUrl:fileBrowserTreeNodeUrl,url:url};
			
			fileBrowserDialogService.getfileBrowserTreeData(dataObj); // to open andget data for file browser tree.
			
		}
		
 }]);

