angular.module('fileBrowserDialogApp', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','backupJobModule'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
		  });
    	}])

.service('fileBrowserDialogService',['$rootScope','$http','ngDialog',function($rootScope,$http,ngDialog){
        this.getfileBrowserTreeData= function(dataObject){
            $rootScope.fileBrowserTreeNodeUrl = dataObject.fileBrowserTreeNodeUrl;
            var load = PHD.showLoadingIndicator("body", true, "Loading...");
            $http({
				method: 'get',
				url : dataObject.url
            }).success(function(data, status, headers){
				var jsonData = data.data;
				var treeObj = {}
				var treeArray = []; 
				var childDummayDataArray = [];
		        var finalTreeDataArray = [];
				
		     	for(var i=0;i<jsonData.length;i++){
		     		var index = jsonData[i].name.indexOf("/");
		            var nodeName = jsonData[i].name;
		            var nodeId = jsonData[i].id;
		            if(index != undefined && index !=null && index == -1){
			            nodeName = jsonData[i].name+"/";
			            nodeId = jsonData[i].id+"/"; 
            		}

					treeObj = {id:nodeId,parent:"#",text:nodeName,icon:(jsonData[i].isBranch == true)? "icon-hv-folder icon" : "icon-file icon",state: { opened: false},data:{expanded:false}};
					treeArray.push(treeObj);
					
				  var id = nodeId+"dummy";
				  if(jsonData[i].isBranch == true){
					 treeObj={id:id,parent:nodeId,text:"dummy",state: { opened: false}};  
					 childDummayDataArray.push(treeObj); 
				  }
				}

				finalTreeDataArray = treeArray.concat(childDummayDataArray);
			    $rootScope.originalData = finalTreeDataArray;
                PHD.hideLoadingIndicator(load);

                ngDialog.open({
                            template: 'app/protect/file-browser-dialog/fileBrowserDialogTemplate.html',
                            scope: $rootScope,
                            overlay:false,
                            modelDialogId:'file-browserSetting-dailog',
							ngDialogStyle:'width:800px;height:650px;',
                            preCloseCallback: function (value) {}
            	});
            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'Retry',
                    dialogMessage:response.result[0].message
                });
            });
		 };    
 }])

.controller('fileBrowserDialogCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','dataToBeShared', 'includeExcludeLabelService',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,dataToBeShared,includeExcludeLabelService) {
	    var newId = 1;
        $scope.ignoreChanges = false;
        $scope.newNode = {};
		$scope.selectedNode;
        $scope.selectedTreeNode = [];
        var fileBrowserTreeObj={};
		$scope.fileBrowserTreeArray = []; 
        
       $scope.treeData = $rootScope.originalData;
       
        // To set includeExclude Label on browser tree window		
        $scope.includeExcludeLabel = includeExcludeLabelService.getLabel();
		   
        $scope.treeConfig = {
            core : {
                multiple : true,
                animation: true,
                error : function(error) {$log.error('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            version : 1,
            plugins : ['types','dnd']
        };

        this.applyModelChanges = function() {
            return !$scope.ignoreChanges;
        };
        
 	
$scope.beforeOpen = function(e,item){
	        var url ="";
			var abc = [];
			var jstreeDivId = $("#fileBrowserTreeId");
	   
			if(item.node.data.expanded == false){
				
			  var ID = encodeURIComponent(item.node.id);
				
			  url =$rootScope.fileBrowserTreeNodeUrl+ID;
				
			  load=PHD.showLoadingIndicator(jstreeDivId);
				
			$http({
				method: 'get',
				url : url
			}).success(function(data, status, headers){
				var jsonData = data.data;
				
		        if(jsonData != null){
				   for(var i=0;i<jsonData.length;i++){
            	   fileBrowserTreeObj = {id:jsonData[i].id, parent:jsonData[i].directory,text:jsonData[i].name,icon:(jsonData[i].isBranch == true)? "icon-hv-folder icon" : "icon-file icon",
										 state: { opened: false},data:{expanded:false}}
					$scope.fileBrowserTreeArray.push(fileBrowserTreeObj);
					   
					var id = jsonData[i].id+"dummy";	
					if(jsonData[i].isBranch == true){
						fileBrowserTreeObj={id:id,parent:jsonData[i].id, text:"dummy",state: { opened: false}};  
						$scope.fileBrowserTreeArray.push(fileBrowserTreeObj);
					  }

					}

					angular.forEach($scope.fileBrowserTreeArray, function (e) { this.push(e); }, $scope.treeData)
					item.node.data.expanded =true;
					
					setTimeout(function(){  
						var dummyNodeID = item.node.id+"dummy";
						$('#fileBrowserTreeId').jstree(true).delete_node(item.instance.get_node(dummyNodeID));
						PHD.hideLoadingIndicator(load); 
						$(window).resize(); 
					}, 200);
				}else{
					var dummyNodeID = item.node.id+"dummy";
					$('#fileBrowserTreeId').jstree(true).delete_node(item.instance.get_node(dummyNodeID));
					PHD.hideLoadingIndicator(load); 
				}
			 }).error(function(response) { console.log(response);}); 
		   }
	
}

$scope.changedCB = function(e,item) {
            var i, j, r = [];
            for(i = 0, j = item.selected.length; i < j; i++) {
                r.push(item.instance.get_node(item.selected[i]).text);
            }
            angular.copy(r,$scope.selectedTreeNode);
            $scope.selectedItem = $scope.selectedTreeNode.toString();
			
};
	
$scope.nodeSelected = function(e,item){
	var i, j, r = [];
	$scope.filePathArray = [];
    for(i = 0, j = item.selected.length; i < j; i++) {
        $scope.filePathArray.push(item.selected[i]);
     }
	
	console.log($scope.filePathArray);
};
$scope.nodeDeselected = function(node,item){
	console.log(item.node.text);
	var index = $scope.filePathArray.indexOf(item.node.text);
	$scope.filePathArray.splice(index, 1);
}
$scope.addItem = function(){
	var listbox = document.tree.inventoryListbox;
	for(var i=0; i<$scope.filePathArray.length;i++){
	  addOption(listbox, $scope.filePathArray[i]);
	}
};

$scope.$on('totalListItem', function (event){	
	var listbox = document.tree.inventoryListbox;
	$scope.totalListItem = listbox.options.length;
	$(window).resize();
	console.log($scope.totalListItem);
});
			
function addOption(selectbox,node){
		var optn = document.createElement("OPTION");
		optn.text = node;
		optn.value = node;

		var exists = false;
		$('#listboxId option').each(function(){
			if (this.value == node) {
				exists = true;
			}
		});
	   
	  if(!exists && !angular.isUndefined(node) && node !== null){
		   selectbox.options.add(optn);
	       $scope.$broadcast("totalListItem");
	  }
}
	
$scope.removeItem = function(){
	var listbox = document.tree.inventoryListbox;
	var listBoxItems=[];
	  for(var i = 0; i < listbox.options.length; i++) {
         //if the option is selected, delete the option
         if(listbox.options[i].selected == true) {
          listBoxItems.push(listbox.options[i].value);
          }
       }
       for(var i = 0; i < listBoxItems.length; i++) {
	    	for(var j = 0; j < listbox.options.length; j++) {
	    		if(listBoxItems[i]==listbox.options[j].text){
	    			try {listbox.remove(j, null);} catch(error) {
	                  listbox.remove(j);
	          	  }
	          	  break;
	    		}
	    	}
       }
	   $scope.$broadcast("totalListItem");
   };
    
$scope.removeAllItem = function(){
	 var listbox = document.tree.inventoryListbox;
	 listbox.innerHTML = "";
	  $scope.$broadcast("totalListItem");
};

$scope.saveIncludeFiles = function(){
    var listbox = document.tree.inventoryListbox;
	
	$scope.inventoryListObj ={};
	$scope.inventoryListItems = [];

	for(var i = 0; i < listbox.options.length; i++) {
		$scope.inventoryListObj={ name: listbox.options[i].value};
		console.log($scope.inventoryListObj);
		$scope.inventoryListItems.push($scope.inventoryListObj);
	 }
	   dataToBeShared.objectList = $scope.inventoryListItems;
	
    listbox.innerHTML = "";
	ngDialog.close('file-browserSetting-dailog'); 
	
};

$scope.confirmDialog = function(){
    console.log($scope.totalListItem);
     if(parseInt($scope.totalListItem)>0){
         ngDialog.open({
             template: 'app/protect/file-browser-dialog/confirm-setting.html',
             scope: $scope,
             overlay: true,
             modelDialogId: 'confirmBrowserFileDlg',
             showHelpArticleButton: true,
             ngDialogStyle: 'width:46em; height:15em;  top: 70px;left: 27px;right: 27px;'
         });
    }else{
         $scope.closeThisDialog();
    }
};
$scope.closeDialogs = function(){
    ngDialog.close('file-browserSetting-dailog'); 
    ngDialog.close('confirmBrowserFileDlg'); 
};
$scope.cancellEvent = function(){
    ngDialog.close('confirmBrowserFileDlg'); 
};
 
/***************for Drag and Drop tree node******************/

  $(document).on('dnd_move.vakata', function (e, data) {
		      var t = $(data.event.target);
		       if(!t.closest('.jstree').length) {
                    if(t.closest('.treeListBox').length) {
				      data.helper.find('.jstree-icon').removeClass('jstree-er').addClass('jstree-ok');
                    }
                    else {
                        data.helper.find('.jstree-icon').removeClass('jstree-ok').addClass('jstree-er');
                    }
                }
	  
    }) .on('dnd_stop.vakata', function (e, data) {
				 var t = $(data.event.target);
                   if(!t.closest('.jstree').length) {
                     if(t.closest('.treeListBox').length) {
					      addDragNodesInList(data.data.nodes);
						  $(data.element).clone().appendTo(t.closest('.treeListBox'));
                     }
                }
     });


function addDragNodesInList(textArray){
    var listbox = document.tree.inventoryListbox;
	for(var i=0;i<textArray.length;i++){
	  if(textArray[i] != null){ 
		 addOption(listbox,textArray[i]);
	  } 
   }
}

}]); 			