angular.module('searchFLRModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','ngGrid','ui.bootstrap','inventory','checklist-model','ui.grid.selection'])
.directive('angularDatepicker', function ($parse) {
    return function (scope, element, attrs, controller) {
        var ngModel = $parse(attrs.ngModel);
        $(function(){
            element.datepicker({
               showOn: "both",
                buttonText: '<img src="assets/images/calendar.png" width="24" height="24">',
                dateFormat: DATE_FORMAT,
                onSelect:function (dateText, inst) {
                    scope.$apply(function(scope){
                        // Change binded variable
                        ngModel.assign(scope, dateText);
                    });
                }
            });
        });
    }
})
.directive('loading', function () {
      return {
        restrict: 'E',
        replace:true,
        template: '<span  class="loading" alt="Loading..."><i class="icon-restart icon-spin"></i></span>',
        link: function (scope, element, attr) {
              scope.$watch('loading', function (val) {
                  if (val)
                      $(element).show();
                  else
                      $(element).hide();
              });
        }
      }
  })
.filter('fixedDecimalPointTo2', function($filter) {
  return function(input) {
      return (input).toFixed(2);
  };
})
.controller('searchFLRController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','$timeout',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,$timeout) {
        $scope.showgrid=false;
        $scope.sizeLimit=false;
        $scope.showCheckError=false;
        $scope.noResults=false;
		$scope.emptyString=false;
        $scope.searchOption={};
        $scope.recoverOption={};
        $scope.searchOption.case=true;
        $scope.searchOption.expression=false;
        $scope.advance={};
        $scope.advance.open=false;
        $scope.search={};
        $scope.typeOptions=[
            {id:"0",name:"Backup"},
            {id:"1",name:"Backup Copy"}
        ];
        $scope.checkId=true;
        $scope.gridSelectedItems=0;
        $scope.nextValue="  Next  ";
        $scope.showSecondStep=true;
        $scope.ClientNameList=[];
        $scope.gridSelectedArray=[];
        $scope.columnDefinitions=[[
                          /*{ field: 'id', displayName:"Path",width:"**" ,cellTooltip: true},*/
                          { field: 'name', displayName:"Filename" ,cellTooltip: function (row, col) {
                                     return 'Path:' + row.entity.id;
                                } },
                          { field: 'date_string',displayName:"File Date" ,cellTooltip: true },
                          { field: 'backup_id', displayName:"BackupId" ,visible: false},
                          { field: 'backup_date', displayName:"Backup Date" ,cellTooltip: true},
                         { field: 'size', displayName:"Size (KB)",cellFilter: 'fixedDecimalPointTo2',cellTooltip: true}
                    ],[
                          { field: 'filename', displayName:"Path" ,cellTooltip: true},
                        { field: 'archive_date', displayName:"Archive Date",cellTooltip: true},
                          { field: 'date', displayName:"Date" ,cellTooltip: true},
                          { field: 'size', displayName:"Size" ,cellFilter: 'fixedDecimalPointTo2',cellTooltip: true},
                          { field: 'id', displayName:"BackupCopyId",visible: false}
                    ] 
        ]; 
        $scope.loading = true;
        $scope.selectedId=0;
        /*set Defaults for recoverOptions*/
        $scope.recoverOption.target={};
        $scope.recoverOption.target.flat=false;
        $scope.recoverOption.target.non_destructive=true;
        $scope.recoverOption.target.newer=false;
        $scope.recoverOption.target.today=false;
        $scope.recoverOption.target.unix=true;
        $scope.recoverOption.target.directory='';
        $scope.recoverOption.before_cmd='';
        $scope.recoverOption.after_cmd='';
        $scope.exclusionData=[];
        $scope.ckeckedIdList=[];
        $scope.excludeFlrOptionsColumnDefs = [{field: 'name',displayName:''},
                                            {field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity)"/></div>'}];
        $scope.excludeFlrOptions={
            columnDefs:$scope.excludeFlrOptionsColumnDefs,data:'exclusionData',enableHorizontalScrollbar:0
       };
        $scope.deleteRow = function(row){
                 var index = $scope.exclusionData.indexOf(row);
                 $scope.exclusionData.splice(index, 1); 
            }
        
        $scope.addExcludeText = function(){
            console.log($scope.recoverOption.excludeText);
           var obj = {name:$scope.recoverOption.excludeText};
            var uniqueFlag = containsObject(obj,$scope.exclusionData);
            if(uniqueFlag != true && $scope.exclusionData != undefined){
                $scope.exclusionData.push(obj);
            }
           $(window).resize();
           $scope.recoverOption.excludeText="";
        console.log($scope.exclusionData);
        }
        function containsObject(obj, list) {
            if(!angular.isUndefined(list)){
                var i;
                for (i = 0; i < list.length; i++) {
                    if (list[i].name === obj.name) {
                        return true;
                    }
                }
            }
            return false;
        }
        $scope.changeNextTabSettings = function(){
            console.log($scope.searchOption.type);
            $scope.ClientNameList=[];
            $scope.loading = true;
             var url=''; 
            if($scope.searchOption.type == 1){
                $scope.nextValue="  Save  ";
                $scope.showSecondStep=false;
                url='/api/assets/archive'
            }else{
                $scope.nextValue="  Next  ";
                $scope.showSecondStep=true;
                url='/api/assets'
            }
            $http({
                    method: 'get',
                    url   : url
                }).success(function(data, status, headers) {
                    $scope.loading = false;
                    for (var i =0 ; i < data.data.length ; i++){
                        var Obj= {
                            name : data.data[i].name,
                            id : data.data[i].id,
                            sid : data.data[i].system_id
                        }
                        $scope.ClientNameList.push(Obj);

                    }
                    $scope.searchOption.client=$scope.ClientNameList[0];
                }).error(function(data, status, headers) {
                    $scope.loading = false;
                    console.log(data);
                    
                });
        }
        $scope.changeNextTabSettings();
        $scope.gridOptionsFLRSearch={
                    multiSelect: true,
                    selectionRowHeaderWidth: 35,
                    rowHeight: 35,
                    enableFullRowSelection : true,
                    gridMenuShowHideColumns:false,
                    enableColumnMenus:false
        };
        /*Post Data for FlR*/
        $scope.postDataforBackupCopyFLR=function(){
             var load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery...");
             var archive_id=$scope.gridSelectedArray[0].id;
             var backupCopyRestoreObj = {};
             backupCopyRestoreObj.archive_ids=archive_id;
             backupCopyRestoreObj.association = "dr";
             var includes_list = '';
             for (var i =0 ; i <  $scope.gridSelectedArray.length;i++){
                if(i==0){
                    includes_list =$scope.gridSelectedArray[i].filename;
                }else{
                    includes_list =includes_list + ","+$scope.gridSelectedArray[i].filename;
                }
             }
             console.log();
             backupCopyRestoreObj.inclusions = [includes_list];
             backupCopyRestoreObj.exclusions = [];
             backupCopyRestoreObj.restore_backup = true;
             backupCopyRestoreObj = JSON.stringify(backupCopyRestoreObj);
             url = "/api/restore/archive/files/?sid="+$scope.searchOption.client.sid;
             $http ({
            method: 'post',
            url : url,
            data: backupCopyRestoreObj
            }).success(function(data){
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                                    template: 'app/recover/filerecovery/searchFLR/viewJobs.html',
                                    scope: $scope,
                                    overlay:true,
                                    modelDialogId:'window-flr-view-jobs-dialog',
                                    ngDialogStyle:'width:82em; height:20em; left: 80px;'
                });
               
                //ngDialog.close('flr-search-dialog');

            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        }
        $scope.nextWizard = function($event){
             
            if(wizardTitle == "Search Files"){
                if( $scope.gridSelectedItems <= 0){
                    $scope.showCheckError=true;
                    return;
                }else{
                    if($scope.searchOption.type == 1){
                      $scope.postDataforBackupCopyFLR();
                    }else{
                    $scope.getRestoreFLRBackupTarget();    
                    $rootScope.$broadcast("nextBtnClick");
                    console.log($scope.searchOption);
                    console.log('BackUp Coming Soon');
                    }
                }
            }
            if(wizardTitle == "Recover Options"){
                var excludes_list = [];
                console.log($scope.exclusionData);
                for (var i =0 ; i <  $scope.exclusionData.length;i++){
                    excludes_list.push($scope.exclusionData[i].name);
                }
                var includes_list = [];
                for (var i =0 ; i <  $scope.gridSelectedArray.length;i++){
                    includes_list.push($scope.gridSelectedArray[i].id);
                }
                $scope.recoverOption.includes=includes_list;
                $scope.recoverOption.excludes=excludes_list;
                $scope.recoverOption.isPhysicalServer=true;
                $scope.recoverOption.client_id=$scope.recoverOption.targetClient.client_id;
                console.log($scope.recoverOption);
                var url="/api/restore/full/?sid="+$scope.searchOption.client.sid;
                var load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery...");
               $http ({
                    method: 'post',
                    url : url,
                    data:  JSON.stringify($scope.recoverOption)

                }).success(function(data){
                    PHD.hideLoadingIndicator(load);
                    data = {};
                    data.result = [{'message': 'File level recovery job successfully started.'}];
                    var options = {};
                    if (window.location.href.indexOf("#/protect") !== -1 || window.location.href.indexOf("#/jobs") !== -1) {
                        options.buttons = [
                            {
                                text: gettext("View FLR"),
                                click: function () {
                                    window.location.href = "#/recover/#1";
                                    $(this).dialog("destroy").remove();
                                }
                            }
                        ];
                    }
                    PHD.throwNotice(data, options);
                    ngDialog.close('flr-search-dialog');
                }).error(function(response) {
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType:'retry',
                        dialogMessage:response.result[0].message
                    })
                });
            }
         
        }
        $scope.getRestoreFLRBackupTarget = function(){
            console.log($scope.gridOptionsFLRSearch.data[0].backup_id);
            var backup_id=$scope.gridSelectedArray[0].backup_id;
            $scope.recoverOption.backup_id=$scope.gridSelectedArray[0].backup_id;
            var url="/api/restore/targets/?backup_id="+backup_id;
             $http({
                method: 'get',
                url   : url
            }).success(function(data, status, headers) {
                 $scope.targetNameList = data.targets;
                 $scope.recoverOption.targetClient =$scope.targetNameList[0];
                 
            }).error(function(data, status, headers) {
                
                
            });
            
        }
        $scope.viewJobs = function(){
            ngDialog.close('window-flr-view-jobs-dialog');
            ngDialog.close('flr-search-dialog');
            window.location.href = "#/jobs/#0";
            
            
        }
        $scope.closeDialog = function(){
            ngDialog.close('window-flr-view-jobs-dialog');
            ngDialog.close('flr-search-dialog');
            
        }
        $scope.clearSearchModel = function(){
           $scope.advance.open=false;
           $scope.showgrid = false;
           $scope.noResults =false; 
           $scope.searchOption={};
           $scope.searchOption.case=true;
           $scope.gridOptionsFLRSearch.data=[];
           $scope.gridOptionsFLRSearch.columnDefs=[];
        };
        $scope.handleRowSelection = function(row) {
            var rowId=($scope.searchOption.type == 0)?row.entity.backup_id:row.entity.id;
            var titleString=($scope.searchOption.type == 0)?'Select one type of BackupId ':'Select one type of BackupCopyId ';
            if($scope.selectedId==0 || $scope.ckeckedIdList.length ==0){
                $scope.selectedId =rowId;
                $scope.checkId=false;
                $scope.ckeckedIdList.push(rowId);
                document.getElementById("save-Next-Button").title='';
            }
            if (row.isSelected){
                if ($scope.ckeckedIdList.indexOf(rowId) > -1){
                    $scope.showCheckError=false;
                }else{
                    $scope.checkId=true;
                    document.getElementById("save-Next-Button").title=titleString;
                    $scope.ckeckedIdList.push(rowId);
                }
            }else{
                if ($scope.ckeckedIdList.length > 1){
                    var index = $scope.ckeckedIdList.indexOf(rowId);
                    $scope.ckeckedIdList.splice(index, 1);
                }
                if ( $scope.ckeckedIdList.length ==1 ){
                    $scope.checkId=false;
                    document.getElementById("save-Next-Button").title='';
                }else{
                    $scope.checkId=true;
                    document.getElementById("save-Next-Button").title=titleString;
                }

            }
            $scope.gridSelectedItems =$scope.gridApi.selection.getSelectedRows().length;
            $scope.gridSelectedArray=$scope.gridApi.selection.getSelectedRows();
            if($scope.gridSelectedItems==0){
                $scope.checkId=true;
                $scope.ckeckedIdList=[];
            }
        };
        $scope.gridOptionsFLRSearch.onRegisterApi = function(gridApi){
            //set gridApi on scope
            $scope.gridApi = gridApi;
            gridApi.selection.on.rowSelectionChanged($scope, $scope.handleRowSelection);
            gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                rows.forEach($scope.handleRowSelection);
            });
        };
        
        $scope.loadBackupSearchData = function(pid , timestr,loadgridIndicator){
            var pid =pid;
            var timestr =timestr;
             var loadgridIndicator=loadgridIndicator;
             var url ='/api/backups/search/'+pid+'/?sid='+$scope.searchOption.client.sid+'&timestr='+timestr;
            $http({
                method: 'get',
                url   : url
            }).success(function(data, status, headers) {
                if(data.results instanceof Array){
                PHD.hideLoadingIndicator(loadgridIndicator);
                    $scope.setGridDataForBackup(data.results);
                }else{
                    if(data.results =='running'){
                            $timeout(function() {
                                 $scope.loadBackupSearchData(pid,timestr,loadgridIndicator);                
                         }, 3000);
                        }else{
                            $scope.showgrid = false;
                            $scope.noResults=true;
                            PHD.hideLoadingIndicator(loadgridIndicator);    
                        }
                }
            }).error(function(data, status, headers) {
                //$scope.noResults=true;
                //$scope.showgrid = false;
                PHD.hideLoadingIndicator(loadgridIndicator);
                var message = data.result[0].message;
                ngDialog.open({
                    dialogType:'retry',
                    scope: $scope,
                    modelDialogId:'backup-search-dialog',
                    dialogMessage: message
                });
            });
        };
        $scope.advanceOpen = function(){
            $scope.advance.open = !$scope.advance.open;
            if($scope.advance.open){
                $("#expandId-advaceSearch").removeClass("reportExpand");
                $("#expandId-advaceSearch").addClass("reportExpanded");
            }else{
                $("#expandId-advaceSearch").removeClass("reportExpanded");
                $("#expandId-advaceSearch").addClass("reportExpand");
            }
        }
        $scope.searchFLR = function(){
            $scope.noResults=false;
            if($('#start_size_spinner_field').val() >= 9999 || $('#end_size_spinner_field').val() >= 9999){
                $scope.sizeLimit=true; 
                return;   
            }
            $scope.searchOption.name=($scope.searchOption.expression)?$scope.search.regexName:$scope.search.name;
            if((typeof($scope.searchOption.name) == 'undefined' || $scope.searchOption.name == "") && ((typeof($scope.search.end_date) == 'undefined' ||isNaN(moment($scope.search.end_date).unix()))&& (typeof($scope.searchOption.end_size) == 'undefined' ||$scope.searchOption.end_size ==null )&& (typeof($scope.search.start_date) == 'undefined' || isNaN(moment($scope.search.start_date).unix())) && (typeof($scope.searchOption.start_size) == 'undefined' || $scope.searchOption.start_size == null)))  {
              $scope.emptyString = true;
              return;
            }
            
            $scope.sizeLimit=false;
            $scope.emptyString = false;
            var url;
            
            var gridId=$('#backup-copy-flr-grid');
            var loadgridIndicator= PHD.showLoadingIndicator(gridId);
            console.log();
           if($scope.searchOption.type == 0){
               url="/api/backups/search/?sid="+$scope.searchOption.client.sid+"&cid="+$scope.searchOption.client.id;
            }else{
                 url="/api/archive/search/?sid="+$scope.searchOption.client.sid;
            }
            if(typeof($scope.search.start_date) != 'undefined'){
                if($scope.searchOption.type == 0){
                    $scope.searchOption.start_date=moment($scope.search.start_date).unix();
                }else{
                    $scope.searchOption.start_date=$scope.search.start_date;
                }
            }
            if(typeof($scope.search.end_date) != 'undefined'){
                if($scope.searchOption.type == 0){
                    $scope.searchOption.end_date=moment($scope.search.end_date).unix();
                }else{
                    $scope.searchOption.end_date=$scope.search.end_date;
                }
            }
            $scope.searchOption.client_name=$scope.searchOption.client.name;
            $scope.searchOption.id=$scope.searchOption.client.id;
            $scope.gridOptionsFLRSearch.data=[];
            $scope.gridOptionsFLRSearch.columnDefs=[];
            $scope.gridSelectedItems=0;
            $http({
                method: 'POST',
                url   : url,
                data  : JSON.stringify($scope.searchOption)
            }).success(function(data, status, headers) {
               
               
                if ($scope.searchOption.type == 0){
                     $scope.loadBackupSearchData(data.pid,data.timestr,loadgridIndicator);
                 }else{
                     PHD.hideLoadingIndicator(loadgridIndicator);
                     $scope.setGridDataForBackupCopy(data.files);
                     
                     
                 }
            }).error(function(data, status, headers) {
                 $scope.showgrid = false;
                 $scope.noResults=true;
                 PHD.hideLoadingIndicator(loadgridIndicator);
                 console.log(data);
            });
        }
        $scope.setGridDataForBackupCopy = function(data){
            var id=data[0].id;
            $scope.selectedId=0;
            $scope.ckeckedIdList=[];
            var dataArray=[];
            for (var i=0;i<data.length;i++){
                dataArray.push(data[i]);

            }
            if(dataArray.length >0){
                $scope.showgrid = true;
                $scope.noResults=false;
                $scope.gridOptionsFLRSearch.columnDefs= $scope.columnDefinitions[$scope.searchOption.type];
                $scope.gridOptionsFLRSearch.data=dataArray;
                /*$scope.gridSelectedItems =dataArray.length;*/            
            }else{
                $scope.gridSelectedItems=0;
                $scope.showgrid = false;
                $scope.noResults=true;
            }
        }
        $scope.setGridDataForBackup = function(data){
            var id=data[0].backup_id;
            $scope.selectedId=0;
            $scope.ckeckedIdList=[];
            var dataArray=[];
            for (var i=0;i<data.length;i++){
                dataArray.push(data[i]);

            }
            if(dataArray.length >0){
                $scope.showgrid = true;
                $scope.noResults=false;
                $scope.gridOptionsFLRSearch.columnDefs= $scope.columnDefinitions[$scope.searchOption.type];
                $scope.gridOptionsFLRSearch.data=dataArray;
                /*$scope.gridSelectedItems =dataArray.length;*/
            }else{
                $scope.gridSelectedItems=0;
                $scope.showgrid = false;
                $scope.noResults=true;
            }
        }
        
}]);
