var recoverModule = angular.module('recoveryModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.selection','singleFileBrowserDialogApp']);

recoverModule.config(['ngDialogProvider', function (ngDialogProvider) {
    ngDialogProvider.setDefaults({
        plain: false,
        closeByDocument: true,
        closeByEscape: true,
        appendTo: false,
        preCloseCallback: function (value) {

        }
    });
}]);

recoverModule.directive('timeSlider', function() {
    var updateCurrentTime, updateEndTime, updateStartTime;
    updateStartTime = function(span, value) {
        var sd, startDate, startTime;
        sd = new Date(value);
        startDate = sd.toLocaleDateString({month:"2-digit",day:"2-digit",year:"2-digit"});
        startTime = sd.toLocaleTimeString(navigator.language, {hour: '2-digit', minute:'2-digit'});
        return span.innerHTML = startDate + ',' + startTime;
    };
    updateEndTime = function(span, value) {
        var ed, endDate, endTime;
        ed = new Date(value);
        endDate = ed.toLocaleDateString({month:"2-digit",day:"2-digit",year:"2-digit"});
        endTime = ed.toLocaleTimeString(navigator.language, {hour: '2-digit', minute:'2-digit'});
        return span.innerHTML = endDate + ',' + endTime;
    };
    updateCurrentTime = function(span, value) {
        var cd, curDate, curTime;
        cd = new Date(value);
        curDate = cd.toLocaleDateString({month:"2-digit",day:"2-digit",year:"2-digit"});
        curTime = cd.toLocaleTimeString(navigator.language, {hour: '2-digit', minute:'2-digit'});
        return span.innerHTML = curDate + ',' + curTime;
    };
    return {
        template: "<div style='margin-left: 130px;font: 1.2em/30px \"Oxygen\", Arial, \"Helvetica Neue\", Helvetica, \"Lucida Sans Unicode\", \"Lucida Sans\", sans-serif;'><span>Earliest</span>" + "<input id='rangeID' type='range'><span>Latest</span><br/><span class='startTime'></span><span style='margin-left: 60px;' class='endTime'></span>" + "<div style='display:none' class='curTime'><span></span></div>" + "</div>",
        restrict: 'E',
        scope: {
            min: '=',
            max: '=',
            callback: '='
        },
        link: function(scope, element, attrs) {
            var adjusting, curTimeDiv, moveCurTimeDiv, rangeInput, rangeInputElement, rangeInputOffset, spans;
            rangeInput = element.find('input')[0];
            rangeInputElement = angular.element(rangeInput);
            spans = element.find('span');
            curTimeDiv = element.find('div')[1];
            rangeInputOffset = $(rangeInput).offset();
            adjusting = false;
            rangeInput.min = scope.min;
            rangeInput.max = scope.max;
            rangeInput.step = attrs.step;
            rangeInput.value = scope.min;
            updateStartTime(spans[2], rangeInput.min);
            updateEndTime(spans[3], rangeInput.max);
            moveCurTimeDiv = function(curValue) {
                var ctdElement, curPercentage, curValueLocation;
                curPercentage = (curValue - scope.min) / (scope.max - scope.min);
                curValueLocation = (rangeInput.clientWidth * curPercentage) + rangeInputOffset.left;
                ctdElement = angular.element(curTimeDiv);
                ctdElement.css('left', curValueLocation - curTimeDiv.clientWidth + 'px');
                return ctdElement.css('top', rangeInput.clientHeight - curTimeDiv.clientHeight + 'px');
            };
            rangeInputElement.bind('change', function(event) {
                var curValue;
                adjusting = true;
                curValue = parseInt(event.target.value);
                var dateString = new Date(curValue);
                var dateLocalStringvalue=dateString.toLocaleString(navigator.language, {month:"2-digit",day:"2-digit",year:"2-digit",hour: '2-digit', minute:'2-digit'});
                document.getElementById('rangeID').title =dateLocalStringvalue;
                updateCurrentTime(spans[4], curValue);
                return moveCurTimeDiv(curValue);
            });
            rangeInputElement.bind('mouseup', function(event) {
                adjusting = false;
                return scope.callback.call(this, parseInt(event.target.value));
            });
            scope.$watch('min', function(newValue, oldValue) {
                updateStartTime(spans[2], parseInt(newValue));
                rangeInput.min = scope.min;
                rangeInput.value = scope.min;
                return spans[4].innerHTML = '';
            });
            return scope.$watch('max', function(newValue, oldValue) {
                updateEndTime(spans[3], parseInt(newValue));
                return rangeInput.max = scope.max;
            });
        }
    };
});


recoverModule.factory('recoverFactory', function($http,ngDialog) {
    return {
        getRestoreTargets: function(method, url, sid, backup_id, instance_id, client_id, ndmp_target_client_id) {
            var params = {};
            if (sid != 0) {
                params.sid = (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : sid;
                params.replicated = (selectedBackup.replicated == 'true') ? 1 : 0;
                console.log("sab:  sid in getRestoreTargets: " + sid);
                if((app_type != undefined) && (app_type === APPLICATION_TYPE_NAME_HYPER_V)){
                    if(isIRJob) {
                        params.instance_id = instance_id;
                        params.type = 'ir';
                    } else {
                        params.backup_id = backup_id;
                        params.type = 'restore';
                    }
                } else {
                    params.backup_id = backup_id;
                    if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                        params.client_id = client_id;
                    } else if((app_type != undefined) && (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) && ndmp_target_client_id != undefined)  {
                        params.ndmp_target_client_id = ndmp_target_client_id;
                    }
                }
            }
            var promise = $http({
                url: url,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });
            });
            return promise;
        }
    };
});

recoverModule.factory('applianceNetworkFactory', function($http,ngDialog) {
    return {
        getNetworkDetails: function(method, url, sid) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;

            }
            var promise = $http({
                url: url,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});

recoverModule.factory('hypervisorSwitchFactory', function($http, ngDialog) {
    return {
        getHypervisorSwitch: function(method, url, hypervisor, sid) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;
            }
            params.hypervisor_type = APPLICATION_TYPE_NAME_HYPER_V;
            params.hypervisor = hypervisor;
            var promise = $http({
                url: url,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});

recoverModule.factory('alternateExchangeServersFactory', function($http, ngDialog) {
    return {
        getAlternateExchangeServers: function(method, url, app_id, sid) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;
            }
            params.app_id = app_id;

            var promise = $http({
                url: url,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});

recoverModule.factory('alternateLocationsFactory', function($http, ngDialog) {
    return {
        getAlternateLocations: function(method, url, sid) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;
            }
            params.os_family = "Windows";
            params.showSystemClient = '1';

            var promise = $http({
                url: url,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});

recoverModule.controller('recoveryCtrl', ['$scope', '$rootScope', '$http', '$timeout', 'ngDialog', 'wizardService', '$analytics', 'recoverFactory', 'applianceNetworkFactory', 'hypervisorSwitchFactory', 'alternateExchangeServersFactory', 'alternateLocationsFactory',
    function($scope, $rootScope, $http, $timeout, ngDialog, wizardService, $analytics, recoverFactory, applianceNetworkFactory, hypervisorSwitchFactory, alternateExchangeServersFactory, alternateLocationsFactory) {


        $scope.layoutSliderChanged = function (value) {
            $scope.slecetdPit = value;
            var dateString=new Date($scope.slecetdPit);
            $scope.showslecetdPit = dateString.toLocaleString(navigator.language, {month:"2-digit",day:"2-digit",year:"2-digit",hour: '2-digit', minute:'2-digit'});
            $(window).resize();
        };

        $scope.isPitSupported = false;

        $scope.jobName = "On-Demand";
        $scope.replicated = false;
        $scope.hideSwitch = true;
        $scope.hideRP = app_type !== APPLICATION_TYPE_NAME_VMWARE;
        $scope.hideStorage = false;
        $scope.isCluster = false;

        $scope.target = {};
        $scope.target.locationObj = "";
        $scope.recovery_asset = "";
        $scope.target.resourcePoolObj = "";
        $scope.target.dataStoreObj = "";
        $scope.target.appliance_network = "";
        $scope.target.network_switch = "";
        $scope.target.audit = false;

        $scope.locations = [];
        $scope.resourcePools = [];
        $scope.dataStores = [];
        $scope.applianceNetworks = [];
        $scope.networkSwitches = [];
        // array of datastores names
        $scope.dataStoresWithoutSize = [];
        $scope.dataStoreName = "";

        $scope.hostRequired = false;
        $scope.resourcePoolRequired = false;
        $scope.storageRequired = false;
        $scope.networkRequired = false;
        $scope.switchRequired = false;

        $scope.targetsData = [];
        $scope.locationName = "";
        $scope.hypervisorId = "";
        $scope.resourcePoolName = "";
        $scope.networkName = "";
        $scope.networkIP = "";

        $scope.restoreObj = {};
        $scope.targetStorageSelectPlaceHolder = false;
        $scope.hyperVTypeApplicationFlag = false;
        // set the entire name, not the suffix
        //$scope.suffix = {};
        //$scope.suffix.name = "_restore";
        $scope.recovery = {};

        var defaultHyperVLocation = 0;

        //Xen variables
        $scope.notXen = true;
        $scope.storageRepos = [];
        $scope.storageName = "";
        $scope.target.storageObj = "";
        $scope.storageReposWithoutSize = [];

        // Physical server variables
        $scope.physicalTarget = {};
        $scope.physicalTarget.asset = "";
        $scope.physicalTarget.preserve_dir = true;
        $scope.physicalServerRecoveryOption = {};
        $scope.physicalServerRecoveryOption.target = {
            flat: false,
            non_destructive: true,
            newer: false,
            today: false,
            unix: true,
            directory: ""
        };
        var defalutAssetVal = 1;

        // Oracle and SharePoint variables
        $scope.recoveryDataFirst = "";
        $scope.recoveryDataSecond = "";
        $scope.oracleSharePointObj = {};

        $scope.summaryHeaderArray = [];
        $scope.showSummaryHeader = true;

        // Exchange server variables
        $scope.exchangeTarget = {};
        $scope.exchangeTarget.asset = "";
        $scope.exchangeTarget.recoveryTarget = "";
        $scope.exchangeTarget.recoveryArea = "";
        $scope.exchangeTarget.altAsset = "";
        $scope.exchangeTargetDataArray = [];
        $scope.assetTargets = [];
        $scope.altAssetTargets = [];
        $scope.exchangeRecoveryOption = {};
        $scope.exchangeRecoveryOption.target = {};
        $scope.exchangeOption = {};
        $scope.exchangeOption.target = {
            flat: true,
            non_destructive: true,
            newer: false,
            today: false,
            unix: true,
            directory: ""
        };
        $scope.recoveryAreas = [];
        $scope.recoveryDatabase = [];
        $scope.exchangeAssetName = "";
        $scope.isOriginalDB = false;
        $scope.exchangeRecoveryDatabasePlaceHolder = "";
        $scope.exchangeRecoveryDatabaseName = "";
        $scope.exchange2003 = selectedBackup.app_id == 2;

        // SQL variables
        $scope.SQLRecoveryObj = {};
        $scope.SQLRecoveryObj.target = {};
        $scope.SQLRecoveryObj.target.instance = "";
        $scope.SQLRecoveryObj.target.database = "";
        $scope.SQLTarget = {};
        $scope.SQLTarget.asset = "";
        $scope.SQLTarget.directory = "";
        $scope.SQLTarget.recoveryTarget = "";
        $scope.SQLTargetDataArray = [];
        $scope.SQLselectedaltlocationFlag = false;
        $scope.selectedAssetNameChangeFlag = true;
        $scope.SQLTarget.recoveryOption = '1';
        $scope.SQLTarget.instanceObj = "";
        $scope.databaseRequired = false;
        $scope.instanceRequired = false;
        $scope.targetRequired = false;
        $scope.sqlMasterDBFlag = false;
        $scope.setTargetPath = true;

        // NDMP variables
        $scope.ndmpRecoveryObj = {};
        $scope.ndmpRecoveryObj.target = {};
        $scope.ndmpRecoveryObj.target.volume = "";
        $scope.ndmpRecoveryObj.target.directory = "";
        $scope.ndmpRestoreTarget = {};
        $scope.ndmpRestoreTarget.asset = "";
        $scope.ndmpRestoreTarget.assetName = "";
        $scope.ndmpRestoreTarget.directory = "";
        $scope.ndmpTargets = [];
        $scope.ndmpTargetVolumes = [];
        $scope.ndmpRestoreTargetVolume = {};
        $scope.ndmpRestoreTargetVolume.instance_id = "";
        $scope.ndmpRestoreTargetVolume.assetName = "";

        console.log(app_type + ":::" + selectedBackup.vm_name);

        if (app_type === APPLICATION_TYPE_NAME_SHAREPOINT || app_type === APPLICATION_TYPE_NAME_ORACLE) {
            $scope.summaryHeaderArray = [{
                "labelName": "Backup Details",
                "labelDescription": selectedBackup.backup_type + " " + selectedBackup.backup_date
            },
                {"labelName": "Size", "labelDescription": selectedBackup.backup_size + " MB"}
            ];
        } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
            $scope.summaryHeaderArray = [
                {
                    "labelName": "Backup",
                    "labelDescription": selectedBackup.backup_type + " " + selectedBackup.backup_date
                },
                {"labelName": "Database", "labelDescription": selectedBackup.vm_name},
                {"labelName": "Instance", "labelDescription": selectedBackup.server_instance_name},
                {"labelName": "Size", "labelDescription": selectedBackup.backup_size + " MB"}
            ];
        } else {
            $scope.summaryHeaderArray = [{"labelName": "Asset Name", "labelDescription": selectedBackup.vm_name},
                {
                    "labelName": "Backup Details",
                    "labelDescription": selectedBackup.backup_type + " " + selectedBackup.backup_date
                },
                {"labelName": "Size", "labelDescription": selectedBackup.backup_size + " MB"}
            ];
        }

        if (app_type == APPLICATION_TYPE_NAME_HYPER_V) {
            $scope.targetStorageSelectPlaceHolder = "Please select volume";
            $scope.notXen = true;
            if (isIRJob) {
                $scope.hyperVTypeApplicationFlag = false;
            } else {
                $scope.hyperVTypeApplicationFlag = true;
            }
        } else if (app_type == APPLICATION_TYPE_NAME_XEN) {
            $scope.notXen = false;
            $scope.hideStorage = true;
            $scope.hyperVTypeApplicationFlag = false;
        } else {
            $scope.targetStorageSelectPlaceHolder = "Please select datastore";
            $scope.hyperVTypeApplicationFlag = false;
            $scope.notXen = true;
        }

        if (app_type === APPLICATION_TYPE_NAME_SHAREPOINT) {
            $scope.recoveryDataFirst = "SharePoint farm will be recovered to its original location.";
            $scope.recoveryDataSecond = "To recover individual SharePoint items, use File Recovery options to create a file recovery object.";

        }
        if (app_type === APPLICATION_TYPE_NAME_ORACLE) {
            $scope.recoveryDataFirst = "The Oracle database will be recovered to its original location.";
            $scope.recoveryDataSecond = "To recover individual Oracle items, use File Recovery options to create a file recovery object.";
        }

        if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
            //$scope.targetServerSelectPlaceHolder = "Please select a server";
            $scope.targetInstanceSelectPlaceHolder = "Please select an instance";

            $scope.recoveryTargetChange = function(asset){
                //get the sql instances
                $scope.instances = [];
                if (typeof($scope.locations) != "undefined") {

                    for (var i = 0; i < $scope.locations.length; i++) {
                        if ($scope.locations[i].value != "undefined") {
                            if($scope.locations[i].value == asset){
                                $scope.SQLTarget.assetName = $scope.locations[i].name;
                                $scope.SQLTarget.targetId = $scope.locations[i].value;
                                console.log($scope.SQLTarget.targetId);

                                for (var j = 0; j < $scope.locations[i].instances.length; j++) {
                                    $scope.instances.push({'name': $scope.locations[i].instances[j].instance_name});
                                }
                            }
                        }
                    }
                }
                $scope.SQLselectedaltlocationFlag = parseInt(selectedBackup.client_id,10) !== asset;
            }
        }

        if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
            var altExchangeServer = {};
            altExchangeServer.value = 1;
            altExchangeServer.name = "Exchange Server";
            $scope.exchangeTargetDataArray.push(altExchangeServer);

            var altLocation = {};
            altLocation.value = 2;
            altLocation.name = "Alternate Location";
            $scope.exchangeTargetDataArray.push(altLocation);

            getExchangeServers();
        }

        function getExchangeServers() {
            var url = "/api/clients/filtered/",
                app_id = parseInt(selectedBackup.app_id, 10);
            alternateExchangeServersFactory.getAlternateExchangeServers('get', url, app_id, ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid))
                .then(function (data) {
                    var applicable_servers = data.data.data;
                    if (applicable_servers && applicable_servers.length > 0) {
                        angular.forEach(applicable_servers, function (value, key) {
                            var assetTempObj = {};
                            // in case of Exchange 2003, only restore to original server and original location
                            if ($scope.exchange2003) {
                                if (value.client_name == selectedBackup.client_name) {
                                    assetTempObj.value = value.client_id;
                                    assetTempObj.name = value.client_name;
                                    $scope.assetTargets.push(assetTempObj);
                                }
                            } else {
                                assetTempObj.value = value.client_id;
                                assetTempObj.name = value.client_name;
                                $scope.assetTargets.push(assetTempObj);
                            }
                        });
                    }
                    $scope.exchangeAssetName = selectedBackup.client_name;
                    $scope.exchangeTarget.asset = parseInt(selectedBackup.client_id, 10);
                });
        }

        /********* Exchange Recovery Target change *********/
        $scope.exchangeRecoveryTargetChange = function () {
            $scope.recoveryAreas = [];
            $scope.recoveryDatabase = [];
            $scope.assetTargets = [];
            $scope.altAssetTargets = [];
            $scope.exchangeTarget.asset = "";
            $scope.exchangeTarget.altAsset = "";
            $scope.exchangeTarget.recoveryArea = "";
            $scope.exchangeAssetName = "";

            if ($scope.exchangeTarget.recoveryTarget === 1) {
                getExchangeServers();
                $scope.getRecoveryDatabases(selectedBackup.client_id);
            } else {
                var url = "/api/clients/filtered/",
                    load = PHD.showLoadingIndicator("body", true, "Loading...");
                alternateLocationsFactory.getAlternateLocations('get', url, ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid))
                    .then(function (data) {
                        var applicable_servers = data.data.data;
                        if (applicable_servers && applicable_servers.length > 0) {
                            angular.forEach(applicable_servers, function (value, key) {
                                var assetTempObj = {};
                                assetTempObj.value = value.client_id;
                                assetTempObj.name = value.client_name;
                                $scope.altAssetTargets.push(assetTempObj);
                            });
                        }
                        PHD.hideLoadingIndicator(load);
                    });
            }
        };

        $scope.exchangeAssetChange = function () {
            if ($scope.exchangeTarget.asset !== null) {
                $scope.exchangeTarget.recoveryArea = "";
                $scope.getRecoveryDatabases($scope.exchangeTarget.asset);
                $scope.exchangeAssetName = $.grep($scope.assetTargets, function (asset) {
                    return asset.value == $scope.exchangeTarget.asset;
                })[0].name;
            } else {
                $scope.exchangeAssetName = "";
            }
        };

        $scope.exchangeAltAssetChange = function() {
            if ($scope.exchangeTarget.altAsset !== null) {
                $scope.exchangeAssetName = $.grep($scope.altAssetTargets, function (asset) {
                    return asset.value == $scope.exchangeTarget.altAsset;
                })[0].name;
            }
        };
        $scope.$on("singleFilesBrowseSelected", function(event, filePath) {
            $scope.SQLTarget.directory = filePath;
        });


        $scope.exchangeRecoveryAreaChange = function () {
            $scope.exchangeRecoveryDatabasePlaceHolder = "Please select recovery database";
            $scope.recoveryAreas = $scope.recoveryDatabase;
        };

        $scope.exchangeOriginalLocationChange = function () {
            if($scope.isOriginalDB){
                $scope.exchangeAssetName = selectedBackup.client_name;
            }else{
                $scope.exchangeTarget.recoveryOption = 0;

            }
        };

        $scope.getRecoveryDatabases = function (client_id) {
            $scope.recoveryDatabase = [];
            $scope.recoveryAreas = [];
            $scope.isOriginalDB = false;
            $scope.exchangeTarget.recoveryOption = 2;
            var url = "/api/restore/targets/",
                load = PHD.showLoadingIndicator("body", true, "Loading...");
            recoverFactory.getRestoreTargets('get', url, ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid), selectedBackup.backup_id, selectedBackup.instance_id, client_id)
                .then(function (data) {
                    PHD.hideLoadingIndicator(load);
                    var restore_targets = data.data.targets;
                    if (restore_targets && restore_targets.length > 0) {
                        angular.forEach(restore_targets, function (value, key) {
                            if (selectedBackup.vm_name === value.name) {
                                $scope.isOriginalDB = true;
                                $scope.exchangeTarget.recoveryOption = 1;
                            } else {
                                $scope.recoveryDatabase.push(value.name);
                            }
                        });
                    }
                    if ($scope.exchangeTarget.recoveryOption == 2 && $scope.recoveryDatabase.length > 0) {
                        $scope.recoveryAreas = $scope.recoveryDatabase;
                    }
                });
        };

        if (app_type === APPLICATION_TYPE_NAME_HYPER_V && $scope.hyperVTypeApplicationFlag) {
            var originalLocation = {};
            originalLocation.value = 0;
            originalLocation.name = 'Original Location';
            $scope.locations.push(originalLocation);
            defaultHyperVLocation = 0;
        }

        //API call for step first "Recovery Options".
        var url = "/api/restore/targets/",
            load = PHD.showLoadingIndicator("body", true, "Loading Target Location...");
        recoverFactory.getRestoreTargets('get', url, ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid), selectedBackup.backup_id, selectedBackup.instance_id, selectedBackup.client_id)
            .then(function (data) {
                PHD.hideLoadingIndicator(load);
                var restore_targets = data.data.targets;
                if (restore_targets && restore_targets.length > 0) {
                    if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
                        angular.forEach(restore_targets, function (value, key) {
                            var locationTempObj = {};
                            locationTempObj.value = value.client_id;
                            locationTempObj.name = value.client_name;
                            if (value.client_name == selectedBackup.vm_name) {
                                defalutAssetVal = value.client_id;
                            }
                            $scope.locations.push(locationTempObj);
                        });
                    } else {
                        $scope.isOriginalDB = false;
                        $scope.exchangeTarget.recoveryOption = 2;
                        angular.forEach(restore_targets, function (value, key) {
                            var locationTempObj = {};
                            if (app_type === APPLICATION_TYPE_NAME_SHAREPOINT || app_type === APPLICATION_TYPE_NAME_ORACLE) {
                                if (app_type === APPLICATION_TYPE_NAME_SHAREPOINT && value.num_servers > 1) {
                                    $scope.recoveryDataFirst = "This is a multi-server Farm. Full restores are only supported if SharePoint is on single server.";
                                    $scope.recoveryDataSecond = "To restore a multi-server Farm, use File Level Recovery.";
                                    $scope.isMultiServer = true;
                                } else {
                                    $scope.oracleSharePointObj.client_id = value.client_id;
                                    $scope.isMultiServer = false;
                                }
                            } else if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                                if (selectedBackup.vm_name === value.name) {
                                    $scope.isOriginalDB = true;
                                    $scope.exchangeTarget.recoveryOption = 1;
                                } else {
                                    $scope.recoveryDatabase.push(value.name);
                                }
                                if (!$scope.isOriginalDB) {
                                    $scope.exchangeRecoveryDatabasePlaceHolder = "Please select recovery database";
                                    $scope.recoveryAreas = $scope.recoveryDatabase;
                                }
                            } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
                                locationTempObj.value = value.client_id;
                                locationTempObj.name = value.client_name;
                                locationTempObj.database = value.database;
                                locationTempObj.instances = value.instances;

                                $scope.locations.push(locationTempObj);
                                $scope.SQLTarget.database = selectedBackup.datbase_name;
                                $scope.SQLTarget.isSystemDB = value.system_db;
                                $scope.setTargetPath = value.target_path !== undefined ? value.target_path : true;
                            } else if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
                                locationTempObj.value = value.client_id;
                                locationTempObj.name = value.client_name;
                                $scope.ndmpTargets.push(locationTempObj);
                            } else {
                                locationTempObj.value = value.id;
                                locationTempObj.name = value.name;
                                $scope.locations.push(locationTempObj);
                            }
                        });
                    }
                } else if (angular.isObject(restore_targets)){
                    var locationTempObj = {};
                    $scope.isSystemDB = false;

                    if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
                        locationTempObj.value = restore_targets.client_id;
                        locationTempObj.name = restore_targets.client_name;
                        locationTempObj.database = restore_targets.database;
                        locationTempObj.instances = restore_targets.instances;

                        $scope.locations.push(locationTempObj);
                        $scope.SQLTarget.database = selectedBackup.datbase_name;
                        $scope.SQLTarget.isSystemDB = restore_targets.system_db;
                        if(restore_targets.pit_start_time !== undefined){
                            $scope.layoutEarliestMS = restore_targets.pit_start_time *1000;
                            $scope.layoutLatestMS = restore_targets.pit_end_time *1000;
                            $scope.pitSliderRange = ((Math.floor(($scope.layoutLatestMS % 3600000) / 60000)) - (Math.floor(($scope.layoutEarliestMS % 3600000) / 60000)));
                            $scope.slecetdPit = $scope.layoutEarliestMS;
                            var dateString=new Date($scope.slecetdPit);
                            $scope.showslecetdPit =dateString.toLocaleString(navigator.language, {month:"2-digit",day:"2-digit",year:"2-digit",hour: '2-digit', minute:'2-digit'});
                            $scope.isPitSupported = true;
                        }

                    }
                }
                $scope.targetsData = restore_targets;
                if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
                    $scope.physicalTarget.asset = defalutAssetVal;
                    $scope.targetNameForPhysicalServer = $.grep($scope.locations, function (location) {
                        return location.value == $scope.physicalTarget.asset;
                    })[0].name;
                }
                if (app_type === APPLICATION_TYPE_NAME_HYPER_V || app_type === APPLICATION_TYPE_NAME_VMWARE || app_type === APPLICATION_TYPE_NAME_XEN) {
                    $scope.target.locationObj = $scope.locations[0].value;
                    $scope.locationName = $scope.locations[0].name;
                    if(app_type === APPLICATION_TYPE_NAME_XEN) {
                        $scope.XenClientId = restore_targets[0].client_id;          //only one Xen client is present on a system
                    }
                    $scope.locationChange($scope.target.locationObj);
                }
                if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
                    $scope.SQLTarget.asset = $scope.locations[0].value;
                    $scope.SQLTarget.assetName = $scope.locations[0].name;
                    $scope.SQLTarget.targetId = $scope.locations[0].value;

                    $scope.recoveryTargetChange($scope.SQLTarget.asset);
                }
                if ($scope.hyperVTypeApplicationFlag) {
                    $scope.target.locationObj = defaultHyperVLocation;
                    $scope.locationName = selectedBackup.client_name;
                    $scope.hideStorage = true;
                    $scope.notXen = true;
                    $scope.storageRequired = false;
                }
                if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
                    $scope.ndmpRestoreTarget.asset = $scope.ndmpTargets[0].value;
                    $scope.ndmpRestoreTarget.assetName = $scope.ndmpTargets[0].name;

                    $scope.ndmpTargetChange($scope.ndmpRestoreTarget.asset);
                }
            });

        if (isIRJob) {
            $scope.title = "Create Instant Recovery Job";
            $scope.notIR = false;
            $scope.hideSwitch = app_type !== APPLICATION_TYPE_NAME_HYPER_V;

            var network_url = "/api/networks/";
            applianceNetworkFactory.getNetworkDetails('get', network_url, (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid)
                .then(function (data) {
                    var restore_networks = data.data.networks;
                    if (restore_networks && restore_networks != undefined && restore_networks.length > 0) {
                        angular.forEach(restore_networks, function (network, index) {
                            if (network.ip != "") {
                                var networkTempObj = {};
                                networkTempObj.value = network.ip;
                                networkTempObj.name = network.id + " - " + network.ip;
                                $scope.applianceNetworks.push(networkTempObj);
                            }
                        });
                        $scope.target.appliance_network = $scope.applianceNetworks[0].value;
                        $scope.networkName = $scope.applianceNetworks[0].name;
                    }
                });
            $scope.networkRequired = true;

            //Hide/Unhide the network switches
            if (app_type === APPLICATION_TYPE_NAME_HYPER_V) {
                $scope.hideSwitch = $scope.target.audit;
                if (!$scope.target.audit) {
                    $scope.switchRequired = true;
                } else {
                    $scope.switchRequired = false;
                }
            }
        } else {
            $scope.title = "Create Recover Job";
            $scope.notIR = true;
            $scope.hideSwitch = true;
            $scope.networkRequired = false;
        }

        $scope.locationChange = function (location) {
            if(location !== "" && typeof(location) !== "undefined" && location !== null){
                $scope.target.locationObj = location;
            } else {
                $scope.target.locationObj = null;
            }

            $scope.resourcePools = [];
            if ($scope.target.locationObj !== "" && typeof($scope.target.locationObj) !== "undefined" && $scope.target.locationObj != null) {
                $scope.resourcePools = [];
                $scope.resourcePoolName = "";
                for (var i = 0; i < $scope.targetsData.length; i++) {
                    if (typeof($scope.targetsData[i].groups) !== 'undefined') {
                        if ($scope.targetsData[i].id == location) {
                            $scope.target.resourcePoolObj = "";
                            angular.forEach($scope.targetsData[i].groups.VG, function (value, key) {
                                var obj = {
                                    name: value.Name,
                                    value: value.Key
                                };
                                $scope.resourcePools.push(obj);
                            });
                        }
                    }
                }
                $scope.dataStores = [];
                $scope.dataStoreName = "";
                $scope.storageRepos = [];
                $scope.storageName = "";
                if (typeof($scope.targetsData) != "undefined") {
                    for (var i = 0; i < $scope.targetsData.length; i++) {
                        if ($scope.targetsData[i].id == location) {
                            if (typeof($scope.targetsData[i].datastores) != "undefined") {
                                if (app_type === APPLICATION_TYPE_NAME_XEN) {
                                    $scope.target.storageObj = "";
                                    angular.forEach($scope.targetsData[i].datastores, function (value, key) {
                                        var obj = {
                                            name: value.name + ' (' + addFreeSize(value.free_size_gb) + ')',
                                            value: value.id
                                        };
                                        $scope.storageRepos.push(obj);
                                        var objWithoutSize = {
                                            name: value.name,
                                            value: value.id
                                        };
                                        $scope.storageReposWithoutSize.push(objWithoutSize);
                                    });
                                } else {
                                    $scope.target.dataStoreObj = "";
                                    for (var j = 0; j < $scope.targetsData[i].datastores.length; j++) {
                                        $scope.dataStoresWithoutSize.push($scope.targetsData[i].datastores[j].name);
                                        var dataStoresWithSize = $scope.targetsData[i].datastores[j].name + ' (' + addFreeSize($scope.targetsData[i].datastores[j].free_size_gb) + ')';
                                        $scope.dataStores.push(dataStoresWithSize);
                                    }
                                }
                            }
                            if (typeof ($scope.targetsData[i].capabilities) != "undefined") {
                                if (typeof ($scope.targetsData[i].capabilities.is_cluster) != "undefined") {
                                    $scope.isCluster = $scope.targetsData[i].capabilities.is_cluster;
                                }
                            }
                        }
                    }
                }
                // Target Storage is not required in case of Hyper-V cluster and when 'Original Location' is selected in case of Hyper-V restores
                if ((!isIRJob && app_type === APPLICATION_TYPE_NAME_HYPER_V && $scope.isCluster) ||
                    (app_type === APPLICATION_TYPE_NAME_HYPER_V && $scope.hyperVTypeApplicationFlag && $scope.target.locationObj == 0)) {
                    $scope.hideStorage = true;
                    $scope.storageRequired = false;
                    $scope.target.dataStoreObj = "";
                } else {
                    if (app_type === APPLICATION_TYPE_NAME_XEN) {
                        $scope.hideStorage = true;
                        $scope.notXen = false;
                    } else {
                        $scope.hideStorage = false;
                        $scope.notXen = true;
                    }
                    $scope.storageRequired = true;
                }
            }
            if (app_type !== APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
                if ($scope.hyperVTypeApplicationFlag && $scope.target.locationObj == 0) {
                    $scope.locationName = selectedBackup.client_name;
                } else {
                    $scope.locationName = $.grep($scope.locations, function (location) {
                        return location.value == $scope.target.locationObj;
                    })[0].name;
                }
            } else {
                $scope.targetNameForPhysicalServer = $.grep($scope.locations, function (location) {
                    return location.value == $scope.physicalTarget.asset;
                })[0].name;
            }

            // If Hyper-V IR, need to get network switches.
            if (isIRJob && app_type === APPLICATION_TYPE_NAME_HYPER_V) {
                $scope.networkSwitches = [];
                $scope.hypervisorId = $scope.locationName;
                var switch_url = "/api/networks/hypervisor-switch/";
                var networkSwitchDiv = $("#id_switch_control_group");
                var networkSwtichDivId = $("#id_switch");
                load = PHD.showLoadingIndicator(networkSwtichDivId);
                hypervisorSwitchFactory.getHypervisorSwitch('get', switch_url, $scope.hypervisorId, (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid)
                    .then(function (data) {
                        PHD.hideLoadingIndicator(load);
                        var restore_switches = data.data.names;
                        if (restore_switches) {
                            angular.forEach(restore_switches, function (name, index) {
                                $scope.networkSwitches.push(name);
                            })
                        }
                    });
            }
        };

        $scope.resourcePoolChange = function (resourcePool) {
            $scope.resourcePoolName = $.grep($scope.resourcePools, function (resourcePool) {
                return resourcePool.value == $scope.target.resourcePoolObj;
            })[0].name;
        };

        $scope.dataStoreChange = function (dataStore) {
            if ($scope.target.dataStoreObj != null) {
                for (var i = 0; i < $scope.dataStoresWithoutSize.length; i++) {
                    if ($scope.target.dataStoreObj.indexOf($scope.dataStoresWithoutSize[i]) == 0) {
                        $scope.dataStoreName = $scope.dataStoresWithoutSize[i];
                    }
                }
            }
        };

        $scope.storageRepoChange = function (storage) {
            $scope.storageName = $.grep($scope.storageReposWithoutSize, function (storage) {
                return storage.value == $scope.target.storageObj;
            })[0].name;
        };

        $scope.applianceNetworkChange = function (network) {
            $scope.networkName = $.grep($scope.applianceNetworks, function (network) {
                return network.value == $scope.target.appliance_network;
            })[0].name;
        };

        $scope.auditChange = function () {
            if (app_type === APPLICATION_TYPE_NAME_HYPER_V) {
                $scope.hideSwitch = $scope.target.audit;
            } else {
                $scope.hideSwitch = true;
            }
        };

        $scope.ndmpTargetChange = function (ndmp_target_client_id) {
            if (ndmp_target_client_id !== null) {
                $scope.ndmpRestoreTarget.assetName = $.grep($scope.ndmpTargets, function (asset) {
                    return asset.value === ndmp_target_client_id;
                })[0].name;
            } else {
                $scope.ndmpRestoreTarget.assetName = "";
            }
            //API call for step first "Recovery Options".
            var url = "/api/restore/targets/",
                load = PHD.showLoadingIndicator("body", true, "Loading Target Volumes...");
            recoverFactory.getRestoreTargets('get', url, ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid), selectedBackup.backup_id, selectedBackup.instance_id, selectedBackup.client_id, ndmp_target_client_id)
                .then(function (data) {
                    PHD.hideLoadingIndicator(load);
                    var restore_target_volumes = data.data.targets;
                    if (restore_target_volumes && restore_target_volumes.length > 0) {
                        $scope.ndmpTargetVolumes = [];
                        angular.forEach(restore_target_volumes, function (value, key) {
                            var volumeTempObj = {};
                            volumeTempObj.value = value.instance_id;
                            volumeTempObj.name = value.name;
                            $scope.ndmpTargetVolumes.push(volumeTempObj);
                        });
                        //$scope.ndmpRestoreTarget.asset = $scope.ndmpTargets[0].value;
                        //$scope.ndmpRestoreTargetVolume.instance_id = $scope.ndmpTargetVolumes[0].value;
                        //$scope.ndmpRestoreTarget.assetName = $scope.ndmpTargets[0].name;

                    }
                });
        };

        $scope.ndmpTargetVolumeChange = function () {
            if ($scope.ndmpRestoreTargetVolume.instance_id !== null) {
                $scope.ndmpRestoreTargetVolume.assetName = $.grep($scope.ndmpTargetVolumes, function (asset) {
                    return asset.value === $scope.ndmpRestoreTargetVolume.instance_id;
                })[0].name;
            } else {
                $scope.ndmpRestoreTargetVolume.assetName = "";
            }
        };

        /********************************** Recover summary grid**************************/
        var editSuffixesCellTempate = "";

        if (app_type === APPLICATION_TYPE_NAME_VMWARE || isIRJob || app_type === APPLICATION_TYPE_NAME_XEN) {
            editSuffixesCellTempate = '<div style="padding-top:5px;" ng-click="grid.appScope.openEditNameDialog(row.entity,row.getProperty(col.field), col.field)"><div style="font-size: 1em;padding-left:5px;text-overflow:ellipsis;float:left;">{{row.entity.vm_name}}</div><div style="float:right;padding-right:5px;" title="Edit VM Name"><img  src="assets/images/edit_pencil.png" style="height:14px;cursor:pointer;"/></div></div>';
        }
        var storageDisplayName = "";
        var assetDisplayName = "";
        var targetDisplayName = "";
        var instanceDisplayName = "";
        if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
            storageDisplayName = "TARGET DIRECTORY";
            assetDisplayName = "RECOVERY ASSET";
            targetDisplayName = "TARGET ASSET";
        } else if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
            storageDisplayName = "TARGET STORAGE";
            assetDisplayName = "RECOVERY ASSET";
            targetDisplayName = "TARGET ASSET";
        } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER){
            instanceDisplayName = "INSTANCE NAME";
            assetDisplayName = "DATABASE NAME";
            targetDisplayName = "TARGET HOST";
            storageDisplayName = "TARGET DIRECTORY";
        } else if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
            storageDisplayName = "TARGET DIRECTORY";
            assetDisplayName = "TARGET ASSET";
            targetDisplayName = "TARGET VOLUME";
        } else {
            storageDisplayName = "TARGET STORAGE";
            assetDisplayName = "VM NAME";
            targetDisplayName = "TARGET HOST";
        }

        $scope.recoverGridOptions = {
            enableColumnMenus:false,
            enableHorizontalScrollbar: 0,
            columnDefs: [
                { field: 'vm_name',displayName:assetDisplayName,resizable:true,cellTemplate:editSuffixesCellTempate},
                { field: 'target_host',displayName:targetDisplayName},
                { field: 'target_resource',displayName:"TARGET RESOURCE", visible:(app_type === APPLICATION_TYPE_NAME_VMWARE)? true:false },
                { field: 'instance_name', displayName:instanceDisplayName, visible:(app_type === APPLICATION_TYPE_NAME_SQL_SERVER) ? true : false},
                { field: 'target_storage',displayName:storageDisplayName},
                { field: 'appliance_network',displayName:"APPLIANCE NETWORK",visible:(isIRJob)? true:false },
                { field: 'network_switch',displayName:"NETWORK SWITCH",visible:(isIRJob && app_type === APPLICATION_TYPE_NAME_HYPER_V)? true:false }
            ]
        };

        /********************************** Function to edit recovered VM name *********************/
        $scope.openEditNameDialog = function(row, cell, col) {
            $scope.selectedRow = row;
            $scope.selectedColumn = col;
            $scope.VmName = row.vm_name;
            ngDialog.open({
                template: 'app/recover/editRecoveryName.html',
                scope: $scope,
                overlay: true,
                modelDialogId: 'recovery_name_dialogId',
                ngDialogStyle: 'width:42em; height:16em;'
            });
            $scope.recovery.name = $scope.VmName;
        };

        $scope.updateRecoveryName = function(){
            $scope.VmName = $scope.recovery.name;
            console.log($scope.VmName);
            $scope.getSummaryDetail($scope.VmName);
            ngDialog.close('recovery_name_dialogId');
        };

        /********************************** Function to edit suffixes*********************/
        /* Replaced by code to edit VM recovery name */
        /*$scope.openEditSuffixesdialog = function(row, cell, col) {
            $scope.selectedRow = row;
            $scope.selectedColumn = col;
            $scope.VmName = row.vm_name;
            ngDialog.open({
                template: 'app/recover/editSuffixes.html',
                scope: $scope,
                overlay: true,
                modelDialogId: 'recover_edit_suffix_dialogId',
                ngDialogStyle: 'width:42em; height:26em;'
            });
            $scope.suffix.name = "_restore";
        }; */

        /********************************** Function to update suffixes*********************/
        /*$scope.updateSuffixestToVMName = function(){ // Need to fix
            var suffix = $scope.suffix.name;
            var editAction =  $("#id_suffix_action option:selected").text();

            if(editAction == "Append") {
                $scope.getSummaryDetail($scope.VmName+suffix);
                ngDialog.close('recover_edit_suffix_dialogId');
            } else {
                var vmName = $scope.VmName;
                var updatedVmName = vmName.replace(suffix,"");
                console.log(updatedVmName);
                $scope.getSummaryDetail(updatedVmName);
                ngDialog.close('recover_edit_suffix_dialogId');
            }
        };*/

        /**********************************Wizard next steps.*********************/
        $scope.nextStepWizard = function($event) {
            if (wizardTitle == "Define Recovery Options") {//1st step
                $scope.hostRequired = true;
                $scope.storageRequired = true;

                if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
                    $scope.getSummaryDetail("");
                    $scope.showSummaryHeader = false;
                    $rootScope.$broadcast("nextBtnClick");
                } else {
                    if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                        if (checkValidationForExchangeRecoverOptions()) {
                            $scope.showSummaryHeader = false;
                            $scope.getSummaryDetail("");
                            $rootScope.$broadcast("nextBtnClick");
                        }
                    } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
                        if (checkValidationForSqlRecoverOptions($scope.SQLselectedaltlocationFlag)) {
                            $scope.showSummaryHeader = false;
                            $scope.getSummaryDetail("");
                            $rootScope.$broadcast("nextBtnClick");
                        }
                    } else if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
                        if (checkValidationForNdmpRecoverOptions()) {
                            $scope.showSummaryHeader = false;
                            $scope.getSummaryDetail("");
                            $rootScope.$broadcast("nextBtnClick");
                        }
                    } else {
                        if (checkValidationForRecoverOptions($scope.hostRequired, $scope.resourcePoolRequired, $scope.storageRequired, $scope.networkRequired, $scope.switchRequired)) {
                            $scope.showSummaryHeader = false;
                            $scope.getSummaryDetail("");
                            $rootScope.$broadcast("nextBtnClick");
                        }
                    }
                }
            }
            if (wizardTitle == "Summary") { //2nd step
                $scope.showSummaryHeader = true;
                $scope.postRecoverData(); //call to the POST API
            }
        };

        $scope.clickPreviousStep = function(){
            $scope.showSummaryHeader = true;
        };


        /********************************** Function to get summary detail*********************/
        $scope.getSummaryDetail = function(vmNameParam){
            var network = "";
            var vmName = "";
            var switchName = "";
            var hostName = "";
            var storageName = "";
            var instanceName = "";
            if (vmNameParam != "" && vmNameParam != undefined) {
                vmName = vmNameParam;
            } else if ((app_type == APPLICATION_TYPE_NAME_HYPER_V && !isIRJob) || app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER ||
                app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                vmName = selectedBackup.vm_name;
            } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER){
                vmName = $scope.SQLTarget.database;
                storageName = $scope.SQLTarget.directory;
                $scope.sqlMasterDBFlag = selectedBackup.datbase_name === "master";
            } else {
                vmName = selectedBackup.vm_name+ '_restore'; //VM name should have '_restore' appended in case of vmware.
            }
            if (isIRJob) {
                network = $scope.networkName;
            }
            if (isIRJob && app_type === APPLICATION_TYPE_NAME_HYPER_V && !$scope.hideSwitch) {
                switchName = $scope.target.network_switch;
            }
            if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
                hostName = $scope.targetNameForPhysicalServer;
                storageName = $scope.physicalServerRecoveryOption.target.directory;
            } else if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                hostName = $scope.exchangeAssetName;
                if ($scope.exchangeTarget.recoveryOption == 1) {
                    storageName = selectedBackup.vm_name;
                }
                if ($scope.exchangeTarget.recoveryOption == 2 && $scope.exchangeTarget.recoveryArea) {
                    storageName = $scope.exchangeTarget.recoveryArea;
                }
                if ($scope.exchangeTarget.recoveryTarget == 2) {
                    storageName = $scope.exchangeOption.target.directory;
                }
            } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER){
                hostName = $scope.SQLTarget.assetName;
                instanceName = $scope.SQLTarget.instance.name;
                storageName = $scope.SQLTarget.directory;
            } else if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE){
                vmName = $scope.ndmpRestoreTarget.assetName;
                hostName = $scope.ndmpRestoreTargetVolume.assetName;
                storageName = $scope.ndmpRestoreTarget.directory;
            } else {
                hostName = $scope.locationName;
                if (app_type === APPLICATION_TYPE_NAME_XEN) {
                    storageName = $scope.storageName;
                } else {
                    storageName = $scope.dataStoreName;
                }
            }
            $scope.recoverGridOptions.data = [
                {
                    "vm_name": vmName,
                    "target_host": hostName,
                    "target_resource": $scope.resourcePoolName,
                    "target_storage": storageName,
                    "appliance_network": network,
                    "network_switch":switchName,
                    "instance_name":instanceName
                }
            ];
            console.log($scope.recoverGridOptions.data);
        };

        /************************ Function to post the recover data to backend **********/
        $scope.postRecoverData = function() {

            $scope.restoreObj = {};
            $scope.restoreObj.target = {};

            if (app_type === APPLICATION_TYPE_NAME_VMWARE || app_type === APPLICATION_TYPE_NAME_HYPER_V || app_type === APPLICATION_TYPE_NAME_XEN) {
                $scope.restoreObj  = $scope.collectRecoverData();
            } else if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER){
                $scope.restoreObj  = $scope.collectRecoverDataForPhysicalServer();
            } else if (app_type === APPLICATION_TYPE_NAME_SHAREPOINT || app_type === APPLICATION_TYPE_NAME_ORACLE) {
                $scope.restoreObj = $scope.collectRecoverDataForOracleSharePoint();
            } else if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                $scope.restoreObj = $scope.collectRecoverDataForExchange();
            } else if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
                $scope.restoreObj = $scope.collectRecoverDataForSQL();
            } else if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
                $scope.restoreObj = $scope.collectRecoverDataForNDMP();
            }

            console.log('=== Submit form: object = ' + JSON.stringify($scope.restoreObj));
            var url = (isIRJob ? "/api/restore/instant/" : "/api/restore/full/");
            var params = {};
            params.sid = (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid;
            var load = PHD.showLoadingIndicator("body", true, "Starting Recovery...");

            $http ({
                method: 'post',
                url : url,
                data: JSON.stringify($scope.restoreObj),
                params: params
            }).success(function(data){
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'Information',
                    scope:$scope,
                    dialogMessage:(!isIRJob)?"Restore has started successfully" : "Instant Recovery has started successfully"
                });
                //ngDialog.close('recover-dialog');

            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        };

        /****************** Function to collect restore data of VMware and Hyper-V AND XEN**************/
        $scope.collectRecoverData = function(){
            if (app_type === APPLICATION_TYPE_NAME_HYPER_V) {
                if (isIRJob) {
                    $scope.restoreObj.target.host = $scope.locationName;
                } else {
                    if ($scope.hyperVTypeApplicationFlag && $scope.target.locationObj == 0) {
                        $scope.restoreObj.client_id = parseInt(selectedBackup.client_id, 10);
                    } else {
                        $scope.restoreObj.client_id = parseInt($scope.target.locationObj, 10);
                    }
                }
            } else {
                $scope.restoreObj.target.host = $scope.target.locationObj;
            }

            $scope.restoreObj.target.name = $scope.recoverGridOptions.data[0].vm_name;
            console.log("VM name " + $scope.restoreObj.target.name);

            //if 'original location' is selected in Hyper-V restores, do not set 'directory'
            if (app_type === APPLICATION_TYPE_NAME_HYPER_V && $scope.hyperVTypeApplicationFlag && $scope.target.locationObj == 0) {

            } else {
                if (app_type === APPLICATION_TYPE_NAME_HYPER_V) {
                    $scope.restoreObj.target.directory = $scope.dataStoreName;
                } else if (app_type === APPLICATION_TYPE_NAME_XEN) {
                    $scope.restoreObj.target.storage_repository = $scope.target.storageObj;
                    $scope.restoreObj.target.metadata = true;
                } else {
                    $scope.restoreObj.target.datastore = $scope.dataStoreName;
                    $scope.restoreObj.target.group = $scope.target.resourcePoolObj;
                    $scope.restoreObj.target.metadata = true;
                    console.log("RP name " + $scope.restoreObj.target.group);
                    if (!isIRJob) {
                        $scope.restoreObj.target.metadata = true;
                        $scope.restoreObj.target.template = selectedBackup.vmware_template;
                    }
                }
            }

            $scope.restoreObj.backup_id = parseInt(selectedBackup.backup_id, 10);
            if(app_type === APPLICATION_TYPE_NAME_XEN){
                $scope.restoreObj.client_id = $scope.XenClientId;
            }
            if (isIRJob) {
                // start in audit mode.
                $scope.restoreObj.audit = $scope.target.audit;
                if (!$scope.restoreObj.audit && (app_type === APPLICATION_TYPE_NAME_HYPER_V)) {
                    $scope.restoreObj.target.switch = $scope.target.network_switch;
                }
                $scope.restoreObj.address = $scope.target.appliance_network;
            }
            return $scope.restoreObj;
        };

        /*************************** Function to collect physical server data****************************/
        $scope.collectRecoverDataForPhysicalServer = function() {
            $scope.physicalServerRecoveryOption.backup_id = parseInt(selectedBackup.backup_id, 10);
            $scope.physicalServerRecoveryOption.client_id = $scope.physicalTarget.asset;
            $scope.physicalServerRecoveryOption.synthesis = selectedBackup.synth_capable;

            $scope.physicalServerRecoveryOption.target.flat = !$scope.physicalTarget.preserve_dir;

            $scope.physicalServerRecoveryOption.excludes = "";
            $scope.physicalServerRecoveryOption.includes = "";

            console.log($scope.physicalServerRecoveryOption);
            return $scope.physicalServerRecoveryOption;
        };

        /*************************** Function to collect Oracle and SharePoint data***********************/
        $scope.collectRecoverDataForOracleSharePoint = function() {
            $scope.oracleSharePointObj.backup_id = parseInt(selectedBackup.backup_id, 10);

            return $scope.oracleSharePointObj;
        };

        /***************************** Function to collect Exchange data*****************/
        $scope.collectRecoverDataForExchange = function() {
            $scope.exchangeRecoveryOption.backup_id = parseInt(selectedBackup.backup_id, 10);
            var client_id = selectedBackup.client_id;
            var database = "";
            if ($scope.exchangeTarget.recoveryOption == 1) {
                database = selectedBackup.vm_name;
            } else if ($scope.exchangeTarget.recoveryOption == 2 && $scope.exchangeTarget.recoveryArea) {
                database = $scope.exchangeTarget.recoveryArea;
            }
            if ($scope.exchangeTarget.recoveryTarget === 1) {
                client_id = $scope.exchangeTarget.asset;
                if (database !== "") {
                    $scope.exchangeRecoveryOption.target.database = database;
                }
            } else {
                client_id = $scope.exchangeTarget.altAsset;
                $scope.exchangeRecoveryOption.target = $scope.exchangeOption.target;
            }
            $scope.exchangeRecoveryOption.client_id = client_id;
            return $scope.exchangeRecoveryOption;
        };


        /*************************** Function to collect SQL data***********************/
        $scope.collectRecoverDataForSQL = function() {
            $scope.SQLRecoveryObj.backup_id = (selectedBackup.backup_id);
            $scope.SQLRecoveryObj.target.instance =  $scope.SQLTarget.instance.name;
            $scope.SQLRecoveryObj.target.database =  $scope.SQLTarget.database;
            $scope.SQLRecoveryObj.client_id = $scope.SQLTarget.asset;
            $scope.SQLRecoveryObj.target.directory = $scope.SQLTarget.directory;

            if($scope.SQLTarget.pit) {
                $scope.SQLRecoveryObj.target.point_in_time = Math.round((parseInt($scope.slecetdPit)/1000));
            }

            console.log("sab:  SQL obj for POST: " + $scope.SQLRecoveryObj);

            return $scope.SQLRecoveryObj;
        };


        /*************************** Function to collect NDMP data***********************/
        $scope.collectRecoverDataForNDMP = function() {
            $scope.ndmpRecoveryObj.client_id = $scope.ndmpRestoreTarget.asset;
            $scope.ndmpRecoveryObj.target.volume = $scope.ndmpRestoreTargetVolume.assetName;
            $scope.ndmpRecoveryObj.target.directory = $scope.ndmpRestoreTarget.directory;
            $scope.ndmpRecoveryObj.backup_id = (selectedBackup.backup_id);

            console.log("sab:  NDMP obj for POST: " + $scope.ndmpRecoveryObj);

            return $scope.ndmpRecoveryObj;
        };

        /************ Popover function for IR wizard*************/
        $scope.showPopoverForIR = function(){
            var form1 = angular.element("#recovery-job-form");
            console.log(form1);
            form1.find(".definition").popover({
                appendTo: form1
            });
        };

        /************* Get Recovery Options based on app_type *******/
        $scope.getRecoveryOptions = function() {
            var include = '';
            if (app_type === APPLICATION_TYPE_NAME_HYPER_V || app_type === APPLICATION_TYPE_NAME_VMWARE || app_type === APPLICATION_TYPE_NAME_XEN) {
                include = 'app/recover/recoveryOptions.html';
            }
            if (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER) {
                include = 'app/recover/recoveryOptions/physicalServerOptions.html';
            }
            if (app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE) {
                include = 'app/recover/recoveryOptions/ndmpOptions.html';
                var ndmp_form = angular.element("#ndmp-recovery-job-form");
                ndmp_form.find(".definition").popover({
                    appendTo: ndmp_form
                });
            }
            if (app_type === APPLICATION_TYPE_NAME_EXCHANGE) {
                include = 'app/recover/recoveryOptions/exchangeOptions.html';
                $scope.exchangeRecoveryDatabaseName = selectedBackup.vm_name;
                var exchange_form = angular.element("#exchange-recovery-job-form");
                exchange_form.find(".definition").popover({
                    appendTo: exchange_form
                });
            }
            if (app_type === APPLICATION_TYPE_NAME_SQL_SERVER) {
                include = 'app/recover/recoveryOptions/sqlOptions.html';
                var form1 = angular.element("#sql-recovery-job-form");
                //console.log(form1);
                form1.find(".definition").popover({
                    appendTo: form1
                });
            }
            return include;
        };

        /*************** Get recovery Steps **********************/
        $scope.getRecoverySteps = function() {
            var recoverySteps = '';
            if (app_type === APPLICATION_TYPE_NAME_ORACLE || app_type === APPLICATION_TYPE_NAME_SHAREPOINT) {
                recoverySteps = 'app/recover/oracleSharePointRecovery.html';
            } else {
                recoverySteps = 'app/recover/recoverySteps.html';
            }
            return recoverySteps;
        };

        /*************** For add exclude patern**************************/
        $scope.addExcludePatternRow = function() {
            console.log($scope.physicalTarget.exclusion);
            var table = document.getElementById("exclusionTable");
            var excludePattern = $scope.physicalTarget.exclusion;

            if(excludePattern == ""){
                return;
            }
            var rowCount = table.rows.length;
            var row = table.insertRow(rowCount);
            var cell1 = row.insertCell(0);
            cell1.innerHTML= excludePattern;

            var cell2 = row.insertCell(1);
            cell2.innerHTML =  '<span class="btn-remove-recipient"><a ng-show=false><i title="Remove" class="icon-removesign"></i></a></span>';
            $scope.physicalTarget.exclusion="";
        };

        /********************For remove exclude patern**************************/
        $scope.deleteRow = function(r) {
            console.log(r);
            var i = r.parentNode.parentNode.parentNode.rowIndex;
            document.getElementById("exclusionTable").deleteRow(i);
        };

        /********************* For SharePoint and Oracle submit****************/
        $scope.doRestore = function() {
            $scope.postRecoverData();
        };

        // converting the free size to a string of the form 'xxx.x GB' or 'xxx.x TB'
        function addFreeSize(sizeInGb) {
            var textSize = '';
            if (sizeInGb > 1000) {
                textSize = (sizeInGb / 1024).toFixed(1) + ' TB free';
            } else {
                textSize = sizeInGb + ' GB free';
            }
            return textSize;
        }

        $scope.openSQLFileBrowserDialog = function(){
            $scope.selectedBackup = selectedBackup;
            var dataObj={};
            var sid = (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid;
            console.log("Target Id >>> "+$scope.SQLTarget.targetId);
            dataObj = {
                singleFileBrowserTreeNodeUrl:"/api/clients/files/" + $scope.SQLTarget.targetId + "/?sid=" + sid + "&dir=",
                url:"/api/clients/files/" + $scope.SQLTarget.targetId + "/?sid=" + sid + ""
            };

            $scope.openSingleFileBrowserDialog(dataObj);
        };

        $scope.openSingleFileBrowserDialog = function(dataObject){
            $rootScope.singleFileBrowserTreeNodeUrl = dataObject.singleFileBrowserTreeNodeUrl;
            var load = PHD.showLoadingIndicator("body", true, "Loading...");
            $http({
                method: 'get',
                url : dataObject.url
            }).success(function(data, status, headers){
                var jsonData = data.data;
                var treeObj = {};
                var treeArray = [];
                var childDummayDataArray = [];
                var finalTreeDataArray = [];

                for(var i=0;i<jsonData.length;i++){
                    var index = jsonData[i].name.indexOf("/");
                    var nodeName = jsonData[i].name;
                    var nodeId = jsonData[i].id;
                    if(index != undefined && index !=null && index == -1){
                        nodeName = jsonData[i].name+"/";
                        nodeId = jsonData[i].id+"/";
                    }

                    treeObj = {id:nodeId,parent:"#",text:nodeName,icon:(jsonData[i].isBranch == true)? "icon-hv-folder icon" : "icon-file icon",state: { opened: false},data:{expanded:false}};
                    treeArray.push(treeObj);

                    var id = nodeId+"dummy";
                    if(jsonData[i].isBranch == true){
                        treeObj={id:id,parent:nodeId,text:"dummy",state: { opened: false}};
                        childDummayDataArray.push(treeObj);
                    }
                }


                finalTreeDataArray = treeArray.concat(childDummayDataArray);
                $rootScope.originalData = finalTreeDataArray;

                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    template: 'app/recover/recoveryOptions/single-file-browser.html',
                    scope: $rootScope,
                    overlay:true,
                    modelDialogId:'single-file-browser-setting-dailog',
                    ngDialogStyle:'width:800px;height:600px;',
                    preCloseCallback: function (value) {}
                });
            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'Retry',
                    dialogMessage:response.result[0].message
                });
            });
        }
    }

]);